﻿/*
	this file is part of OOF
	OOF : Open Source Open Minded Flash Components

	OOF is (c) 2008 Alexandre Hoyau and Ariel Sommeria-Klein. It is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.oof.dataConnectors.RssConnector;
import mx.utils.Delegate;

/** Communicate with the OOF/Silex Excel scripts. Works only for reading at the moment 
 *
 * @author Ariel Sommeria-klein
 * @author lex@silex.tv
 **/
class org.oof.dataConnectors.ExcelConnector extends RssConnector{

	private var _excelFilePath:String = null;
	private var _combineItemsFrom:String = null;
	
	function ExcelConnector(){
		super();
		_className = "org.oof.dataConnectors.ExcelConnector";
	}
		
	/** function getRecords. select data from a datasource
	*@return void
	*/
	function getRecords(successCallback:Function, errorCallback:Function, formName:String, selectedFieldNames:Array, whereClause:String, orderBy:String, count:Number, offset:Number){
		_getRecordsSuccessCallback = successCallback;
		_getRecordsErrorCallback = errorCallback;
		_whereClause = whereClause;
		_orderBy = orderBy;
		_count = count;
		_offset = offset;
		_feed = new XML();
		_feed.ignoreWhite = true;
		_feed.onLoad = Delegate.create(this, onLoadXml);
		
		var url:String = _urlBase + "?file_name=" + _excelFilePath + "&get_values=" + selectedFieldNames + "&combine_items_from=" + _combineItemsFrom;
		// reveal accessors in the url and form name
		var finalUrl:String = silexPtr.utils.revealAccessors(url, this);
		if (!finalUrl){
			finalUrl = _urlBase + formName;
		}
		tyu("calling" , finalUrl);
		
		// load the feed
		_feed.load(finalUrl);
		tyu(arguments);
	}
	
	/** function updateRecord
	*@return void
	*/
	function updateRecord(successCallback:Function, errorCallback:Function, formName:String, item:Object, idRecord:Number){
		throw new Error(this + " updateRecord not implemented");
	}
	
	/** function createRecord
	*@return void
	*/
	function createRecord(successCallback:Function, errorCallback:Function, formName:String, item:Object){
		throw new Error(this + " createRecord not implemented");
	}

	/** function deleteRecord
	*@return void
	*/
	function deleteRecord(successCallback:Function, errorCallback:Function, formName:String, idRecord:Number){
		throw new Error(this + " deleteRecord not implemented");
	}	

	/** property: excelFilePath
	 * 
	 * */	
	[Inspectable(name="excelFilePath", type=String, defaultValue="test.xlsx")]
	public function set excelFilePath(val:String){
		tyu("set excelFilePath", val);
		_excelFilePath = val;
	}

	
	public function get excelFilePath():String{
		tyu("get excelFilePath", _excelFilePath);
		return _excelFilePath;
	}		

	/** property: combineItemsFrom
	 * 
	 * */	
	[Inspectable(name="combine items from", type=String, defaultValue="rows")]
	public function set combineItemsFrom(val:String){
		tyu("set combineItemsFrom", val);
		_combineItemsFrom = val;
	}

	
	public function get combineItemsFrom():String{
		tyu("get combineItemsFrom", _combineItemsFrom);
		return _combineItemsFrom;
	}		

}