﻿/*
	this file is part of OOF
	OOF : Open Source Open Minded Flash Components

	OOF is (c) 2008 Alexandre Hoyau and Ariel Sommeria-Klein. It is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/

import mx.managers.DepthManager;
import mx.utils.Delegate;
import org.oof.lists.CustomList;
/** This list is for displaying a list of images, such as thumbnails for a gallery.
 * If you want to use one of the oof lists in flash, make sure that you have the right 
 * cell renderer (see cellRenderer parameter) and List Row in your library. In silex this
 * is done for you.
 * 
 * @author Ariel Sommeria-klein
 * */
class org.oof.lists.ThumbList extends CustomList{

	private var _resizeImages:Boolean = false;
	private var _urlPrefix:String = null;
	
	var _urlPrefixWithAccessors:String = null;
	
	function ThumbList(){
		super();
		if(_cellRenderer == ""){
			_cellRenderer = "ThumbCellRenderer";	
		}
//		tyu("_cellRenderer " + _cellRenderer);
	}

	/** function set urlPrefix
	* @param val(String)
	* @returns void
	*/
	[Inspectable(name="url base", type=String, defaultValue="")]
	public function set urlPrefix(val:String){
		_urlPrefix = val;
		_urlPrefixWithAccessors = silexPtr.utils.revealAccessors (_urlPrefix, this);
	}
	
	/** function get urlPrefix
	* @returns String
	*/
	
	public function get urlPrefix():String{
		return _urlPrefix;
	}		
	
	/** function set resizeImages
	* @param val(Boolean)
	* @returns void
	*/
	[Inspectable(type = Boolean, defaultValue = false)]
	public function set resizeImages(val:Boolean){;
		_resizeImages = val;
		redraw();
	}
	/** function get resizeImages
	* @returns Boolean
	*/
	
	
	public function get resizeImages():Boolean {
		return _resizeImages;
	}
	
}