﻿/*
	this file is part of OOF
	OOF : Open Source Open Minded Flash Components

	OOF is (c) 2008 Alexandre Hoyau and Ariel Sommeria-Klein. It is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/

import mx.utils.Delegate;
import org.oof.OofBase; 
import org.oof.lists.cellRenderers.CellRendererBase; 
/** companion cell renderer for the thumb list.
 * @author Ariel Sommeria-klein
 * */
class org.oof.lists.cellRenderers.ThumbCellRenderer extends CellRendererBase{
	
	private var _loadedIcon:String = null;
	private var _mcLoader:MovieClipLoader = null;
	// UI
	var container:MovieClip;

	function ThumbCellRenderer(){
		super();
		_mcLoader = new MovieClipLoader();
		_mcLoader.addListener(this);
		//container.useHandCursor = false;
		container._xscale = 100;
		container._yscale = 100;
//		container.useHandCursor = listOwner._useHandCursor;
	}

	function setValue(str:String, item:Object, sel:Boolean) : Void{
		super.setValue(str, item, sel, icon);
			//if this isn't checked , image is reloaded on every click. 
		if(icon != _loadedIcon){ 
			//_mcLoader.unloadClip(container);
			// display icon
			var url:String = listOwner._urlPrefixWithAccessors + icon;
			if(url == undefined){
				trace("invalid url : " + url + ", listOwner._urlPrefixWithAccessors : " + listOwner._urlPrefixWithAccessors + ", icon : " + icon); 
			}
			trace("ThumbCellRenderer, loading from : " + url + ", to clip : " + container);
			var ret = _mcLoader.loadClip(url, container);
			if(!ret){
				throw new Error(this + " problem loading image from url : " + icon);
			}
			_loadedIcon = icon;
/*			_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer ret : " + ret);
			_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer container : " + container);
			_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer listOwner._urlPrefixWithAccessors + icon : " + listOwner._urlPrefixWithAccessors + icon);
			_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer _mcLoader : " + _mcLoader);
*/			
		}
		
/*		_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer _cellMarginY : " + _cellMarginY);
		_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer _cellMarginX : " + _cellMarginX);
		//trace("icon : " + icon);
		//trace("_loadedIcon : " + _loadedIcon);
		*/
		if(listOwner.useVariableRowHeight){
			if(!listOwner.isHorizontal){
				var newVal = listOwner.thumbHeight + _cellMarginY * 2;
				setSize(width, newVal);		
			}else{
				var newVal = listOwner.thumbWidth + _cellMarginX * 2;
				setSize(newVal, height);		
			}
		}
	}

	///////////////////////////////////////
	//listeners for the mcloader
	///////////////////////////////////////
	function onLoadProgress(target:MovieClip, bytesLoaded:Number, bytesTotal:Number):Void {
//		trace(target + ".onLoadProgress with " + bytesLoaded + " bytes of " + bytesTotal);
	}
	function onLoadComplete(target_mc:MovieClip, httpStatus:Number):Void {
//		trace(">> onLoadComplete()");
//		trace(">> =============================");
//		trace(">> target_mc._width: " + target_mc._width); // 0
//		trace(">> httpStatus: " + httpStatus);
	}

	
	function onLoadInit(target_mc:MovieClip) {
//		trace("onLoadInit : " + target_mc);
		if(listOwner.resizeImages){
			container._width = width - _cellMarginX * 2;
			container._height = height - _cellMarginY * 2;
		}
	}	
	
	function onLoadError(target_mc:MovieClip, errorCode:String, httpStatus:Number) {
		_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer "+target_mc + ">> onLoadError(), from url " + listOwner._urlPrefixWithAccessors + icon);
		_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer >> ==========================");
		_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer >> errorCode: " + errorCode);
		_global.getSilex().utils.trace("org.oof.lists.cellRenderers.ThumbCellRenderer >> httpStatus: " + httpStatus);
	}
	
	
	function redraw()
	{
		super.redraw();
		container._x = listOwner.cellMarginX;
		container._y = listOwner.cellMarginY;
	}
}