﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
//import mx.remoting.*;
//import mx.rpc.*;
import org.silex.core.Utils;
import mx.events.EventDispatcher;
import org.silex.core.plugin.HookManager;
import org.silex.core.LayoutHooks;

/* listen to org.silex.core.Layer allPlayersLoaded
*/
//////////////////////////////
// Group: events
/////////////////////////////
[Event("XMLLoaded")]
[Event("showContent")]
[Event("hideContent")]
[Event("showChild")] // dispatch from application::openSection - sectionName layoutFileName target(Layout)
[Event("hideChild")]

[Event("onDeeplink")] // thrown by org.silex.core.Deeplink: parentLayout_ptr.dispatchEvent({type:"onDeeplink",target:parentLayout_ptr,deeplinkName:sectionName});
//layoutLoaded :?:
//allAnimsEnded :?:

/**
 * This class represents a layout which is an object called silexLayout created at run time at the root of each layout.
 * Handle the loading process of the xml data.
 * In the repository : /trunk/core/Layout.as
 * @author	Alexandre Hoyau
 * @version	1
 * @date	2007-10-26
 * @mail : lex@silex.tv
 */
class org.silex.core.Layout extends mx.core.UIObject{
	/**
	 * reference to silex main Api object (org.silex.core.Api)
	 */
	private var silex_ptr:org.silex.core.Api;

	//////////////////////////////
	// Group: layers
	/////////////////////////////
	var layers:Array;
	var layerContainers:Array;
	var defaultIcon/*:org.silex.ui.players.UiBase*/;
	
	/*
	refresh()
	*/
	//////////////////////////////
	// Group: layouts
	/////////////////////////////
	var layoutFileName:String;
	var anims:Array;
	// container for the child layout
	var layoutContainer:MovieClip;
	// reference to the last opened child layout (a dynamically created movie clip contained in layoutContainer)
	var currentChildLayoutContainer:MovieClip;
	var currentChildLayoutContainerIndex:Number=0; // used to create container names
	
	/**
	 * Name of the page deep link.
	 * Used by silex.deeplinkManager::getCurrentPath.
	 * @see	org.silex.core.DeeplinkManager::getCurrentPath
	 */
	var deeplinkName:String;
	
	/**
	 * is content visible? set bay startAnimShow
	*/
	var isContentVisible:Boolean=false;
	//////////////////////////////
	// Group: seo
	/////////////////////////////
	// keywords
	// description
	// isAutomaticSeoActive

	/**
	 * set by propeties tool box when a property has been changed
	 */
	var isDirty:Boolean=false;
	
	/*
	selectedIcon:MovieClip
	*/
	//////////////////////////////
	// Group: xml data
	/////////////////////////////
	var _xml:XML;
	// xml file/section name
	var xmlFileName:String;
	var sectionName:String;
	var cleanSectionName:String; // wiki style section names: no accent, space, ... 
	var xmlLoaded_bool:Boolean=false;
	var initDone_bool:Boolean=false;
	//////////////////////////////
	// Group: dom
	/////////////////////////////
	var dom:Object;
	var domOutOfContext:Object;
	/**
	 * Store the dynamic data.
	 * Used by DynDataManager class.
	 */
	var registeredVariables:Array;
	
	/*
	 * client data from db used by components and players
	 */
	var dbdata_obj:Object;

	/*
	 * Constructor.
	 * Called by org.silex.core.Application before layout first frame.
	 * Start the loading process of data.
	 */
	function Layout(api:org.silex.core.Api, parent:MovieClip, sectionName_str:String,layoutFileName_str:String,deeplinkName_str:String)
	{
		
		// hide before init
		parent._visible=false;
		
		// **
		// store Api reference
		//
		silex_ptr=api;
		silex_ptr.utils.trace("org.silex.core.Layout constructor "+deeplinkName);
		
		// store reference to swf layout
		_parent=parent;
		
		//eventDispatcher
		EventDispatcher.initialize(this);
		
		// **
		// layout
		//
		layoutFileName=layoutFileName_str;
		anims=new Array;

		// **
		// layers
		//
		layers=new Array;
		layerContainers=new Array;

		// **
		// xml file/section name
		//
		// store the section name
		sectionName=sectionName_str;

		// remove unwanted chars from file name
		cleanSectionName=silex_ptr.utils.cleanID(sectionName_str);
		
		// build default deeplink
		if (deeplinkName_str) 
			deeplinkName=deeplinkName_str;
		else
			deeplinkName=cleanSectionName;
		
/*		if (silex_ptr.config.USE_AMF_FILES.toLowerCase()=="true")
		{
			// **
			// AMF
			amfConnect();
//			silex_ptr.sequencer.doInNFrames(1, Utils.createDelegate(this,amfConnect));
		}
		else
		{
			// **
			// XML
			xmlConnect();
		}
*/	}
	function xmlConnect()
	{
		// build the file name
		xmlFileName=silex_ptr.config.id_site+"/"+cleanSectionName+".xml";

		// XML object
		_xml=new XML;
		_xml.contentType = "text/xml";
		_xml.ignoreWhite=true;
		_xml.onLoad=Utils.createDelegate(this,xmlLoaded);

		// load xml data
		var xmlFileUrl_str:String = silex_ptr.config.initialContentFolderPath+xmlFileName;
		if (silex_ptr.config.ALLOW_CACHE_CONTROL.toLowerCase()!="false")
		{
			// allow cache control
			xmlFileUrl_str += "?rand="+Math.round(1000*Math.random());
		}
			
		//silex_ptr.sequencer.doInNFrames(10, function(){_xml.load(silex_ptr.rootUrl+xmlFileUrl_str);});
		_xml.load(silex_ptr.rootUrl+xmlFileUrl_str);
	}
	function amfConnect()
	{
		silex_ptr.utils.trace("org.silex.core.Com amfConnect - " );
		// build the file name
		xmlFileName=silex_ptr.config.id_site+"/"+cleanSectionName+silex_ptr.config.AMF_FILE_EXTENSION;
		// load AMF file
		var responder_obj:Object=new Object;
		responder_obj.silex_ptr = silex_ptr;
		// responder_obj.onResult = Utils.createDelegate(this,amfLoaded);
		// success
		responder_obj.onStatus = Utils.createDelegate(this,amfLoaded);
		// TO DO : 
		responder_obj.onError=function( fault)
		{
			// display error message
			this.silex_ptr.utils.trace("org.silex.core.Com handleRemotingError - " + fault.fault.faultstring);
			this.silex_ptr.utils.alert(this.silex_ptr.utils.revealAccessors(this.silex_ptr.config.ERROR_WEBSERVICE_ERROR,{fault:fault}));
		}
		responder_obj.silex_ptr=silex_ptr;
			
		var xmlFileUrl_str:String = silex_ptr.utils.getRootUrl()+silex_ptr.config.initialContentFolderPath+xmlFileName;
//		var xmlFileUrl_str:String = silex_ptr.utils.getRootUrl()+silex_ptr.config.gatewayRelativePath; 
		if (silex_ptr.config.ALLOW_CACHE_CONTROL.toLowerCase()!="false")
		{
			// allow cache control 
			xmlFileUrl_str += "?rand="+Math.round(1000*Math.random());
		}
		var connection:NetConnection = new NetConnection();
		// error
		connection.onStatus = Utils.createDelegate(this,amfLoaded);
		connection.connect(xmlFileUrl_str);
		connection.call( "", responder_obj );
		silex_ptr.utils.trace("org.silex.core.Layout constructor amf "+xmlFileUrl_str);
		// silex_ptr.utils.alertSimple("amfConnect");
	}
	/**
	 * Called by _xml when xml data is loaded.
	 * Create the dom object corresponding to the xml data.
	 * Load layers objects in the registered layerContainers.
	 * Push the show anim in the sequencer.
	 * @param target_mc	movie clip in which the section (the layout) is loaded
	 */
/**/
	function xmlLoaded(success:Boolean) {
		// call hooks
        var hookManager:HookManager = HookManager.getInstance();
		hookManager.callHooks(LayoutHooks.XML_LOADED_START_HOOK_UID, arguments);
		
		silex_ptr.utils.trace("org.silex.core.Layout xmlLoaded "+success+" - loading of "+sectionName+" ("+silex_ptr.config.initialContentFolderPath+xmlFileName+")");
		if (success){
	 		// create the dom object corresponding to the xml data
			//silex_ptr.utils.trace("org.silex.core.Layout xmlLoaded "+_xml);
			dom=silex_ptr.xmlDom.xmlToObj(_xml);
		}
		else{
			silex_ptr.utils.trace("org.silex.core.Layout xmlLoaded error loading section "+sectionName+". If this section does not exist yet, it will be automatically created.");
			// silex_ptr.utils.alertSimple(silex_ptr.utils.revealAccessors(silex_ptr.config.MESSAGE_SECTION_DOES_NOT_EXIST,this));
	 		// create an empty dom object
			dom=new Object;
		}
		
		// xml loading process has ended
		xmlLoaded_bool=true;

		// load layers objects in the registered layerContainers
		silex_ptr.utils.trace("org.silex.core.Layout xmlLoaded - about to load "+layerContainers.length+" layers");
		for (var idx:Number=0;idx<layerContainers.length;idx++){
			// load the layer object in that layer
			loadRegisteredLayer(layerContainers[idx]);
		}
		
		// if init has been called allready
		if (initDone_bool==true){
			// push the show anim in the sequencer
			silex_ptr.sequencer.addItem(anims[silex_ptr.config.ANIM_NAME_SHOW],Utils.createDelegate(this,endAnimShow),Utils.createDelegate(this,startAnimShow));
		// show after init
		_parent._visible=true;
		}
		
		// dispatch event
		dispatchEvent({type: silex_ptr.config.UI_PLAYERS_EVENT_XMLLOADED ,target:this});
		// hooks
		hookManager.callHooks(LayoutHooks.XML_LOADED_END_HOOK_UID, null);
	}
/**/
	function amfLoaded(resultObj:Object)
	{
		// silex_ptr.utils.alertSimple("amfLoaded "+initDone_bool);
		// call hooks
        var hookManager:HookManager = HookManager.getInstance();
		hookManager.callHooks(LayoutHooks.AMF_LOADED_START_HOOK_UID, arguments);
		
/*			var resString = "";
           for (var r:String in resultObj)
            {
               resString += r + " : " + resultObj[r]+ "\n";
            }
		silex_ptr.utils.trace("org.silex.core.Layout amfLoaded " + resString);
	_root.getURL("javascript:alert('"+resString+"');");
/**/
		if (resultObj)
		{
	 		// create the dom object corresponding to the xml data
			dom = resultObj;
		}
		else{
			silex_ptr.utils.trace("org.silex.core.Layout amfLoaded error loading section "+sectionName+". If this section does not exist yet, it will be automatically created.");
			silex_ptr.utils.alertSimple(silex_ptr.utils.revealAccessors(silex_ptr.config.MESSAGE_SECTION_DOES_NOT_EXIST,this));
	 		// create an empty dom object
			dom=new Object;
		}

		// xml loading process has ended
		xmlLoaded_bool = true;
		
		// load layers objects in the registered layerContainers
		silex_ptr.utils.trace("org.silex.core.Layout amfLoaded - about to load "+layerContainers.length+" layers");
		for (var idx:Number=0;idx<layerContainers.length;idx++){
			// load the layer object in that layer
			loadRegisteredLayer(layerContainers[idx]);
		}
		
		// if init has been called allready
		if (initDone_bool==true){
			// push the show anim in the sequencer
			silex_ptr.sequencer.addItem(anims[silex_ptr.config.ANIM_NAME_SHOW],Utils.createDelegate(this,endAnimShow),Utils.createDelegate(this,startAnimShow));
		}
		
		// dispatch event
		dispatchEvent({type: silex_ptr.config.UI_PLAYERS_EVENT_XMLLOADED ,target:this});
		// hooks
		hookManager.callHooks(LayoutHooks.AMF_LOADED_END_HOOK_UID, null);
	}
	/*
	 * Called by org.silex.core.Application AFTER layout first frame.
	 * Handle the anims.
	 */
	function init(){
		silex_ptr.utils.trace("org.silex.core.Layout init");
		// silex_ptr.utils.alertSimple(" init "+xmlLoaded_bool);
		
		initDone_bool=true;

		// **
		// automatic anims registering
		// depending on flash IDE mode: normal, slide presentation or form application
		//
		// normal mode
		var layoutRoot_mc:MovieClip=_parent;
		// slide presentation mode
		if (_parent.presentation)
			layoutRoot_mc=_parent.presentation;
		// form application mode
		if (_parent.application)
			layoutRoot_mc=_parent.application;

		// register anims
		if (layoutRoot_mc[silex_ptr.config.ANIM_NAME_PRELOAD])
			registerAnim(layoutRoot_mc[silex_ptr.config.ANIM_NAME_PRELOAD],silex_ptr.config.ANIM_NAME_PRELOAD);
		if (layoutRoot_mc[silex_ptr.config.ANIM_NAME_SHOW])
			registerAnim(layoutRoot_mc[silex_ptr.config.ANIM_NAME_SHOW],silex_ptr.config.ANIM_NAME_SHOW);
		if (layoutRoot_mc[silex_ptr.config.ANIM_NAME_TRANSITION_CLOSE])
			registerAnim(layoutRoot_mc[silex_ptr.config.ANIM_NAME_TRANSITION_CLOSE],silex_ptr.config.ANIM_NAME_TRANSITION_CLOSE);
		if (layoutRoot_mc[silex_ptr.config.ANIM_NAME_TRANSITION])
			registerAnim(layoutRoot_mc[silex_ptr.config.ANIM_NAME_TRANSITION],silex_ptr.config.ANIM_NAME_TRANSITION);
		if (layoutRoot_mc[silex_ptr.config.ANIM_NAME_CLOSE])
			registerAnim(layoutRoot_mc[silex_ptr.config.ANIM_NAME_CLOSE],silex_ptr.config.ANIM_NAME_CLOSE);

		// **
		// start preload anim
		silex_ptr.sequencer.addItem(anims[silex_ptr.config.ANIM_NAME_PRELOAD],Utils.createDelegate(this,endAnimPreload));

		// **
		// if xml has allready been loaded (local mode), push the show anim in the sequencer
		if (xmlLoaded_bool==true){
			silex_ptr.sequencer.addItem(anims[silex_ptr.config.ANIM_NAME_SHOW],Utils.createDelegate(this,endAnimShow),Utils.createDelegate(this,startAnimShow));
		}
		// show after init
		_parent._visible=true;
		if (silex_ptr.config.USE_AMF_FILES.toLowerCase()=="true")
		{
			// **
			// AMF
			amfConnect();
//			silex_ptr.sequencer.doInNFrames(1, Utils.createDelegate(this,amfConnect));
		}
		else
		{
			// **
			// XML
			xmlConnect();
		}
	}
	/**
	 * Close the layout
	 */
	function close(){
		// TO DO : chexk isDirty property
	
		silex_ptr.utils.trace("org.silex.core.Layout close");
		// dispatch event
		dispatchEvent({type:  silex_ptr.config.UI_PLAYERS_EVENT_CONTENT_HIDE_START ,target:this});
		
		// show close anim if there is one and unload
/*		if (anims[silex_ptr.config.ANIM_NAME_CLOSE])
			silex_ptr.sequencer.addItem(anims[silex_ptr.config.ANIM_NAME_CLOSE],Utils.createDelegate(this,unloadLayoutCallback));
		else
			unloadLayoutCallback();*/
			
		// close the child layouts
		closeChild();
			
		// show th close anim
		silex_ptr.sequencer.addItem(anims[silex_ptr.config.ANIM_NAME_CLOSE],Utils.createDelegate(this,unloadLayoutCallback));
	}
	/**
	 * close children and then start the close transition anim
	 */
	function closeChild(){
		silex_ptr.utils.trace("org.silex.core.Layout closeChild "+currentChildLayoutContainer.silexLayout+" - "+currentChildLayoutContainer.silexLayout.close);
		// close the child layouts
		if (currentChildLayoutContainer){
			currentChildLayoutContainer.silexLayout.close();
			// show the transition close anim
			silex_ptr.sequencer.addItem(anims[silex_ptr.config.ANIM_NAME_TRANSITION_CLOSE],Utils.createDelegate(this,transitionCloseStop),Utils.createDelegate(this,transitionCloseStart));
		}
	}
	/**
	 * the tracition close anim is over
	 */
	function transitionCloseStop() {
		silex_ptr.utils.trace("org.silex.core.Layout transitionCloseStop");
		// no more current child
		currentChildLayoutContainer=null;
		// reset transition anim
		anims[silex_ptr.config.ANIM_NAME_TRANSITION].gotoAndPlay(1);		
	}
	/**
	 * the tracition close anim started
	 */
	function transitionCloseStart() {
		silex_ptr.utils.trace("org.silex.core.Layout transitionCloseStart");
		// dispatch event
		dispatchEvent({type:  "hideChild" ,target:this});
	}
	/**
	 * the close anim ended
	 */
	function unloadLayoutCallback() {
		silex_ptr.utils.trace("org.silex.core.Application unloadLayoutCallback - unload layout "+this._parent);

		// dispatch event
		dispatchEvent({type:  silex_ptr.config.UI_PLAYERS_EVENT_CONTENT_HIDE,target:this});

		// unload after the anim ended
		if (anims[silex_ptr.config.ANIM_NAME_CLOSE]){
			var remainingFramesBeforeUnload:Number = anims[silex_ptr.config.ANIM_NAME_CLOSE]._totalFrames - anims[silex_ptr.config.ANIM_NAME_CLOSE]._currentFrame;
			silex_ptr.sequencer.doInNFrames(remainingFramesBeforeUnload, Utils.createDelegate(this, doUnloadLayoutCallback));
		}
		else
			doUnloadLayoutCallback();
	}
	function doUnloadLayoutCallback(){
		silex_ptr.application.layout_mcl.unloadClip(this._parent);
	}
	/**
	 * called by org.silex.core.Sequencer when preload anim ends
	 */
	function endAnimPreload() {
		silex_ptr.utils.trace("org.silex.core.Layout endAnimPreload");
	}
	/**
	 * called by org.silex.core.Sequencer when show anim ends
	 */
	function startAnimShow() {
		silex_ptr.utils.trace("org.silex.core.Layout startAnimShow");

		// is content visible?
		isContentVisible=true;

		// dispatch event
		dispatchEvent({type: silex_ptr.config.UI_PLAYERS_EVENT_CONTENT_SHOW ,target:this});
	}
	/**
	 * called by org.silex.core.Sequencer when show anim ends
	 */
	function endAnimShow() {
		silex_ptr.utils.trace("org.silex.core.Layout endAnimShow");
	}
	/**
	 * has to be called on the 1st frame of a layout
	 */
	function registerAnim (target_mc:MovieClip,animName_str:String){
		anims[animName_str]=target_mc;
		target_mc.stop();
		target_mc._visible=false;
	}
	/**
	 * Called by the layout.
	 * The target is filled with a layer object.
	 * To be efficient, it has to be called on the 1st frame of a layout.
	 */
	function registerLayerContainer(layerContainer:MovieClip, layerName_str:String) {
		// silex_ptr.utils.alertSimple("registerLayerContainer "+xmlLoaded_bool+" - "+layerName_str);
		layerContainers.push(layerContainer);
		layerContainer.layerName=layerName_str;

		if (!layerContainer.container_mc)
			layerContainer.createEmptyMovieClip("container_mc",layerContainer.getNextHighestDepth());
		
		// load the layer object in that layer
		if (xmlLoaded_bool) {
//			loadRegisteredLayer(layerContainer);
			var refthis = this;
			silex_ptr.sequencer.doInNFrames(10, function () { refthis.loadRegisteredLayer(layerContainer) } );
		}
	}
	function loadRegisteredLayer(layerContainer:MovieClip){
		silex_ptr.utils.trace("org.silex.core.Layout loadRegisteredLayer - load "+silex_ptr.config.FLASH_PLAYER_FOLDER+silex_ptr.config.layerSkinUrl+" in the registered layer "+layerContainer.container_mc);
		// silex_ptr.utils.alertSimple("loadRegisteredLayer "+ layerContainer);
		
		// hide the layer while loading
		layerContainer._visible=false;

//		layerContainer.container_mc.loadMovie(silex_ptr.rootUrl+silex_ptr.utils.revealAccessors(silex_ptr.config.FLASH_PLAYER_FOLDER+silex_ptr.config.layerSkinUrl));
//		silex_ptr.utils.loadMedia(silex_ptr.utils.revealAccessors(silex_ptr.config.FLASH_PLAYER_FOLDER + silex_ptr.config.layerSkinUrl), layerContainer.container_mc);
		layerContainer.container_mc.loadMovie(silex_ptr.rootUrl+silex_ptr.utils.revealAccessors(silex_ptr.config.FLASH_PLAYER_FOLDER+silex_ptr.config.layerSkinUrl));
	}
	/**
	 * Called by the org.silex.ui.Layer class before all players have been initialized.
	 * Store the layer into layers array and retrieve the layer's name from layer container.
	 */
	function registerLayer(target_mc:org.silex.ui.Layer){
		// silex_ptr.utils.alertSimple("registerLayer "+target_mc);
		// retrieve the layer's name from layer container 
		var ptr_mc:MovieClip=target_mc._parent;
		while (ptr_mc && !ptr_mc.layerName){
			ptr_mc=ptr_mc._parent;
		}
		if (ptr_mc.layerName)
			target_mc.name=ptr_mc.layerName;
			
		silex_ptr.utils.trace("org.silex.core.Layout registerLayer target=" + target_mc + " - name=" + target_mc.name);

		// show after loading
//		target_mc._visible=false;
//		ptr_mc._visible=true;

		// store the layer into layers array
		layers.push(target_mc);
		var _obj:Object=new Object;
		_obj.allPlayersLoaded=Utils.createDelegate(this,registeredLayerAllPlayersLoaded);
		target_mc.addEventListener("allPlayersLoaded",_obj);
	}
	
	/**
	 * Called by the org.silex.ui.Layer class after all players have been initialized.
	 * Check for deeplinks or default icons.
	 */
	function registeredLayerAllPlayersLoaded(ev:Object){
		silex_ptr.utils.trace("org.silex.core.Layout registeredLayerAllPlayersLoaded target=" + ev.target);
		// silex_ptr.utils.alertSimple("registeredLayerAllPlayersLoaded "+ev.target);

		// show after loading
		var ptr_mc:MovieClip=ev.target;
		while (ptr_mc && !ptr_mc.layerName){
			ptr_mc=ptr_mc._parent;
		}
		ptr_mc._visible=true;
		
		// check if deeplink target has been reached
		if(silex_ptr.deeplink.doApplyPath()==true){
			silex_ptr.utils.trace("org.silex.core.Layout registerLayer deeplink target has been reached - check if there is a default icon");
			// check if a default icon should be opened
			if (defaultIcon!=undefined){
				silex_ptr.utils.trace("org.silex.core.Layout registerLayer a default icon has to be opened "+defaultIcon+" - "+defaultIcon.iconPageName+" - "+defaultIcon.iconLayoutName);
				defaultIcon.openIcon();
			}
		}
		//else silex_ptr.utils.trace("org.silex.core.Layout registerLayer deeplink target has NOT been reached yet "+silex_ptr.deeplink.deeplink_array);
	}
	/**
	 * Called by the child layout component.
	 * The target will contain the child layouts.
	 * It has to be called on the 1st frame of a layout.
	 * org.silex.core.Application openSection can create one automatically at the layout root.
	 */
	function registerLayoutContainer(layoutContainer_mc:MovieClip){
		// silex_ptr.utils.alertSimple("registerLayoutContainer "+layoutContainer_mc);
		layoutContainer=layoutContainer_mc;
	}
	function registerDefaultIcon(player:org.silex.ui.players.PlayerBase) {
		// no more error since a context change can let a default icon appear/disappear
		/*
		if (defaultIcon)
		{
			// error
			// silex_ptr.utils.alert(silex_ptr.utils.revealAccessors(silex_ptr.config.WARNING_MULTIPLE_DEFAULT_ICON,{layout:this,player:player}));
		}
		*/
		defaultIcon=player;
	}
	function unRegisterDefaultIcon(player:org.silex.ui.players.PlayerBase) {
		if (defaultIcon==player) defaultIcon=undefined;
	}

}