﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.controls.TextArea;

class org.silex.toolbox.Actions extends org.silex.toolbox.Toolbox{
	var _txt:TextArea;
	function Actions(){
		ui_mc.help_btn.onRelease = function(){_root.getURL(_global.getSilex().config.HELP_URL_DOCUMENTATION_ROOT+_global.getSilex().config.HELP_URL_WYSIWYG_ACTIONS,"_blank");};
	}
	function allToolsLoaded() {
		super.allToolsLoaded();
		var refreshListener = new Object();
		refreshListener.change = Utils.createDelegate(this,refresh);
		_parent._parent.players_tool.main.addEventListener("change",refreshListener);
		
		//clipTo(_parent._parent.players_tool.main,BOTTOM_ZONE);
	}
	
	public function onLoad(){
		super.onLoad();
		
//		_global.styles.TextArea.setStyle("backgroundColor", undefined);


		title=silex_ptr.config.TOOL_BOX_TITLE_ACTION;
		refresh();
		// Defined the change event for the list.
		var listListener:Object = new Object();
		listListener.change = Utils.createDelegate(this, change);
		_txt.addEventListener("change", listListener);
	}
	public function resize(w:Number,h:Number):Void{
		super.resize(w,h);
		_txt.setSize(resize_btn._x + resize_btn._width - _txt.x,resize_btn._y-_txt.y);
	}
	public function refresh(){
		super.refresh();
		
		//silex_ptr.utils.trace("toolbox.Actions refresh properties");
		var currentPlayerName:String = _parent._parent.players_tool.main.getSelectedContent()._name;
		var currentLayer/*:org.silex.ui.Layer*/ = _parent._parent.layers_tool.main.getSelectedContent();
		var currentPlayer/*:org.silex.ui.players.PlayerBase*/=currentLayer[currentPlayerName].main;

		if (currentPlayer){
			_txt.text="";
			for (var idx:Number=0;idx<currentPlayer.actions.length;idx++){
				_txt.text+=currentPlayer.actions[idx].modifier+" "+currentPlayer.actions[idx].functionName;
				if (currentPlayer.actions[idx].parameters && currentPlayer.actions[idx].parameters.length>0)
					_txt.text+=":"+currentPlayer.actions[idx].parameters;
				_txt.text+="\r";
			}
		}
		else
			_txt.text="Select a player in the Players Tool Box";
			
		dispatchEvent({type:"change"});
	}
	/**
	 * Function used to retrieve the selected properties.
	 */
	public function getSelectedContent():Array {
		return silex_ptr.interpreter.buildActionArrayFromString(_txt.text);
	}
	public function change(evt_obj:Object):Void {
		//silex_ptr.utils.trace("toolbox.Actions change properties");
		var currentPlayerName:String = _parent._parent.players_tool.main.getSelectedContent()._name;
		var currentLayer/*:org.silex.ui.Layer*/ = _parent._parent.layers_tool.main.getSelectedContent();
		var currentPlayer/*:org.silex.ui.players.PlayerBase*/=currentLayer[currentPlayerName].main;
		
		if (!currentPlayer){
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return;
		}
		
		currentPlayer.actions=silex_ptr.interpreter.buildActionArrayFromString(_txt.text);

		dispatchEvent({type:"change"});
	}
	/**
	 * make UIs disappear, leave drag zone and minimize_btn
	 * get the initial size back in currentWidth and currentHeight
	*/
	public function minimize():Void{
		super.minimize();
		if(this.minimized){
			_txt._visible=false;
		}else _txt._visible=true;
	}
}
