﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;

class org.silex.toolbox.KeyboardShortcut extends mx.core.UIComponent{
	var silex_ptr/*:org.silex.core.Api*/;
	var listener:Object;
	
	function KeyboardShortcut () {
		silex_ptr=_global.getSilex(this);
		
		silex_ptr.utils.trace("KeyboardShortcut constructor");
		
		listener= new Object();
		listener.onKeyDown = Utils.createDelegate(this,onKeyDownCallback);
		listener.onKeyUp = Utils.createDelegate(this,onKeyUpCallback);
		Key.addListener(listener);

		// menu tool
		_parent.isNotSeenByMenuTool=true; // so that it is not used by the menu
	}
	function onKeyDownCallback() {
		//silex_ptr.utils.trace("KeyboardShortcut onKeyDownCallback "+Key.getAscii()+" "+Key.isDown(Key.CONTROL));
		//silex_ptr.utils.trace("KeyboardShortcut onKeyDownCallback - Code: "+Key.getCode()+" - ASCII: "+Key.getAscii()+" - Key: "+chr(Key.getAscii()));
		var isCtrl:Boolean=Key.isDown(Key.CONTROL);
		switch(chr(Key.getAscii())){
			case "s":
			case "S":
				silex_ptr.utils.trace("KeyboardShortcut onKeyDownCallback saveAll "+_parent._parent.menu_tool);
				if (isCtrl) _parent._parent.menu_tool.main.saveAll();
			break;
			case "a":
			case "A":
				if (isCtrl){
//					_parent._parent.players_tool.main.list.selectedIndices=[0,_parent._parent.players_tool.main.list.length-1];
				}
			break;
			default:
		}
		switch(Key.getCode()){
			case Key.ESCAPE:
				_parent._parent.players_tool.main.deselect();
			break;
			case Key.SPACE:
				if (!dragDropListener_obj){
					dragDropListener_obj=new Object;
					dragDropListener_obj.onBgPress=Utils.createDelegate(this,onBgPress);
					dragDropListener_obj.onBgRelease=Utils.createDelegate(this,onBgRelease);
					silex_ptr.application.addEventListener("onBgPress",dragDropListener_obj);
					silex_ptr.application.addEventListener("onBgRelease",dragDropListener_obj);
				}
			break;
			case Key.DELETEKEY:
				silex_ptr.utils.trace("KeyboardShortcut DELETEKEY "+Selection.getFocus().toLowerCase());
				// if focus is in a toolbox but not in a property editor
				if (Selection.getFocus().toLowerCase().indexOf("toolscontainer_mc.library")>-1
					|| Selection.getFocus().toLowerCase().indexOf("toolscontainer_mc.players")>-1
					|| Selection.getFocus().toLowerCase().indexOf("toolscontainer_mc.layers")>-1
					|| Selection.getFocus().toLowerCase().indexOf("toolscontainer_mc.selection")>-1
					|| (Selection.getFocus().toLowerCase().indexOf("toolscontainer_mc.properties")>-1 && Selection.getFocus().indexOf("editor_mc")==-1)
					)
					_parent._parent.players_tool.main.deleteSelection();
			break;
			case Key.TAB:
				_parent._parent._visible=!_parent._parent._visible;
			break;
			default:
		}
	}
	var dragDropListener_obj:Object=null;
	function onKeyUpCallback () {
		switch(Key.getCode()){
			case Key.SPACE:
				if (dragDropListener_obj){
					silex_ptr.application.removeEventListener("onBgPress",dragDropListener_obj);
					silex_ptr.application.removeEventListener("onBgRelease",dragDropListener_obj);
					delete dragDropListener_obj;
					dragDropListener_obj=null;
				}
			break;
			default:
		}
	}
	function onBgRelease() {
		//if (_parent._parent.menu_tool.main.sceneBorder_mc) silex_ptr.utils.alertSimple("Desactivate \"view scene border\" tool if you want to move the scene arround");
		// Desactivate "view scene border" tool
		if (_parent._parent.menu_tool.main.sceneBorder_mc)
			_parent._parent.menu_tool.main.viewScene();
		silex_ptr.application.layoutContainer.stopDrag();
	}
	function onBgPress() {
		silex_ptr.application.layoutContainer.startDrag();
	}
}
