﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.controls.Tree;
import mx.data.binding.ObjectDumper;
//import org.silex.core.Layout;

/**
 * Layers toolbox
 */
class org.silex.toolbox.Layers extends org.silex.toolbox.Toolbox {
	static var REFRESH_INTERVAL_MS:Number = 500;
	public function Layers(){
		//trace("New Layers");
		ui_mc.show_btn.onRelease = Utils.createDelegate(this,show);
		ui_mc.hide_btn.onRelease = Utils.createDelegate(this,hide);
		ui_mc.solo_btn.onRelease = Utils.createDelegate(this,solo);
		ui_mc.apply_btn.onRelease = Utils.createDelegate(this,apply);
		ui_mc.library_btn.onRelease = Utils.createDelegate(this,addFromLibrary);
		ui_mc.url_btn.onRelease = Utils.createDelegate(this,addFromUrl);
		//ui_mc.component_btn.onRelease = Utils.createDelegate(this,addComponentFromUrl);
		ui_mc.text_btn.onRelease = Utils.createDelegate(this,addFromText);
		ui_mc.refresh_btn.onRelease=Utils.createDelegate(this, refresh);
		ui_mc.help_btn.onRelease = function(){_root.getURL(_global.getSilex().config.HELP_URL_DOCUMENTATION_ROOT+_global.getSilex().config.HELP_URL_WYSIWYG_LAYERS,"_blank");};
	}
	
	var listListener:Object;

	// refresh interval
	var intervalIdx:Number=-1;
	public function onLoad(){
		super.onLoad();

		title=silex_ptr.config.TOOL_BOX_TITLE_LAYERS;
		//silex_ptr.utils.trace("toolbox.Layers onLoad");
		
		list.selectedIndex=-1;
		refresh();
		// Defined the change event for the list.
		listListener = new Object();
		listListener.change = Utils.createDelegate(this, change);
		list.addEventListener("change", listListener);

		listListener.layoutLoaded=Utils.createDelegate(this, layoutLoaded);
		silex_ptr.application.addEventListener("layoutLoaded", listListener);

		listListener.showContent=Utils.createDelegate(this, refresh);
		listListener.hideContent=Utils.createDelegate(this, layoutUnLoaded);
		// icons and item function
		// icons and item function
		list.iconFunction=Utils.createDelegate(this,iconFunction);
		
		//  refresh regularly to display all layers anytime
		intervalIdx=setInterval(Utils.createDelegate(this, refresh),REFRESH_INTERVAL_MS,false);
	}
	function onUnload(){
		super.onUnload();
		clearInterval(intervalIdx);
	}
	function iconFunction(item:Object) {
		var layer=item.data;
		if (layer._visible==true) return "hideButton";
		return "showButton";
	}

	// layoutLoaded
	// ev.target is the loaded layout
	function layoutLoaded(ev:Object) {
		//silex_ptr.utils.trace("toolbox.Layers layoutLoaded "+ev.target);
		ev.target.addEventListener("showContent",listListener);
		ev.target.addEventListener("hideContent",listListener);
		refresh();
	}
	function layoutUnLoaded (ev:Object) {
		//silex_ptr.utils.trace("toolbox.Layers layoutUnLoaded "+ev.target);
		ev.target.removeEventListener("showContent",listListener);
		ev.target.removeEventListener("hideContent",listListener);
		refresh();
	}

	public function refresh(doDispatch:Boolean){
		
		var selectedIndex:Number=list.selectedIndex;
		var currentIndex:Number=0;
		
		// Check the layers list from silex_ptr
		list.removeAll();
		list.dataProvider= new Array;
		var layouts_arr =silex_ptr.application.layouts;
		//silex_ptr.utils.trace("toolbox.Layers refresh layouts_arr="+layouts_arr+" - layouts_arr[1]="+layouts_arr[1]+" - layouts_arr[1].layers="+layouts_arr[1].layers);
		
		for(var i=0 ; i<layouts_arr.length ; i++){
			//silex_ptr.utils.trace("toolbox.Layers refresh layout "+i+" has "+layouts_arr[i].layers.length+" layers");
			for(var j=0; j<layouts_arr[i].layers.length ; j++){
				//silex_ptr.utils.trace("toolbox.Layers refresh "+"layer"+i+"_"+j+" - layouts_arr[i]="+layouts_arr[i]+" - layers="+layouts_arr[i].layers+" - layers[j]="+layouts_arr[i].layers[j]+" - layers[j].players="+layouts_arr[i].layers[j].players);
				//silex_ptr.utils.trace("toolbox.Layers refresh "+"layer"+i+"_"+j+" - "+layouts_arr[i].layers[j].name+" - "+layouts_arr[i].layers[j]._target+" - "+list+" - selectedIndex = "+selectedIndex.toString());
				//list.addItem({label:"layer"+i+"_"+j, data:layouts_arr[i].layers[j]});
				/*var idx:Number=*/list.addItem({label:layouts_arr[i].sectionName+" ["+layouts_arr[i].layers[j].name+"]", data:layouts_arr[i].layers[j]});
				//if (doDispatch!=false)
					//silex_ptr.utils.trace("toolbox.Layers refresh "+i.toString()+","+j.toString()+" --- "+idx.toString()+" - setEditable "+(selectedIndex>-1 && selectedIndex==idx).toString()+" ("+layouts_arr[i].layers[j]+")");
					layouts_arr[i].layers[j].setEditable(selectedIndex!=undefined && selectedIndex>-1 && selectedIndex==currentIndex++);
			}
		}
		if (doDispatch!=false){
			super.refresh();
			dispatchEvent({type:"change"});
		}
		else{
			// keep selected item
			list.selectedIndex = selectedIndex;
			
			// force refresh of selection
			//silex_ptr.sequencer.doInNFrames(2,Utils.createDelegate(_parent._parent.selection_tool.main,_parent._parent.selection_tool.main.playersToolboxChange));
			_parent._parent.selection_tool.main.playersToolboxChange();
		}
	}
	/**
	 * Function used to retrieve the selected layers.
	 */
	public function getSelectedContent():Array {
		return list.selectedItem.data;
	}
	
	/**
	 * Function change.
	 */
	public function change(evt_obj:Object):Void {
		silex_ptr.utils.trace("toolbox.Layers change "+list.selectedItem.label);
		for(var i=0; i<list.length ; i++){
			list.getItemAt(i).data.setEditable(list.selectedIndex!=undefined && list.selectedIndex>-1 && list.selectedIndex==i);
		}
		dispatchEvent({type:"change"});
	}
	
	/**
	 * show selected layers (set all players isVisible attribute to true) 
	 * To list all players associated at the current layers and use setVisible method with true.
	 */
	public function show(idx:Number):Void {
		silex_ptr.utils.trace("toolbox layers show "+idx+" or "+list.selectedItem);

		if (idx==undefined) idx=list.selectedItem;
		list.getItemAt(idx).data._visible=true;
		dispatchEvent({type:"change"});
	}
		
	/**
	 * hide selected layers (set all players isVisible attribute to false) 
	 * To list all players associated at the current layers and use setVisible method with false
	 */
	public function hide(idx:Number):Void {
		if (idx==undefined) idx=list.selectedItem;
		list.getItemAt(idx).data._visible=false;
		dispatchEvent({type:"change"});
	}
	
	/**
	 * show only selected layer (set all players isVisible attribute to false except for the selected players) 
	 * To list all layers and set isVisible to false for the layers not selected
	 */
	public function solo():Void {
		silex_ptr.utils.trace("solo "+list.length);
		for(var i=0; i<list.length ; i++){
			list.getItemAt(i).data._visible=!list.getItemAt(i).data._visible;
		}
		dispatchEvent({type:"change"});
	}
	
	/**
	 * apply the modifications (call silex save method and set all players editable attribute to false) 
	 * Check the mc layer selected reference and pass to core.save method 
	 * To list all players associated at the current layers and set editable property to false
	 */
	public function apply():Void { /// listener sur 
		if (!list.selectedItem){
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return;
		}
		silex_ptr.application.save(list.selectedItem.data._parent);
	}
	
	/**
	 * add the medias which are selected in the library. 
	 * Call the getSelectedContent of library toolbox to check the return media url value. 
	 * Then to call addMedia method of selected layer and recover the boolean returned for validate
	 */
	public function addFromLibrary():Boolean {
		var selectedMediaUrl = _parent._parent.library_tool.main.getSelectedContent().attributes.url;
		var select = list.selectedItem;
		silex_ptr.utils.trace("toolbox.Layers addfromLibrary "+selectedMediaUrl+" in "+select);
		if (!selectedMediaUrl || !select){
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return false;
		}
		list.selectedItem.data.addMedia(silex_ptr.config.initialFtpFolderPath+silex_ptr.config.websiteFtpRelativeUrl+selectedMediaUrl);
		return true;
	}
	
	/**
	 * function url.
	 */
	public function addFromUrl():Boolean {
		silex_ptr.utils.trace("addfromUrl");
		if (!list.selectedItem){
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return false;
		}
		silex_ptr.utils.prompt(silex_ptr.config.PROMPT_ENTER_URL_FOR_MEDIA_IMPORT,"http://",Utils.createDelegate(this,addFromUrlCbkFunction));
		return true;
	}
	function addFromUrlCbkFunction(theTextOfTheUser)
	{
		if (theTextOfTheUser && theTextOfTheUser!=""){
			list.selectedItem.data.addMedia(theTextOfTheUser);
			// select the new player
			_parent._parent.players_tool.main.list.selectedIndex = 0;
		}
	}		
	/**
	 * addComponentFromUrl and addComponentFromUrlCbk
	 * call org.silex.ui.Layer.addComponent
	 */
/*	public function addComponentFromUrl():Boolean {
		silex_ptr.utils.trace("addComponentFromUrl");
		if (!list.selectedItem){
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return false;
		}
		silex_ptr.utils.prompt("Enter the URL of the component","./components/mail/mailComp.swf",Utils.createDelegate(this,addComponentFromUrlCbkFunction));
		return true;
	}
	function addComponentFromUrlCbkFunction(theTextOfTheUser)
	{
		if (theTextOfTheUser && theTextOfTheUser!=""){
			list.selectedItem.data.addComponent(theTextOfTheUser);
		}
	}			
*/	/**
	 * function library.
	 */
	public function addFromText():Boolean {
		trace("addfromText");
		if (!list.selectedItem){
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return false;
		}
		list.selectedItem.data.addMedia(null);

		// select the new player
		_parent._parent.players_tool.main.list.selectedIndex = 0;
		return true;
	}
	
	
}