﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import mx.controls.Tree;
import org.silex.core.Utils;
import org.silex.toolbox.LibraryCellRenderer;

/**
 * Properties toolbox
 */
class org.silex.toolbox.Library extends org.silex.toolbox.Toolbox {
	
	public var xml_str:String;
	public var urlPath:String;
//	var pathTree:Array; // result from the call to listFtpFolderContent webservice

	/**
	 * menu UIs
	 */
	var url_btn:Button;
	var txt_btn:Button;
	var widget_btn:Button;
	var html_btn:Button;
	var swf_btn:Button;
	
	var _lc:LocalConnection;

	public function Library(){
		// Configure the arborescence aspect
        list.setStyle("Arial", "_sans");
        list.setStyle("fontSize", 12);
		
		// menu UIs
		url_btn.onRelease = Utils.createDelegate(this,urlButtonCallback);
		txt_btn.onRelease = Utils.createDelegate(this,txtButtonCallback);
		widget_btn.onRelease = Utils.createDelegate(this,widgetButtonCallback);
		html_btn.onRelease = Utils.createDelegate(this,htmlButtonCallback);
		swf_btn.onRelease = Utils.createDelegate(this,swfButtonCallback);
		
		// other UIs
		ui_mc.view_btn.onRelease = Utils.createDelegate(this,view);
		ui_mc.url_btn.onRelease = Utils.createDelegate(this,urlString);
		ui_mc.refresh_btn.onRelease = Utils.createDelegate(this,refresh);
		ui_mc.ftp_btn.onRelease = Utils.createDelegate(this,ftpClient);
		ui_mc.help_btn.onRelease = function(){_root.getURL(_global.getSilex().config.HELP_URL_DOCUMENTATION_ROOT+_global.getSilex().config.HELP_URL_WYSIWYG_LIBRARY,"_blank");};
		
		urlPath = silex_ptr.config.initialFtpFolderPath+silex_ptr.config.websiteFtpRelativeUrl;
		
		_lc=new LocalConnection;
		_lc.refresh=Utils.createDelegate(this,refresh);
		_lc.connect("_silexLibrary");
		
		refresh();
	}
	////////////////////////////////////////////
	// buttons callback
	////////////////////////////////////////////
	function urlButtonCallback() 
	{
		_parent._parent.layers_tool.main.addFromUrl();
	}
	function txtButtonCallback() 
	{
		_parent._parent.layers_tool.main.addFromText();
	}
	function widgetButtonCallback() 
	{
		if (!_parent._parent.layers_tool.main.list.selectedItem)
		{
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return;
		}
		silex_ptr.utils.prompt(silex_ptr.config.PROMPT_ENTER_WIDGET_HTML_CODE,"",Utils.createDelegate(this,addFramedHtmlTextCbkFunction));
	}
	function addFramedHtmlTextCbkFunction(theTextOfTheUser:String)
	{
		addFramedMedia(theTextOfTheUser, "addFramedHtmlText");
	}
	function htmlButtonCallback() 
	{
		if (!_parent._parent.layers_tool.main.list.selectedItem)
		{
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return;
		}
		silex_ptr.utils.prompt(silex_ptr.config.PROMPT_ENTER_HTML_PAGE_URL,"",Utils.createDelegate(this,addFramedLocationCbkFunction));
	}
	function addFramedLocationCbkFunction(theTextOfTheUser:String)
	{
		addFramedMedia(theTextOfTheUser, "addFramedLocation");
	}
	function swfButtonCallback() 
	{
		if (!_parent._parent.layers_tool.main.list.selectedItem)
		{
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return;
		}
		silex_ptr.utils.prompt(silex_ptr.config.PROMPT_ENTER_SWF_URL,"",Utils.createDelegate(this,addFramedEmbededObjectCbkFunction));
	}
	function addFramedEmbededObjectCbkFunction(theTextOfTheUser:String)
	{
		addFramedMedia(theTextOfTheUser, "addFramedEmbededObject");
	}

	/**
	 * add a framed media to the layer
	 * either location, widget or as3
	 * @param	theTextOfTheUser
	 * @param	functionName
	 */
	function addFramedMedia(theTextOfTheUser:String, functionName:String)
	{
		if (theTextOfTheUser && theTextOfTheUser != "")
		{
			_parent._parent.layers_tool.main.getSelectedContent()[functionName](theTextOfTheUser);
			// select the new player
			_parent._parent.players_tool.main.list.selectedIndex = 0;
		}
	}		
	////////////////////////////////////////////
	// xml and webservices
	////////////////////////////////////////////
	function handleListFtpFolderContent(tree_array:Array):Void{
		//silex_ptr.utils.trace("toolbox.Library handleListFtpFolderContent - " + tree_array.length);

		//Implement custom callback code
		xml_str = "<node label='root'>";
		madeXML(tree_array);
		xml_str += "</node>";
		//silex_ptr.utils.trace("toolbox.Library handleListFtpFolderContent - tree_array=" + tree_array+" - xml_str="+xml_str);
		
		var menuXML:XML = new XML(xml_str);
        list.dataProvider = menuXML.firstChild;
		//pathTree=tree_array;
		list.iconField="itemExtension";// "itemType";
		//list.iconFunction=iconFunction;
	}
	function madeXML(obj:Object,path:String):Void{
		//trace("madeXML "+obj);
		if(!path) path="";
		
		if(obj.length==null) obj= new Array(obj);
		for(var i=0 ; i<obj.length; i++){
			//silex_ptr.utils.trace("toolbox.Library madeXML - " + obj[i][silex_ptr.config.itemTypeField]);
			if(obj[i][silex_ptr.config.itemTypeField]=="file"){
				var ext:String=obj[i][silex_ptr.config.itemNameField].toLowerCase().substring(obj[i][silex_ptr.config.itemNameField].length - 3);
				if (ext=="swf" && obj[i][silex_ptr.config.itemNameField].toLowerCase().substring(obj[i][silex_ptr.config.itemNameField].length - 7)=="cmp.swf")
					ext="cmp.swf";
					
				//trace("<node label='"+obj[i][silex_ptr.config.itemNameField]+"' url='"+path+obj[i][silex_ptr.config.itemNameField]+"' itemModifDate='"+obj[i][silex_ptr.config.itemModifDateField]+"' itemSize='"+obj[i][silex_ptr.config.itemSizeField]+"' itemType='"+obj[i][silex_ptr.config.itemTypeField]+"' itemWidth='"+obj[i][silex_ptr.config.itemWidthField]+"' itemHeight='"+obj[i][silex_ptr.config.itemHeightField]+"'/>");
				xml_str += "<node label='"+obj[i][silex_ptr.config.itemNameField]+"' url='"+path+obj[i][silex_ptr.config.itemNameField]+"' itemModifDate='"+obj[i][silex_ptr.config.itemModifDateField]+"' itemSize='"+obj[i][silex_ptr.config.itemSizeField]+"' itemType='"+obj[i][silex_ptr.config.itemTypeField]+"' itemWidth='"+obj[i][silex_ptr.config.itemWidthField]+"' itemHeight='"+obj[i][silex_ptr.config.itemHeightField]+"' itemExtension='"+ext+"'/>";
			}
			else if(obj[i][silex_ptr.config.itemTypeField] == "folder"){
				//trace("<node label='"+obj[i][silex_ptr.config.itemNameField]+"'>");
				xml_str += "<node itemExtension='folder' itemType='folder' label='"+obj[i][silex_ptr.config.itemNameField]+"'>";
				madeXML(obj[i][silex_ptr.config.itemContentField],path+obj[i][silex_ptr.config.itemNameField]+"/");
				xml_str += "</node>";
				
			}
		}
	}
/*	function iconFunction(item:Object):String {
	    if (item.itemType != "file") {
	        return item.itemType;
	    } 
		else {
	        return item.itemExtension;
	    }
	}*/

	function refresh() {
		super.refresh();
		silex_ptr.com.listFtpFolderContent(silex_ptr.config.websiteFtpRelativeUrl,Utils.createDelegate(this,handleListFtpFolderContent));
    }
	
	public function onLoad(){
		super.onLoad();

		title=silex_ptr.config.TOOL_BOX_TITLE_LIBRARY;
		list.cellRenderer="LibraryCellRenderer";
	}
	
	/**
	 * Function used to retrieve the selected layers.
	 */
	public function getSelectedContent():Object {
		return list.selectedItem;
	}
	
	/**
	 * Function change.
	public function change(evt_obj:Object):Void {
		// trace("change");
	}
	 */
	
	/**
	 * function view.
	 */
	public function view():Void { /// listener sur 
		trace("view");
		if (!list.selectedItem){
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return;
		}
		silex_ptr.interpreter.exec("download:"+urlPath+list.selectedItem.attributes.url,this);
	}
	
	/**
	 * function urlString.
	 */
	public function urlString():Void {
		if (!list.selectedItem){
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
			return;
		}
		else{
			var url_str = urlPath+list.selectedItem.attributes.url;
			System.setClipboard(url_str);
			silex_ptr.utils.alertSimple(silex_ptr.utils.revealAccessors(silex_ptr.config.MESSAGE_COPY_SELECTED_MEDIA_URL,{url:url_str}));
		}
	}
	
	/**
	 * function ftpClient.
	 */
	static public var FtpClientPath:String="tools/FtpClient/index.php";
	public function ftpClient():Void {
		trace("ftpClient");
		var url_str:String=FtpClientPath+"?initialRelativePath="+silex_ptr.config.websiteFtpRelativeUrl;
		var command_str:String="void(window.open('"+url_str+"', '', config='width=700, height=350, toolbar=no, menubar=no, resizable=no, location=no, directories=no, status=no, scrollbars=no'))";
		silex_ptr.com.jsCall(command_str);
	}
}