﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.events.EventDispatcher;

/*
 * events
 */
[Event("show")]
[Event("hide")]

class org.silex.toolbox.Menu extends org.silex.toolbox.MenuBase {
	
	/**
	* Constructor.
	*/
	public function Menu() {
		// parent class
		super();
		
		//silex_ptr.utils.trace("toolbox.Menu constructor "+silex_ptr.toolsManager);

		// event listener to wait for all tools to be loaded
		silex_ptr.toolsManager.addEventListener("onLoadToolsManager",this);

		bg_mc.rightAligned_mc.helpKeys_btn.onRelease = function(){_root.getURL(_global.getSilex().config.HELP_URL_DOCUMENTATION_ROOT+_global.getSilex().config.HELP_URL_WYSIWYG_KEYBOARD_SHORTCUTS,"_blank");};
		bg_mc.rightAligned_mc.help_btn.onRelease = function() { _root.getURL(_global.getSilex().config.HELP_URL_DOCUMENTATION_ROOT + _global.getSilex().config.HELP_URL_WYSIWYG_VIEW_MENU, "_blank"); };
		bg_mc.rightAligned_mc.help_btn.toolName = _global.getSilex().config.TOOL_BOX_BUTTON_TOOLTIP_help_btn;
		bg_mc.rightAligned_mc.helpKeys_btn.toolName = _global.getSilex().config.TOOL_BOX_BUTTON_TOOLTIP_helpKeys_btn;

//		bg_mc.rightAligned_mc.manager_mc._btn.onRelease = function(){_root.getURL(_global.getSilex().rootUrl+"#manager","_blank");};
//		bg_mc.rightAligned_mc.manager_mc.toolName=_global.getSilex().config.TOOL_BOX_MENU_MANAGER_BTN_LABEL;

//		bg_mc.rightAligned_mc.install_mc._btn.onRelease = function(){_root.getURL(_global.getSilex().config.installPath,"_blank");};
//		bg_mc.rightAligned_mc.install_mc.label=_global.getSilex().config.TOOL_BOX_MENU_INSTALL_BTN_LABEL;
//		bg_mc.rightAligned_mc.regenerate_mc._btn.onRelease = function(){_global.getSilex().com.regenerateWebsiteIndex();};
//		bg_mc.rightAligned_mc.regenerate_mc.label=_global.getSilex().config.TOOL_BOX_MENU_REGENERATE_INDEX_BTN_LABEL;
		
		// language selector
		bg_mc.rightAligned_mc.languageSelector_mc.gotoAndStop(getToolsLanguage());
		bg_mc.rightAligned_mc.languageSelector_mc.changeToolsLanguage = Utils.createDelegate(this,changeToolsLanguage);
		bg_mc.rightAligned_mc.xray_btn.onRelease = function(){_root.getURL(_global.getSilex().config.XRAY_URL,"_blank");};
	}
	function onUnload(){
		silex_ptr.toolsManager.removeEventListener("onLoadToolsManager",this);
	}
	function onLoad () {
		// parent class
		super.onLoad();
		
		//silex_ptr.utils.trace("toolbox.Menu onLoad");

		// **
		// icons
		//
		icons_mc.manager_mc._btn.onRelease = function(){_root.getURL(_global.getSilex().rootUrl+"?/manager","_blank");};
		icons_mc.manager_mc.toolName=_global.getSilex().config.TOOL_BOX_MENU_MANAGER_BTN_LABEL;

		icons_mc.hide_btn._visible=false;
		icons_mc.hide_btn.onRelease=Utils.createDelegate(this,hideAll);
		icons_mc.show_btn.onRelease=Utils.createDelegate(this,showAll);
		icons_mc.save_btn.onRelease=Utils.createDelegate(this,saveAll);
		icons_mc.viewScene_btn.onRelease=Utils.createDelegate(this,viewScene);
		icons_mc.hide_btn.toolName=silex_ptr.config.TOOL_BOX_BUTTON_TOOLTIP_HIDE_STANDARD_TOOLS;
		icons_mc.show_btn.toolName=silex_ptr.config.TOOL_BOX_BUTTON_TOOLTIP_SHOW_STANDARD_TOOLS;
		icons_mc.save_btn.toolName=silex_ptr.config.TOOL_BOX_BUTTON_TOOLTIP_SAVE_ALL;
		icons_mc.viewScene_btn.toolName=silex_ptr.config.TOOL_BOX_BUTTON_TOOLTIP_VIEW_BORDERS;
		

		
		// menu tool
		_parent.isNotSeenByMenuTool=true; // so that it is not used by the menu
	}
	/**
	 * onLoadToolsManager
	 * called by listener when all tool are loaded
	 * show an icon for each tool
	 * clip tool boxes in a convenient way
	 */
	var iconsSize:Number=55; // size per icone in pixels - including space between icons
	var xoffset:Number=20;
	var iconsNumber:Number=3;
	function onLoadToolsManager() {
		// show an icon for each tool
		for(var toolName_str:String in _parent._parent){
			if (_parent._parent[toolName_str] instanceof MovieClip && !_parent._parent[toolName_str].isNotSeenByMenuTool && toolName_str.indexOf(".")!=0){
				// check if a tool with the same name exist (workaround reloadbug)
				if (!icons_mc[toolName_str.toLowerCase()]){
					// push down the menu
					_parent._parent[toolName_str]._y=50;
					
					// attach an icon for this tool
					var _mc:MovieClip=icons_mc.attachMovie(toolName_str.toLowerCase()+"_icon",toolName_str.toLowerCase(),icons_mc.getNextHighestDepth());
					//silex_ptr.utils.trace("toolbox.Menu onLoadToolsManager attachMovie 1 - "+_mc);
					if (!_mc) _mc=icons_mc.attachMovie("default_icon",toolName_str.toLowerCase(),icons_mc.getNextHighestDepth());
					//silex_ptr.utils.trace("toolbox.Menu onLoadToolsManager attachMovie 2 - "+_mc);
					if (_mc){
						// reference the tool container
						_mc.toolContainer_mc=_parent._parent[toolName_str];
						// remove the "_tool"
						_mc.toolName=toolName_str.substring(0,toolName_str.lastIndexOf("_tool"));
						// position
						_mc._x=xoffset + iconsNumber*iconsSize;
						// state
						refreshIconState(_mc);
						/*
						// tool tip
						_mc.btnTip = new core.Tooltip(toolName_str);
						_mc.btnTip.tipDelayTime = .2;
						_mc._btn.onRollOver = function() {
							this._parent.btnTip.drawTip();
						};
						_mc._btn.onRollOut = function() {
							this._parent.btnTip.removeTip();
						};*/

						// listeners
						_mc._btn.onRelease=function() {
							this._parent.toolContainer_mc._visible=!this._parent.toolContainer_mc._visible;
							// for tool boxes
							//if (this._parent.toolContainer_mc.main.unClip)
								//this._parent.toolContainer_mc.main.unClip();
								
							// state
							this._parent._parent._parent.refreshIconState(this._parent);
						}
						// update icon number
						iconsNumber++;
					}
				}
			}
			else{
				//silex_ptr.utils.trace("toolbox.Menu onLoadToolsManager - skip "+toolName_str);
			}
		}
		// clip tool boxes in a convenient way
		//_parent._parent.Library._x=0;
		//_parent._parent.Library._y=50;
		var storedInfoSO:SharedObject = SharedObject.getLocal(silex_ptr.config.SHARED_OBJECT_NAME);
		if (!storedInfoSO.data.toolsPostionsArray)
		{
			_parent._parent.library_tool._x = 10;
			_parent._parent.library_tool._y = 10 + bg_mc._height;
			_parent._parent.library_tool.swapDepths(this._parent._parent.getNextHighestDepth());

			//silex_ptr.utils.trace("toolbox.Menu onLoadToolsManager "+_parent._parent.layers_tool._name);
	//		_parent._parent.layers_tool.main.clipTo(_parent._parent.library_tool.main,_parent._parent.library_tool.main.RIGHT_ZONE);
	//		_parent._parent.layers_tool.main.followTo();
			_parent._parent.layers_tool._y = _parent._parent.library_tool._y + 40;
			_parent._parent.layers_tool._x = _parent._parent.library_tool._x + 60;
			_parent._parent.layers_tool.swapDepths(this._parent._parent.getNextHighestDepth());

			//silex_ptr.utils.trace("toolbox.Menu onLoadToolsManager "+_parent._parent.Players._name);
	//		_parent._parent.players_tool.main.clipTo(_parent._parent.library_tool.main,_parent._parent.library_tool.main.BOTTOM_ZONE);
	//		_parent._parent.players_tool.main.followTo();
			_parent._parent.players_tool._y = _parent._parent.layers_tool._y + 40;
			_parent._parent.players_tool._x = _parent._parent.layers_tool._x + 60;
			_parent._parent.players_tool.swapDepths(this._parent._parent.getNextHighestDepth());
			
			//silex_ptr.utils.trace("toolbox.Menu onLoadToolsManager "+_parent._parent.Properties._name);
	//		_parent._parent.properties_tool.main.clipTo(_parent._parent.players_tool.main,_parent._parent.library_tool.main.RIGHT_ZONE);
	//		_parent._parent.properties_tool.main.followTo();
			_parent._parent.properties_tool._y = _parent._parent.players_tool._y + 40;
			_parent._parent.properties_tool._x = _parent._parent.players_tool._x + 60;
			_parent._parent.properties_tool.swapDepths(this._parent._parent.getNextHighestDepth());
		}
		// initialize : show the menu
		//gotoAndStop(_totalframes);
	}
	function refreshIconState(toolIcon_mc:MovieClip) {
		if (toolIcon_mc.toolContainer_mc._visible == true)
		{
			toolIcon_mc._btn._alpha = 0;
			toolIcon_mc.onOff_mc._visible = true;// gotoAndStop("on");
		}
		else
		{
			toolIcon_mc._btn._alpha = 100;
			toolIcon_mc.onOff_mc._visible = false;//.gotoAndStop("off");
		}		
	}
	/* refresh
	 * this function should be overriden in derived classes
	 */
	function refresh(){
		//silex_ptr.utils.trace("toolbox.Menu refresh");
		
		// **
		// bg_mc & mask_mc
		//
		// set size and position
		bg_mc.container_mc._width=Stage.width;
		bg_mc.rightAligned_mc._x=Stage.width-bg_mc.rightAligned_mc._width;
		mask_mc._width=Stage.width;
		
		_parent._y=_parent._x=0;
		
		stop();
	}
	/* isActive
	 * this function should be overriden in derived classes
	 * called in org.silex.toolbox.MenuBase::_onEnterFrame
	 */
	function isActive():Boolean{
		if (_ymouse>bg_mc._height && isActive_bool==true){
			//silex_ptr.utils.trace("toolbox.Menu isActive - dispatchEvent hide");
			dispatchEvent({type:"hide",target:this});
			return false;
		}
		if (_ymouse<bg_mc._height/8 && isActive_bool==false){
			_parent.swapDepths(_parent._parent.getNextHighestDepth());
			//silex_ptr.utils.trace("toolbox.Menu isActive - dispatchEvent show");
			dispatchEvent({type:"show",target:this});
			return true;
		}
		return isActive_bool;
	}

	function hideAll() {
		showStandardTools(false);
	}
	function showAll() {
		showStandardTools(true);
	}
	function showStandardTools(isVisible:Boolean) {
		// ui
		icons_mc.show_btn._visible=!isVisible;
		icons_mc.hide_btn._visible=isVisible;
		/*
		// show/hide all tools
		for(var toolName_str:String in _parent._parent){
			if (!_parent._parent[toolName_str].isNotSeenByMenuTool){
				// show/hide
				_parent._parent[toolName_str]._visible=isVisible;
				// icon state
				refreshIconState(icons_mc[toolName_str.toLowerCase()]);
			}
		}
		*/
		// show/hide standard tools
		_parent._parent.layers_tool._visible=isVisible;
		_parent._parent.players_tool._visible=isVisible;
		_parent._parent.library_tool._visible=isVisible;
		_parent._parent.properties_tool._visible=isVisible;
		// icon states
		refreshIconsStates();
	}

	// refreshIconsStates
	// for all tools, show hided or visible state
	function refreshIconsStates(){
		for(var toolName_str:String in _parent._parent){
			if (!_parent._parent[toolName_str].isNotSeenByMenuTool){
				// icon state
				refreshIconState(icons_mc[toolName_str.toLowerCase()]);
			}
		}
	}

	// save all application's layouts
	function saveAll(){
		// save all application's layouts
		for (var idxLayout:Number=0;idxLayout<silex_ptr.application.layouts.length;idxLayout++){
			// silex_ptr.utils.trace("toolbox.Menu saveAll "+idxLayout.toString()+" - "+silex_ptr.application.layouts[idxLayout]);
			if (silex_ptr.application.layouts[idxLayout])
				silex_ptr.application.save(silex_ptr.application.layouts[idxLayout]);
		}
	}
	var isSceneBorderVisible:Boolean=false;
	function viewScene() {
		if (isSceneBorderVisible==true)
			sceneBorder_mc.removeMovieClip();
		else
			attachMovie("sceneBorder","sceneBorder_mc",getNextHighestDepth());
			
		isSceneBorderVisible=!isSceneBorderVisible;
	}
	/* getToolsLanguage
	 * retrieve tools language
	 */
	function getToolsLanguage():String{
		return silex_ptr.toolsManager.toolsLanguage;
	}
	/* changeToolsLanguage
	 * reload tools in a new language
	 */
	function changeToolsLanguage(newLanguage:String){
		//(workaround reloadbug)
		return;
		
		//bg_mc.rightAligned_mc.languageSelector_mc.gotoAndStop(getToolsLanguage());
		/*for (var iconName in icons_mc){
			icons_mc[iconName].removeMovieClip();
		}*/
		icons_mc.removeMovieClip();
		silex_ptr.toolsManager.reloadTools(newLanguage);
		
		// (workaround reloadbug)
		_parent._parent._visible=false;
		_parent._parent._name="old_toolsManager_"+Math.round(Math.random()*100000);
		_parent._parent._parent.createEmptyMovieClip("toolsManager",_parent._parent._parent.getNextHighestDepth());
	}
}
