﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.events.EventDispatcher;

/*
 * events
 */
[Event("show")]
[Event("hide")]

class org.silex.toolbox.MenuBase extends mx.core.UIComponent {
	/**
	 * ref to silex api
	 */
	private var silex_ptr/*:org.silex.core.Api*/;
	/**
	 * UI
	 */
	var bg_mc:MovieClip;
	var icons_mc:MovieClip;
	var mask_mc:MovieClip;
	var sceneBorder_mc:MovieClip;

	/* isActive_bool
	 * active or inactive state (visible or not)
	 */
	var isActive_bool:Boolean=true;

	/**
	* Constructor.
	*/
	public function MenuBase() {
		// ref to silex api
		silex_ptr=_global.getSilex(this);
		//silex_ptr.utils.trace("org.silex.toolbox.MenuBase constructor");

		//eventDispatcher
		EventDispatcher.initialize(this);
	}
	function onLoad () {
		super.onLoad();

		//silex_ptr.utils.trace("org.silex.toolbox.MenuBase onLoad");

		// listeners
		var appListener_obj:Object=new Object;
		appListener_obj.resize=Utils.createDelegate(this,refresh);
		silex_ptr.application.addEventListener("resize",appListener_obj);
		
		// initialize : show the menu
		gotoAndStop(_totalframes);
		
		// refresh
		refresh();
		onEnterFrame=_onEnterFrame;
		
		// **
		// icons
		//
/*		icons_mc.hide_btn._visible=false;
		icons_mc.hide_btn.onRelease=Utils.createDelegate(this,hideAll);
		icons_mc.hide_btn.toolName="Hide standard tools";
		icons_mc.show_btn.onRelease=Utils.createDelegate(this,showAll);
		icons_mc.show_btn.toolName="Show standard tools";
		icons_mc.save_btn.onRelease=Utils.createDelegate(this,saveAll);
		icons_mc.save_btn.toolName="Save all layers";
		icons_mc.viewScene_btn.onRelease=Utils.createDelegate(this,viewScene);
		icons_mc.viewScene_btn.toolName="View scene borders";
		*/
	}
	
	/* refresh
	 * adapt to the stage size
	 * this function should be overriden in derived classes
	 */
	function refresh(){
		//silex_ptr.utils.trace("org.silex.toolbox.MenuBase refresh");
		
		// **
		// bg_mc & mask_mc
		//
		// set size and position
		bg_mc.container_mc._width=Stage.width;
		bg_mc.rightAligned_mc._x=Stage.width-bg_mc.rightAligned_mc._width;
		mask_mc._width=Stage.width;
		
		_parent._y=Stage.height-bg_mc._height;
		_parent._x=0;
		
		stop();
	}

	/* _onEnterFrame
	 * goto the frame corresponding to the active or inactive state
	 */
	function _onEnterFrame() {
		//silex_ptr.utils.trace("org.silex.toolbox.MenuBase _onEnterFrame "+_currentframe+"-"+_totalframes+"-"+isActive+"-"+_ymouse);
		
		// update active state
		isActive_bool=isActive();
		
		// goto the desired frame
		if (isActive_bool==true){
			icons_mc._visible=true;
			if (_currentframe<_totalframes)
				gotoAndStop(_currentframe+1);
		}
		else{
			icons_mc._visible=false;
			if (_currentframe>1)
				gotoAndStop(_currentframe-1);
		}
	}
	
	/* isActive
	 * this function should be overriden in derived classes
	 * called in org.silex.toolbox.MenuBase::_onEnterFrame
	 */
	function isActive():Boolean{
		// for example : show from bottom of the screen
		if (_ymouse<0 && isActive_bool==true){
			//silex_ptr.utils.trace("org.silex.toolbox.MenuBase isActive - dispatchEvent hide");
			dispatchEvent({type:"hide",target:this});
			return false;
		}
		if (_ymouse>0 && isActive_bool==false){
			_parent.swapDepths(_parent._parent.getNextHighestDepth());
			//silex_ptr.utils.trace("org.silex.toolbox.MenuBase isActive - dispatchEvent show");
			dispatchEvent({type:"show",target:this});
			return true;
		}
		return isActive_bool;
	}
}
