﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.controls.List;
/*
addContextPlayerAccepted_btn
delContextPlayerAccepted_btn
contextPlayerAccepted_lst

addContextPlayerRejected_btn
delContextPlayerRejected_btn
contextPlayerRejected_lst

addContextGlobal_btn
delContextGlobal_btn
contextGlobal_lst
*/
/**
 * MultiContextTool toolbox
 */
class org.silex.toolbox.MultiContextTool extends org.silex.toolbox.Toolbox{
	
	/* ContextPlayerAccepted UIs
	 * UIs for the player's accepted contexts
	 */
	var addContextPlayerAccepted_btn:Button;
	var delContextPlayerAccepted_btn:Button;
	var contextPlayerAccepted_lst:List;

	/* ContextPlayerRejected UIs
	 * UIs for the player's Rejected contexts
	 */
	var addContextPlayerRejected_btn:Button;
	var delContextPlayerRejected_btn:Button;
	var contextPlayerRejected_lst:List;

	/* ContextGlobal UIs
	 * UIs for the global context
	 */
	var applyGlobalContext_btn:Button;
	var contextGlobal_lst:List;
	
	var addAllContextPlayerAccepted_btn:Button;
	
	/* currentSelectedContext_str
	 * displayed string
	 */
	var currentSelectedContext_str:String="";
	var currentSelectedContext_txt:TextField;
	var scroll_mc:MovieClip;

	public function onLoad(){
		super.onLoad();
		
		// UIs
		currentSelectedContext_txt.wordWrap=false;
	
		// events
		addContextPlayerAccepted_btn.onRelease=Utils.createDelegate(this,addContextPlayerAccepted);
		delContextPlayerAccepted_btn.onRelease=Utils.createDelegate(this,delContextPlayerAccepted);
		contextPlayerAccepted_lst.addEventListener("change",{change:Utils.createDelegate(this,changeContextPlayerAccepted)});

		addContextPlayerRejected_btn.onRelease=Utils.createDelegate(this,addContextPlayerRejected);
		delContextPlayerRejected_btn.onRelease=Utils.createDelegate(this,delContextPlayerRejected);
		contextPlayerRejected_lst.addEventListener("change",{change:Utils.createDelegate(this,changeContextPlayerRejected)});

		applyGlobalContext_btn.onRelease=Utils.createDelegate(this,applyGlobalContext);
		contextGlobal_lst.addEventListener("change",{change:Utils.createDelegate(this,changeContextGlobal)});
		
		addAllContextPlayerAccepted_btn.onRelease=Utils.createDelegate(this,addAllContextPlayerAccepted);

		// DEBUG
		//globalContext_array=[{label:"fr",data:1},{label:"nl",data:2},{label:"proximus",data:3},{label:"belgacom",data:4},{label:"proximus/belgacom",data:5}];
		
		//globalContext_array=["fr","nl","proximus","belgacom","proximus/belgacom"];
		//contextGlobal_lst.dataProvider=globalContext_array;

		// fill the global context list
		//refresh();
	}

	/* refresh
	 * fill the lists
	 */
	function refresh(){
		// **
		// empty the lists
		//contextPlayerAccepted_lst.removeAll();
		//contextPlayerRejected_lst.removeAll();

		// **
		// fill the lists
		
	}
	
	/* change
	 * selection changed in contextGlobal_lst
	 * check if the selection corresponds to a context in contextPlayerRejected_lst or in contextPlayerAccepted_lst
	 */
	function changeContextGlobal(ev:Object){
		silex_ptr.utils.trace("toolbox.MultiContextTool changeContextGlobal "+ev.target.selectedItems[0]+" - "+ev.target.selectedItems[0]);
		
		// global selection
/*		var globalSelection_array:Array=new Array;
		for(var idx:Number=0;idx<ev.target.selectedItems.length;idx++){
			silex_ptr.utils.trace("toolbox.MultiContextTool changeContextGlobal "+idx+" - "+ev.target.selectedItems[idx]+" - "+ev.target.selectedItems[idx].label);
			globalSelection_array.push(ev.target.selectedItems[idx].label);
		}*/
			
		// contextPlayerAccepted_lst
		var selection_array:Array=new Array;
		for(var idx:Number=0;idx<contextPlayerAccepted_lst.length;idx++){
			//trace (idx+" - "+contextPlayerAccepted_lst.getItemAt(idx).label.split(",")+" - "+silex_ptr.utils.isPartOf(contextPlayerAccepted_lst.getItemAt(idx).label.split(","),ev.target.selectedItems));
			if (silex_ptr.utils.isPartOf(contextPlayerAccepted_lst.getItemAt(idx).label.split(","),ev.target.selectedItems)){
				selection_array.push(idx);
			}
		}
		contextPlayerAccepted_lst.selectedIndices=selection_array;
		contextPlayerAccepted_lst.invalidate();
		
		// contextPlayerRejected_lst
		var selection_array:Array=new Array;
		for(var idx:Number=0;idx<contextPlayerRejected_lst.length;idx++){
			//trace (idx+" - "+contextPlayerRejected_lst.getItemAt(idx).label.split(",")+" - "+silex_ptr.utils.isPartOf(contextPlayerRejected_lst.getItemAt(idx).label.split(","),ev.target.selectedItems));
			if (silex_ptr.utils.isPartOf(contextPlayerRejected_lst.getItemAt(idx).label.split(","),ev.target.selectedItems)){
				selection_array.push(idx);
			}
		}
		contextPlayerRejected_lst.selectedIndices=selection_array;
		contextPlayerRejected_lst.invalidate();
	}
	
	/* changeContextPlayerAccepted
	 * display the current selected context
	 */
	function changeContextPlayerAccepted(ev:Object){
		silex_ptr.utils.trace("toolbox.MultiContextTool changeContextPlayerAccepted ev="+ev+" - target="+ev.target+" | "+ev.target.selectedItem+" - "+ev.target.selectedItem.label+" - old : "+currentSelectedContext_str);
		if (ev.target.selectedItem.label)
			currentSelectedContext_str=ev.target.selectedItem.label.split(",").join("<br>");
		scroll_mc.invalidate();
	}
	/* changeContextPlayerRejected
	 * display the current selected context
	 */
	function changeContextPlayerRejected(ev:Object){
		if (ev.target.selectedItem.label)
			currentSelectedContext_str=ev.target.selectedItem.label.split(",").join("<br>");
		scroll_mc.invalidate();
	}
	/////////////////////////////////////////////
	/* addAllContextPlayerAccepted
	 * adds a "*" in the player context
	 */
	function addAllContextPlayerAccepted(){
		contextPlayerAccepted_lst.addItem("*");
	}

	/* addContextPlayerAccepted
	 * adds a context in the player context
	 */
	function addContextPlayerAccepted(){
		contextPlayerAccepted_lst.addItem(contextGlobal_lst.selectedItems.toString());
	}
	/* delContextPlayerAccepted
	 * remove a context in the player context
	 */
	function delContextPlayerAccepted(){
		contextPlayerAccepted_lst.removeItemAt(contextPlayerAccepted_lst.selectedIndex);
	}
	/* addContextPlayerRejected
	 * adds a rejected context in the player context
	 */
	function addContextPlayerRejected(){
		contextPlayerRejected_lst.addItem(contextGlobal_lst.selectedItems.toString());
	}
	/* delContextPlayerRejected
	 * remove a rejected context in the player context
	 */
	function delContextPlayerRejected(){
		contextPlayerRejected_lst.removeItemAt(contextPlayerAccepted_lst.selectedIndex);
	}
	/* applyGlobalContext
	 * apply the global context to this website and save the website config
	 */
	function applyGlobalContext(){
	}
	//////////////////////////////////////////////////
	/* updateArrayFromList
	 * empty  the array and fill it with the content of the list
	 */
	function updateArrayFromList(_array:Array,_lst:List){
		if (!_array) _array=new Array();
		// empty the array
		while (_array.shift()){}
		
		// fill the array
		for (var i=0;i<_lst.length;i++){
			_array.push(_lst.getItemAt(i).label);
		}
		return _array;
	}
}