﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.controls.List;

/**
 * PlayerMultiContextTool toolbox
 */
class org.silex.toolbox.PlayerMultiContextTool extends org.silex.toolbox.MultiContextTool {
	
	var _txt:TextField;
	var label:String="";

	
	/**
	 * Constructor. 
	 * Add a listener on change event of toolbox players and call this onLoad method.
	 */
	public function PlayerMultiContextTool(){
		super();
		
	}
	function allToolsLoaded() {
		super.allToolsLoaded();
		var refreshListener = new Object();
		refreshListener.change = Utils.createDelegate(this,refresh);
		_parent._parent.players_tool.main.addEventListener("change",refreshListener);
	}
	
	public function onLoad(){
		super.onLoad();
		
		title=silex_ptr.config.TOOL_BOX_TITLE_MULTICONTEXT;
		
		silex_ptr.utils.trace("toolbox.PlayerMultiContextTool onLoad "+_global.getSilex().config.AVAILABLE_CONTEXTS_LIST);
		
		// init
		refresh();
	}

	/**
	 * Defined the change event for the list. 
	 */
	public function refresh(){
		super.refresh();
		
		// context list
		var globalContextList_array:Array=_global.getSilex().config.AVAILABLE_CONTEXT_LIST.split(",");
		contextGlobal_lst.dataProvider=globalContextList_array;

		// **
		// empty the lists
		contextPlayerAccepted_lst.removeAll();
		contextPlayerRejected_lst.removeAll();
/*		contextPlayerAccepted_lst.dataProvider=[];
		contextPlayerRejected_lst.dataProvider=[{label:"xx"}];
*/
		var globalContext_array:Array=silex_ptr.config.globalContext.split(",");

		// **
		// fill the lists
		var currentPlayerObject = _parent._parent.players_tool.main.getSelectedContent();
		//var currentLayer = _parent._parent.layers_tool.main.getSelectedContent();
		//silex_ptr.utils.trace("toolbox.PlayerMultiContextTool refresh "+globalContext_array+" - "+currentPlayerObject+" - "+currentPlayerObject.contextAccepted+" - "+currentPlayerObject.contextRejected);
		if (currentPlayerObject){
			// fill the lists with player data
			//no because it links the dataProvider to the array :  contextPlayerAccepted_lst.dataProvider=currentPlayerObject.contextAccepted;		
/**/			for (var i=0;i<currentPlayerObject.contextAccepted.length;i++){
				//silex_ptr.utils.trace("toolbox.PlayerMultiContextTool refresh "+i+" - "+currentPlayerObject.contextAccepted[i]);
				contextPlayerAccepted_lst.addItem(currentPlayerObject.contextAccepted[i]);
			}
/**/
			// rejected
			// no because it links the dataProvider to the array : contextPlayerRejected_lst.dataProvider=currentPlayerObject.contextRejected;
/**/			for (var i=0;i<currentPlayerObject.contextRejected.length;i++){
				//silex_ptr.utils.trace("toolbox.PlayerMultiContextTool refresh "+i+" - "+currentPlayerObject.contextRejected[i]);
				contextPlayerRejected_lst.addItem(currentPlayerObject.contextRejected[i]);
			}
/**/
		}
		else{
			// show the global context
			var selection_array:Array=new Array;
			for(var idx:Number=0;idx<contextGlobal_lst.length;idx++){
				//trace (idx+" - "+contextPlayerAccepted_lst.getItemAt(idx).label.split(",")+" - "+silex_ptr.utils.isPartOf(contextPlayerAccepted_lst.getItemAt(idx).label.split(","),ev.target.selectedItems));
				//silex_ptr.utils.trace("toolbox.MultiContextTool refresh "+contextGlobal_lst.getItemAt(idx)+" - "+contextGlobal_lst.getItemAt(idx).label);
				if (silex_ptr.utils.isPartOf([contextGlobal_lst.getItemAt(idx)],globalContext_array)){
					selection_array.push(idx);
				}
			}
			contextGlobal_lst.selectedIndices=selection_array;
			contextGlobal_lst.invalidate();
		}
		
		contextPlayerAccepted_lst.invalidate();
		contextPlayerRejected_lst.invalidate();
		dispatchEvent({type:"change",target:this});
		//list.labelField="description";
	}
	
	/**
	 * Function used to retrieve the selected content.
	 */
	public function getSelectedContent():Array {
		return contextGlobal_lst.selectedItems;
	}
	/////////////////////////////////////////////////////////////////////////////////////////////
	/* changeContextPlayerAccepted
	 * display the current selected context
	 */
	function changeContextPlayerAccepted(ev:Object){
		super.changeContextPlayerAccepted(ev);
		
		// debug
		var currentPlayerObject = _parent._parent.players_tool.main.getSelectedContent();
		silex_ptr.utils.trace("toolbox.PlayerMultiContextTool changeContextPlayerAccepted "+currentPlayerObject._name+" - "+currentPlayerObject.name+" - "+currentPlayerObject.contextAccepted);
	}
	/* changeContextPlayerRejected
	 * display the current selected context
	 */
	function changeContextPlayerRejected(ev:Object){
		super.changeContextPlayerRejected(ev);
	}
	////////////////////////////
	
	/* addAllContextPlayerAccepted
	 * adds a "*" in the player context
	 */
	function addAllContextPlayerAccepted(){
		var currentPlayerObject = _parent._parent.players_tool.main.getSelectedContent();
		if (currentPlayerObject){
			super.addAllContextPlayerAccepted();
			currentPlayerObject.contextAccepted=updateArrayFromList(currentPlayerObject.contextAccepted,contextPlayerAccepted_lst);
			// refresh Current Layer
			_parent._parent.layers_tool.main.getSelectedContent().refresh();
		}
		else{
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
		}
	}

	/* addContextPlayerAccepted
	 * adds a context in the player context
	 */
	function addContextPlayerAccepted(){
		var currentPlayerObject = _parent._parent.players_tool.main.getSelectedContent();
		silex_ptr.utils.trace("toolbox.PlayerMultiContextTool addContextPlayerAccepted "+currentPlayerObject._name+" - "+currentPlayerObject.name+" - "+currentPlayerObject.contextAccepted+" - "+contextPlayerAccepted_lst.dataProvider);
		if (currentPlayerObject){
			super.addContextPlayerAccepted();
			currentPlayerObject.contextAccepted=updateArrayFromList(currentPlayerObject.contextAccepted,contextPlayerAccepted_lst);
			// refresh Current Layer
			_parent._parent.layers_tool.main.getSelectedContent().refresh();
		}
		else{
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
		}
	}
	/* delContextPlayerAccepted
	 * remove a context in the player context
	 */
	function delContextPlayerAccepted(){
		var currentPlayerObject = _parent._parent.players_tool.main.getSelectedContent();
		silex_ptr.utils.trace("toolbox.PlayerMultiContextTool delContextPlayerAccepted "+currentPlayerObject._name+" - "+currentPlayerObject.name+" - "+currentPlayerObject.contextAccepted+" - "+contextPlayerAccepted_lst.dataProvider);
		if (currentPlayerObject){
			super.delContextPlayerAccepted();
			currentPlayerObject.contextAccepted=updateArrayFromList(currentPlayerObject.contextAccepted,contextPlayerAccepted_lst);
			// refresh Current Layer
			_parent._parent.layers_tool.main.getSelectedContent().refresh();
		}
		else{
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
		}
	}
	/* addContextPlayerRejected
	 * adds a rejected context in the player context
	 */
	function addContextPlayerRejected(){
		var currentPlayerObject = _parent._parent.players_tool.main.getSelectedContent();
		silex_ptr.utils.trace("toolbox.PlayerMultiContextTool addContextPlayerRejected "+currentPlayerObject._name+" - "+currentPlayerObject.name+" - "+currentPlayerObject.contextRejected+" - "+contextPlayerRejected_lst.dataProvider);
		if (currentPlayerObject){
			super.addContextPlayerRejected();
			currentPlayerObject.contextRejected=updateArrayFromList(currentPlayerObject.contextRejected,contextPlayerRejected_lst);
			// refresh Current Layer
			_parent._parent.layers_tool.main.getSelectedContent().refresh();
		}
		else{
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
		}
	}
	/* delContextPlayerRejected
	 * remove a rejected context in the player context
	 */
	function delContextPlayerRejected(){
		var currentPlayerObject = _parent._parent.players_tool.main.getSelectedContent();
		silex_ptr.utils.trace("toolbox.PlayerMultiContextTool delContextPlayerRejected "+currentPlayerObject._name+" - "+currentPlayerObject.name+" - "+currentPlayerObject.contextRejected+" - "+contextPlayerRejected_lst.dataProvider);
		if (currentPlayerObject){
			super.delContextPlayerRejected();
			currentPlayerObject.contextRejected=updateArrayFromList(currentPlayerObject.contextRejected,contextPlayerRejected_lst);
			// refresh Current Layer
			_parent._parent.layers_tool.main.getSelectedContent().refresh();
		}
		else{
			silex_ptr.utils.alertSimple(silex_ptr.config.ERROR_NO_SELECTION);
		}
	}
	/* applyGlobalContext
	 * apply the global context to this website and save the website config
	 */
	function applyGlobalContext(){
		silex_ptr.utils.trace("toolbox.PlayerMultiContextTool applyGlobalContext "+contextGlobal_lst.selectedItems.toString());
		silex_ptr.config.globalContext=contextGlobal_lst.selectedItems.toString();
		refresh();
		// refresh Current Layer
		//_parent._parent.layers_tool.main.getSelectedContent().refresh();
	}
}