﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.controls.List;
import mx.controls.NumericStepper;

[Event("change")]
/**
 * Properties toolbox
 */
class org.silex.toolbox.Properties extends org.silex.toolbox.Toolbox {
	
	public var oldValue;  // an array to memorize the old value
	// To link with a Player (to test)
	//public var currentPlayer:MovieClip; // a movie clip to memorize the current player
	var tabs_mc:MovieClip;
	/**
	 * Constructor. 
	 * Add a listener on change event of toolbox players and call this onLoad method.
	 */
	public function Properties(){
		trace("New Properties");
		ui_mc.help_btn.onRelease = function(){_root.getURL(_global.getSilex().config.HELP_URL_DOCUMENTATION_ROOT+_global.getSilex().config.HELP_URL_WYSIWYG_PROPERTIES,"_blank");};
	}
	function allToolsLoaded() {
		super.allToolsLoaded();
			var refreshListener = new Object();
			refreshListener.change = Utils.createDelegate(this,refresh);
			_parent._parent.players_tool.main.addEventListener("change",refreshListener);
	}
	
	public function onLoad(){
		super.onLoad();

		title=silex_ptr.config.TOOL_BOX_TITLE_PROPERTIES;
		refresh();
		// Defined the change event for the list.
		var listListener:Object = new Object();
		listListener.change = Utils.createDelegate(this, change);
		list.addEventListener("change", listListener);
		
		tabs_mc.onChange = Utils.createDelegate(this, refresh);
	}
	
	/**
	 * Defined the change event for the list. 
	 * Check the properties list by the getSelectedContent method of players toolbox.
	 */
	public function refresh(){
		super.refresh();

		//silex_ptr.utils.trace("toolbox.Properties refresh properties");
		var currentPlayerName = _parent._parent.players_tool.main.getSelectedContent()._name;
		var currentLayer = _parent._parent.layers_tool.main.getSelectedContent();
		trace(_parent._parent.layers_tool.main.getSelectedContent());
		var currentPlayer=currentLayer[currentPlayerName].main;

		//silex_ptr.utils.trace("toolbox.Properties refresh currentPlayer : "+currentPlayer._name);
		list.dataProvider= null;
		for(var i=0; i<currentPlayer.editableProperties.length; i++){
			if (currentPlayer.editableProperties[i].group==tabs_mc.selectedItem.label || tabs_mc.selectedItem.label=="all" || ((!currentPlayer.editableProperties[i].group || currentPlayer.editableProperties[i].group=="") && tabs_mc.selectedItem.label=="others"))
				list.addItem({label:currentPlayer.editableProperties[i].description, data:currentPlayer.editableProperties[i]});
			//list.addItem({name:currentPlayer.editableProperties[i].name, label:currentPlayer.editableProperties[i].label, type:currentPlayer.editableProperties[i].type});
		}

		dispatchEvent({type:"change",target:this});
		//list.labelField="description";
	}
	
	/**
	 * Function used to retrieve the selected properties.
	 *@return object with defaultValue, description, group, isRegistered, name, type
	 */
	public function getSelectedContent():Array {
		return list.selectedItem.data;
	}
	
	/**
	 * Call at each click on the list to show the editor with a good type
	 * Call showEditor with "evt_obj.target.selectedItem"
	 * @param  evt_obj  the event object
	 */
	public function change(evt_obj:Object):Void {
		var currentPlayerName = _parent._parent.players_tool.main.getSelectedContent()._name;
		var currentLayer = _parent._parent.layers_tool.main.getSelectedContent();
		var currentPlayer=currentLayer[currentPlayerName].main;
		var propertyName=evt_obj.target.selectedItem.data.name;

		//showEditor(evt_obj.target.selectedItem.data,currentPlayer);
		//resize(resize_btn._x,resize_btn._y+resize_btn._height);
		dispatchEvent({type:"change",target:this,callback:Utils.createDelegate(this,apply),propertyType:evt_obj.target.selectedItem.data.type,value:currentPlayer[propertyName],data:{player:currentPlayer,layer:currentLayer,propertyName:propertyName}});
	}
/*
	public function showEditor(property:Object,player:MovieClip):Void {
		// hide the curently displayed editor
		hideEditor();

		// put on top of other tools
		_parent.swapDepths(_parent._parent.getNextHighestDepth());
		
		// init object
		var sItem_obj:Object = new Object();
		sItem_obj.property = property;
		sItem_obj.description=sItem_obj.property.description;
		sItem_obj.player = player;
		sItem_obj.initValue = player[property.name];
		sItem_obj.toolbox_ptr = this;
		
		// attach property editor
		ui_mc.attachMovie(property.type+"_editor", "editor_mc", 1,sItem_obj);
		//shape_mc._height = resize_btn._y + ui_mc._height;
	}
	
*/
	/**
	 * Set the value property. 
	* @param   data    object passed by the properties toolbox components, 
	 */
	public function apply(data:Object,value):Void {
		data.player[data.propertyName]=value;

		if (data.propertyName=="playerName"){
			_parent._parent.players_tool.main.getSelectedContent().label=value;
			_parent._parent.players_tool.main.list.refresh();
		}
		// set layout as dirty
		silex_ptr.application.getLayout(data.player).isDirty=true;
		
		// event
		dispatchEvent({type:"change"});
	}
}