﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.events.EventDispatcher;

/*
 * events
 */
[Event("show")]
[Event("hide")]

class org.silex.toolbox.PropertyEditorsToolMenu extends org.silex.toolbox.MenuBase {
	
	/* currentProperty_obj
	 * object of the current property in the player's availableProperty array
	 * defaultValue, isRegistered, type, description, name, group, minValue, maxValue
	 */
	var currentProperty_obj:Object;
	
	/* initialValue
	 * initial value of the current property
	 */
	var initialValue;
	
	/* propertyEditor_mc
	 * container for the property editors
	 */
	var propertyEditor_mc:MovieClip;
	
	/* callback
	 * function to be called with a result value
	 * passed by the tool box in the change event
	 */
	var callback:Function;
	
	function onLoad () {
		// parent class
		super.onLoad();

		// **
		// btn
		//
		bg_mc.rightAligned_mc.close_btn.onRelease=Utils.createDelegate(this,closeMenu);
		bg_mc.resize_mc.resize_btn.onPress=function() {
			_parent._parent._parent.swapDepths(_parent._parent._parent._parent.getNextHighestDepth());
			this._parent.startDrag(false,0,-10000,0,10000);
			this._parent.onEnterFrame=function() {
				_parent.container_mc._height-=_y;
				_parent._parent.mask_mc._height=_parent.container_mc._height;
				_y=0;
				_parent._parent.refresh();
			}
		}
		bg_mc.resize_mc.resize_btn.onRelease=bg_mc.resize_mc.resize_btn.onReleaseOutside=function() {
			this._parent.stopDrag();
			this._parent.onEnterFrame=undefined;
		}
		
		// to avoid clicking silex background through the menu
		bg_mc.container_mc.useHandCursor=false;
		bg_mc.container_mc.onRelease=function (){
			_parent._parent._parent.swapDepths(_parent._parent._parent._parent.getNextHighestDepth());
		};
		
		// menu tool
		_parent.isNotSeenByMenuTool=true; // so that it is not used by the menu

		// event listener to wait for all tools to be loaded
		var toolsManagerListener:Object=new Object;
		toolsManagerListener.onLoadToolsManager=Utils.createDelegate(this,allToolsLoaded);
		silex_ptr.toolsManager.addEventListener("onLoadToolsManager",toolsManagerListener);
		
		// hide menu at the beginning
		gotoAndStop(1);
		closeMenu();
		
		// bg color = website bg color
		if (silex_ptr.config.bgColor){
			propEditorsBgColor=silex_ptr.config.bgColor;
		}

	}
	function allToolsLoaded() {
		// **
		// tool boxes listener
		_parent._parent.properties_tool.main.addEventListener("change",this);
		_parent._parent.website_tool.main.addEventListener("change",this);
	}

	/* refresh
	 * adapt to the stage size
	 * this function should be overriden in derived classes
	 */
	function refresh(){
		// bg color = website bg color
		//if (propEditorsBgColor!=undefined)
		{
			var _color:Color=new Color(bg_mc.container_mc.color_mc);
			_color.setRGB(parseInt(propEditorsBgColor,16));
		}
		// **
		// bg_mc & mask_mc
		//
		// set size and position
		bg_mc.container_mc._width=Stage.width;
		bg_mc.rightAligned_mc._x=Stage.width-bg_mc.rightAligned_mc._width;
		mask_mc._width=Stage.width;
		bg_mc.resize_mc.resize_btn._x=bg_mc.resize_mc.resize_btn._y=0;
		bg_mc.resize_mc.resize_btn._width=mask_mc._width-bg_mc.rightAligned_mc._width;

		// refresh property editor
		if (propertyEditor_mc && propertyEditor_mc.setSize)
			propertyEditor_mc.setSize(bg_mc.container_mc._width,bg_mc.container_mc._height);
		
		_parent._y=Stage.height-bg_mc._height;
		_parent._x=0;
		
		stop();
	}

	/* isActive
	 * this function should be overriden in derived classes
	 * called in org.silex.toolbox.MenuBase::_onEnterFrame
	 */
	function isActive():Boolean{
		return isActive_bool;
	}
	
	/* change 
	 * tool box selection changed
	 * ev.target	the tool box
	 * ev.value 	the initail value
	 * ev.propertyType	the type of property 
	 * ev.data 	to be passed to the callback function
	 * ev.callback	the function receiving the result
	 */
	function change (ev) {
		var _obj:Object=ev.target.getSelectedContent();
		// 
		if (_obj){
			if (ev.data){
				// pointers
				currentProperty_obj=ev.data;
				callback=ev.callback;

				// retrieve initial value
				initialValue=ev.value;

				if (propertyEditor_mc) propertyEditor_mc.removeMovieClip();

				//silex_ptr.utils.trace("toolbox.Menu change "+ev.propertyType+" - "+callback+" - "+currentProperty_obj+" - "+currentProperty_obj.name+" - "+ev.value);
		var currentPlayerName:String = _parent._parent.players_tool.main.getSelectedContent()._name;
		var currentLayer/*:org.silex.ui.Layer*/ = _parent._parent.layers_tool.main.getSelectedContent();
		var currentPlayer/*:org.silex.ui.players.PlayerBase*/=currentLayer[currentPlayerName].main;

				propertyEditor_mc=attachMovie(ev.propertyType+"_editor", "propertyEditor_mc",getNextHighestDepth(),{owner:this,_x:10,_y:10,width:bg_mc.container_mc._width,height:bg_mc.container_mc._height,player:currentPlayer});
				propertyEditor_mc.setSize(bg_mc.container_mc._width,bg_mc.container_mc._height);

				// show background if it is not html text
				if (ev.propertyType == silex_ptr.constants.PROPERTIES_TYPE_RICHTEXT)
					setIsActive(false);
				else
					setIsActive(true);
			}
		}
		else{
			setIsActive(false);
			if (propertyEditor_mc) propertyEditor_mc.removeMovieClip();
			
			// pointers
			currentProperty_obj=null;
			callback=null;
		}
	}
	function setIsActive (newIsActive:Boolean) {
		_parent.swapDepths(_parent._parent.getNextHighestDepth());
		if (newIsActive==false && isActive_bool==true){
			//silex_ptr.utils.trace("toolbox.Menu isActive - dispatchEvent hide");
			dispatchEvent({type:"hide",target:this});
		}
		else if (newIsActive==true && isActive_bool==false){
			//silex_ptr.utils.trace("toolbox.Menu isActive - dispatchEvent show");
			dispatchEvent({type:"show",target:this});
		}
		isActive_bool=newIsActive;
	}
	function closeMenu () {
		setIsActive(false);
		if (propertyEditor_mc) propertyEditor_mc.removeMovieClip();
		currentProperty_obj=undefined;
	}
	function changePropertyValue(newValue:Object) {
		if(callback)
			callback(currentProperty_obj,newValue);
	}
	function resetPropertyValue() {
		if(callback)
			callback(currentProperty_obj,initialValue);
	}
	var _propEditorsBgColor:String;
	function set propEditorsBgColor(color_str:String){
		_propEditorsBgColor=color_str;
		refresh();
	}
	function get propEditorsBgColor():String{
		return _propEditorsBgColor;
	}
}
