﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;

class org.silex.toolbox.SelectionTool extends mx.core.UIComponent{
	
	var silex_ptr/*:org.silex.core.Api*/;
	// **
	// UI
	var sizeUiTL:MovieClip;
	var sizeUiTR:MovieClip;
	var sizeUiBL:MovieClip;
	var sizeUiBR:MovieClip;
	var sizeUiL:MovieClip;
	var sizeUiT:MovieClip;
	var sizeUiR:MovieClip;
	var sizeUiB:MovieClip;
//	var centerUiPos:MovieClip;
	var centerUiRot:MovieClip;
	
	var bg_mc:MovieClip;
	
	var pivot:Object; // pivot in bg_mc coordinates
	
	//
	// constructor
	function SelectionTool()
	{
		silex_ptr=_global.getSilex(this);

		// menu tool
		_parent.isNotSeenByMenuTool=true; // so that it is not used by the menu
		
		pivot={x:0,y:0};
	}

	var isMoving:Boolean=false;
	var isRoatating:Boolean=false;
	var isDragging:Boolean=false;

	function allToolsLoaded() {
			// Players tool box
			//silex_ptr.utils.trace("toolbox.SelectionTool onLoad "+_parent._parent.players_tool);
			var _obj=new Object;
			_obj.change=Utils.createDelegate(this,playersToolboxChange);
			//_parent._parent.players_tool.main.addEventListener("change",_obj);
			_parent._parent.properties_tool.main.addEventListener("change",_obj);
	}

	// called from fla file
	function onLoad()
	{
		super.onLoad();

		// **
		// to do : pivot
		sizeUiTL._visible=false;
		sizeUiT._visible=false;
		sizeUiL._visible=false;
		sizeUiBL._visible=false;
		sizeUiTR._visible=false;
		// **
		
		playersToolboxChange();

		// event listener to wait for all tools to be loaded
		var toolsManagerListener:Object=new Object;
		toolsManagerListener.onLoadToolsManager=Utils.createDelegate(this,allToolsLoaded);
		silex_ptr.toolsManager.addEventListener("onLoadToolsManager",toolsManagerListener);
		
		// **
		// mouse pointer

		// ** ** **
		// UI events
		
		sizeUiTR["isResizeH"]=sizeUiTR["isResizeW"]=true;
		sizeUiBL["isResizeH"]=sizeUiBL["isResizeW"]=true;
		sizeUiBR["isResizeH"]=sizeUiBR["isResizeW"]=true;
		sizeUiTL["isResizeH"]=sizeUiTL["isResizeW"]=true;
		sizeUiL["isResizeW"]=true;
		sizeUiT["isResizeH"]=true;
		sizeUiR["isResizeW"]=true;
		sizeUiB["isResizeH"]=true;

		// **
		// start
		bg_mc.onPress = function()
		{
			this._parent.isMoving = true;
			this.startDrag();
		}
		sizeUiTR._btn.onPress=sizeUiBL._btn.onPress=sizeUiBR._btn.onPress=sizeUiL._btn.onPress=sizeUiT._btn.onPress=sizeUiR._btn.onPress=sizeUiB._btn.onPress=sizeUiTL._btn.onPress=function()
		{
			//silex_ptr.utils.trace("toolbox.SelectionTool sizeUiTL startDrag"+this);
			// lock drag horizontally or vertically
			var vert_num:Number=undefined;
			if (this._parent["isResizeW"]!=true){
				// vert_num=this._parent._x;
			}
			var horiz_num:Number=undefined;
			if (this._parent["isResizeH"]!=true){
				// horiz_num=this._parent._y;
			}
			
			this._parent.startDrag(true,vert_num,horiz_num,vert_num,horiz_num);
			this._parent._parent.isDragging=true;

			var refToBtn:Button=this._parent;
			this._parent._parent.onMouseMove=function()
			{
				//silex_ptr.utils.trace("toolbox.SelectionTool onMouseMove "+refToBtn);
				// resize bg_mc
				refToBtn._parent.setBgFromUi(refToBtn);
			}
		}
/*		centerUiPos.onPress=function()
		{
			//silex_ptr.utils.trace("toolbox.SelectionTool sizeUiTL startDrag"+this);
			this.startDrag();
			this._parent.isDragging=true;
			//this._parent.onMouseMove=Utils.createDelegate(this._parent,this._parent.moveSelection);
			var refToBtn:Button=this;
		}*/
		centerUiRot.onPress=function()
		{
			// Start rotating process (see onEnterFrame)
			this._parent.isRoatating=true;
			//this._parent.onMouseMove=Utils.createDelegate(this._parent,this._parent.rotateSelection);
			var refToBtn:Button=this;
			this._parent.onMouseMove=function()
			{
				var cos:Number=refToBtn._xmouse;
				var sin:Number=refToBtn._ymouse;
				var tan:Number=Math.atan2(sin,cos);
				
				refToBtn._rotation+=tan*180/3.14;
			}
		}
		
		// **
		// end
		// Rotation
		bg_mc.onRelease = bg_mc.onReleaseOutside = function()
		{
			this._parent.isMoving = false;
			this.stopDrag();
			// move media
			this._parent.moveSelection();
		}
		centerUiRot.onRelease=centerUiRot.onReleaseOutside=function()
		{
			// Stop rotating process 
			this._parent.isRoatating=false;
			delete this._parent.onMouseMove;
			
			// traform
			this._parent.rotateSelection(this._rotation);
			this._rotation=0;
		}
		// Horizontal and Vertical resize
		sizeUiL._btn.onRelease=sizeUiL._btn.onReleaseOutside=sizeUiR._btn.onRelease=sizeUiR._btn.onReleaseOutside=sizeUiT._btn.onRelease=sizeUiT._btn.onReleaseOutside=sizeUiB._btn.onRelease=sizeUiB._btn.onReleaseOutside=sizeUiBR._btn.onRelease=sizeUiBR._btn.onReleaseOutside=sizeUiBL._btn.onRelease=sizeUiBL._btn.onReleaseOutside=sizeUiTR._btn.onRelease=sizeUiTR._btn.onReleaseOutside=sizeUiTL._btn.onRelease=sizeUiTL._btn.onReleaseOutside=function()
		{
			// stop drag
			this._parent.stopDrag();
			this._parent._parent.isDragging=false;			
			delete this._parent._parent.onMouseMove;
			
			// resize media
			this._parent._parent.resizeSelection();
		}
		// Move
/*		centerUiPos.onRelease=centerUiPos.onReleaseOutside=function()
		{
			// stop drag
			this.stopDrag();
			this._parent.isDragging=false;			
			delete this._parent.onMouseMove;

			// move pivot
			var player_mc:MovieClip=this._parent.getSelectedPlayer();
			var _obj:Object={x:this._x,y:this._y};
			player_mc.setGlobalCoordPivot(this.localToGlobal(_obj));
			
			// refresh properties list
			this._parent._parent._parent.Properties.main.refresh();
		}*/
	}
	function setBgFromUi(refToBtn:MovieClip) {
		var opositCorner_mc:MovieClip;
		switch(refToBtn){
			case sizeUiTL:
			case sizeUiT:
			case sizeUiL:
				opositCorner_mc=sizeUiBR;
				break;
			case sizeUiR:
			case sizeUiB:
			case sizeUiBR:
				opositCorner_mc=sizeUiTL;
				break;
			case sizeUiBL:
				opositCorner_mc=sizeUiTR;
				break;
			case sizeUiTR:
				opositCorner_mc=sizeUiBL;
				break;
		}
		
		// store position of the pivot
		var pivotPosPercentX:Number;
		var pivotPosPercentY:Number;
		pivotPosPercentX=pivot.x/bg_mc._width;
		pivotPosPercentY=pivot.y/bg_mc._height;
		
		// apply width and height
		if (refToBtn["isResizeH"]==true)
		{
			var h:Number=Math.abs(refToBtn._y-opositCorner_mc._y);
			//silex_ptr.utils.trace("toolbox.SelectionTool setBgFromUi H "+h);

			// apply height
			bg_mc._height=h;
		}
		if (refToBtn["isResizeW"]==true)
		{
			var w:Number=Math.abs(refToBtn._x-opositCorner_mc._x);
			//silex_ptr.utils.trace("toolbox.SelectionTool setBgFromUi W "+w);

			// apply width
			bg_mc._width=w;
		}
		// move in function of the pivot position
		var newPivotPosX:Number=bg_mc._width*pivotPosPercentX;
		var newPivotPosY:Number=bg_mc._height*pivotPosPercentY;
		var offsetPivotX:Number=newPivotPosX-pivot.x;
		var offsetPivotY:Number=newPivotPosY-pivot.y;
		//silex_ptr.utils.trace("toolbox.SelectionTool setBgFromUi "+w);
		// replace pivot at its position
		bg_mc._x-=offsetPivotX;
		bg_mc._y-=offsetPivotY;
	}
	function playersToolboxChange()
	{
		if (isDragging == true || isMoving == true || isRoatating == true) return;
		
		// put this toolbox behind the other toolboxes
		_parent.swapDepths(0);//_parent._parent.getNextHighestDepth());

		// get selection
		var player_mc:MovieClip=getSelectedPlayer();
		//silex_ptr.utils.trace("toolbox.SelectionTool playersToolboxChange "+player_mc);
		
	
		// **
		// context menu
		// emptyContextMenu(bg_mc);

		// **
		//
		if (player_mc)
		{
			_visible=true;
			this.menu=player_mc.menu.copy();

			// from local coords
/*			var coordTL:Object={x:player_mc._x,y:player_mc._y};
			var coordBR:Object={x:player_mc._x+player_mc.width,y:player_mc._y+player_mc.height};

			// to global coords
			player_mc._parent.localToGlobal(coordTL);
			player_mc._parent.localToGlobal(coordBR);
*/
			var coordRot:Number=player_mc.rotation;
			var coordTL:Object=player_mc.getGlobalCoordTL();
			var coordBR:Object=player_mc.getGlobalCoordBR();

			this._rotation=coordRot;
			
			// to local coords
			globalToLocal(coordTL);
			globalToLocal(coordBR);
			
			// pivot in bg_mc coordinates
			//pivot=player_mc.getGlobalCoordPivot();
			//bg_mc.globalToLocal(pivot);


			// apply transform
			bg_mc._x=coordTL.x;
			bg_mc._y=coordTL.y;
			bg_mc._width=coordBR.x-coordTL.x;
			bg_mc._height=coordBR.y-coordTL.y;
			
			if (bg_mc._width == undefined || bg_mc._width<=0) bg_mc._width = player_mc.defaultSize;
			if (bg_mc._height == undefined || bg_mc._height<=0) bg_mc._height = player_mc.defaultSize;

			uiPlacementRefresh();

			// context menu
			// addToContextMenu(bg_mc,player_mc.contextMenuMethods);
		}
		else
		{
			_visible=false;
		}
	}
	function getSelectedPlayer():MovieClip
	{
		var playerDesc_obj:Object=_parent._parent.players_tool.main.getSelectedContent();
		var layer_mc:MovieClip=_parent._parent.layers_tool.main.getSelectedContent();
		var player_mc:MovieClip=layer_mc[playerDesc_obj._name].main;

		//trace("toolbox.SelectionTool getSelectedPlayer "+player_mc);
		return player_mc;
	}

	// UI events
	function resizeSelection()
	{
		var player_mc:MovieClip=getSelectedPlayer();

		// from local
		var coordTL:Object={x:bg_mc._x,y:bg_mc._y};
		var coordBR:Object={x:bg_mc._x+bg_mc._width,y:bg_mc._y+bg_mc._height};
		
		// to global
		localToGlobal(coordTL);
		localToGlobal(coordBR);
		
		// transform
		player_mc.setGlobalCoordTL(coordTL);
		player_mc.setGlobalCoordBR(coordBR);

		//uiPlacementRefresh();

		// set layout as dirty
		silex_ptr.application.getLayout(player_mc).isDirty=true;
			
		// refresh properties list
		_parent._parent.properties_tool.main.refresh();
	}
	function moveSelection()
	{
		//silex_ptr.utils.trace("toolbox.SelectionTool moveSelection "+x+","+y);
		var player_mc:MovieClip=getSelectedPlayer();

		// from local
		var coordTL:Object={x:bg_mc._x,y:bg_mc._y};
		var coordBR:Object={x:bg_mc._x+bg_mc._width,y:bg_mc._y+bg_mc._height};
		//silex_ptr.utils.trace("toolbox.SelectionTool moveSelection - ("+coordTL.x+","+coordTL.y+")");
		
		// to global
		localToGlobal(coordTL);
		localToGlobal(coordBR);
		
		// move
		//silex_ptr.utils.trace("toolbox.SelectionTool moveSelection - ("+coordTL.x+","+coordTL.y+")");
		player_mc.setGlobalCoordTL(coordTL);
		player_mc.setGlobalCoordBR(coordBR);
		
		// set layout as dirty
		silex_ptr.application.getLayout(player_mc).isDirty=true;
			
		//uiPlacementRefresh();
			
		// refresh properties list
		_parent._parent.properties_tool.main.refresh();
	}
	
	function rotateSelection(angle:Number)
	{
		if (!angle) angle=centerUiRot._rotation;
		
		var player_mc:MovieClip=getSelectedPlayer();
		player_mc.rotation+=angle;
			
		// refresh properties list
		_parent._parent.properties_tool.main.refresh();

		// set layout as dirty
		silex_ptr.application.getLayout(player_mc).isDirty=true;
	}


	function uiPlacementRefresh()
	{
		var x:Number= bg_mc._x;//-bg_mc._width/2;
		var y:Number= bg_mc._y;//-bg_mc._height/2;

		sizeUiTL._x=x;
		sizeUiTL._y=y;
		sizeUiTR._x=x+bg_mc._width;
		sizeUiTR._y=y;
		sizeUiBL._x=x;
		sizeUiBL._y=y+bg_mc._height;
		sizeUiBR._y=y+bg_mc._height;
		sizeUiBR._x=x+bg_mc._width;
		sizeUiL._x=x;
		sizeUiL._y=y+bg_mc._height/2;
		sizeUiT._x=x+bg_mc._width/2;
		sizeUiT._y=y;
		sizeUiR._x=x+bg_mc._width;
		sizeUiR._y=y+bg_mc._height/2;
		sizeUiB._x=x+bg_mc._width/2;
		sizeUiB._y=y+bg_mc._height;

		
		
		centerUiRot._x=bg_mc._x;
		centerUiRot._y=bg_mc._y;

/*		var tmpPivot_obj:Object={x:pivot.x,y:pivot.y};
		bg_mc.localToGlobal(tmpPivot_obj);
		globalToLocal(tmpPivot_obj);
		
		centerUiRot._x=tmpPivot_obj.x;
		centerUiRot._y=tmpPivot_obj.y;
		
		centerUiPos._x=tmpPivot_obj.x;
		centerUiPos._y=tmpPivot_obj.y;
	*/
//		pivot._x=x+bg_mc._width/2;
//		pivot._y=y+bg_mc._height/2;
	}
}