﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.controls.Button;
//import mx.controls.Tree;
import mx.controls.List;
import mx.events.EventDispatcher;

/**
 * A toolbox base
 */
class org.silex.toolbox.Toolbox extends mx.core.UIComponent implements org.silex.toolbox.ToolboxInterface {
	private var silex_ptr/*:org.silex.core.Api*/;
	
    public var TOP_ZONE:Number = 0;
    public var LEFT_ZONE:Number = 1;
    public var BOTTOM_ZONE:Number = 2;
    public var RIGHT_ZONE:Number = 3;
	
    public var minWidth:Number; // - width minimum to minimize
    public var minHeight:Number; // - height minimum to minimize
    //public var cornerSize:Number = 5; // - size of top corner square
    public var minimized:Boolean = false; // - state of minimize/maximize toolbox
	
	
    public var list:List;//Tree; // wich contain the items list to selection
    public var topBarBg_mc:MovieClip; // top icon bar background
    public var drag_btn:MovieClip; // - used to drag and drop button
    public var resize_btn:MovieClip; // - resize button
    // public var zoom_btn:Button; // - zoom button - to do later
    public var minimize_btn:MovieClip; //  - minimize/maximize button
    public var close_btn:MovieClip; //  - minimize/maximize button
    public var shape_mc:MovieClip; // - the movie clip represents the shape to overlap
    public var ui_mc:MovieClip; // - movie clip witch contain specifics toolbox buttons
    // public var bg_mc:MovieClip; // - movie clip witch contain background graphic
	//public var grid:Rectangle; // - an abstract grid to defined scale9Grid
	public var parentToolbox:Toolbox=null;
	public var clipZone:Number;
	
	public var listener:Object;
	
	/**
	 * shared object used to remember tool data
	 */
	static var storedInfoSO:SharedObject;

	// title for the tool box (used in the drag zone
	var title:String;
	/**
	* Constructor.
	*/
	public function Toolbox() {
		super.init();
		
		silex_ptr = _global.getSilex(this);
		
		// event listener to wait for all tools to be loaded
		var toolsManagerListener:Object=new Object;
		toolsManagerListener.onLoadToolsManager=Utils.createDelegate(this,allToolsLoaded);
		silex_ptr.toolsManager.addEventListener("onLoadToolsManager",toolsManagerListener);
		
		/// Defined the scale9Grid rectangle
		// grid = new Rectangle(cornerSize, minHeight, width-2*cornerSize, height-resize_btn._height-minHeight);
		//trace("grid.height : "+grid.height);
		/// Defined events of the drag button
		drag_btn.onPress = Utils.createDelegate(super, startDrag);		
		drag_btn.onRelease = drag_btn.onReleaseOutside = Utils.createDelegate(super, stopDrag);
		/// Defined events of the resize button
		resize_btn.onPress = Utils.createDelegate(this, startResize);
		resize_btn.onRelease = resize_btn.onReleaseOutside = Utils.createDelegate(this, stopResize);
		/// Defined events of the minimize button
		minimize_btn.onRelease = Utils.createDelegate(this, minimize);
		close_btn.onRelease = function()
		{
			_parent._parent._visible = false;
			_parent._parent._parent.menu_tool.main.refreshIconsStates();
		}
		/// Set invisible the shape
		shape_mc._alpha = 0;
		
		minWidth = resize_btn._x;
		minHeight = resize_btn._y;
		
		/// Init resizing
		resize(resize_btn._x,resize_btn._y);
		
		// to be used by menu tool
		_parent._visible=false;
		// setInitialPosition();
	}
	function allToolsLoaded()
	{
	}
	function onLoad(){
/*
		list.setStyle("backgroundColor", 0x0);
		list.setStyle("rollOverColor", 0xFFFFCC);
		list.setStyle("selectionColor", 0xFFFFCC);
		list.setStyle("themeColor", 0xFFFFCC);
		/**/
		list.setStyle("rollOverColor", 0x333333);
		list.setStyle("selectionColor", 0x666666);
		//_alpha = 95;
		list._alpha = 80;
		list._focusrect = false;
		//list.boundingBox_mc._visible = false;
		list.border_mc._visible = false;
		// title = silex_ptr.config.SHARED_OBJECT_NAME + " - "+this._parent._name;
		
		
		// remember positions
		if (!storedInfoSO)
			storedInfoSO = SharedObject.getLocal(silex_ptr.config.SHARED_OBJECT_NAME+"-"+silex_ptr.authentication.currentLogin);

		if (!storedInfoSO.data.toolsPostionsArray)
		{
			// initialize the array
			storedInfoSO.data.toolsPostionsArray = new Array;
		}
		if (!storedInfoSO.data.toolsPostionsArray[this._parent._name])
		{
			// create container for this tool
			storedInfoSO.data.toolsPostionsArray[this._parent._name] = new Object;
			storedInfoSO.flush();
		}
		else
		{
			// apply stored data to this tool box
			for (var prop in storedInfoSO.data.toolsPostionsArray[this._parent._name])
			{
				this[prop] = storedInfoSO.data.toolsPostionsArray[this._parent._name][prop];
			}
		}
		
		// resize normally
		resize(_width, _height);
		_xscale = _yscale = 100;
	}
	var _isToolBox:Boolean=true;
    function isToolBox():Boolean
	{
		return true;
	}

	// position in function of the other tool boxes
	function setInitialPosition()
	{
		//silex_ptr.utils.trace ("toolbox base - setInitialPosition");

		// go to 0,0
		_x=0;
		_y=0;
		
		// clip the unclipped toolbox (the last loaded one) to this
		for (var tool_str in _parent._parent)
		{
			if (_parent._parent[tool_str]!=_parent && _parent._parent[tool_str].main.isToolBox()==true && _parent._parent[tool_str].main.parentToolbox==null)
			{
				//silex_ptr.utils.trace("toolbox base - setInitialPosition - ------------------------------------ ");
				// clip other tool to this
				_parent._parent[tool_str].main.clipTo(this,BOTTOM_ZONE);
				_parent._parent[tool_str].main.followTo();
				break;
			}
		}
	}
	/**
	* Start the drag and drop event
	*/
	private function startDrag():Void{
		//silex_ptr.utils.trace ("toolbox base - startDrag");
		//trace("startDrag ");
		super.startDrag();
		this._parent.swapDepths(this._parent._parent.getNextHighestDepth());
		this.onMouseMove = function(){
			dispatchEvent({type:"resize"});
		}
		unClip();
	}
	function unClip() {
		//silex_ptr.utils.trace ("toolbox base - unClip");
		parentToolbox.removeEventListener("parentMove",listener);
		parentToolbox.removeEventListener("resize",listener);
		delete(parentToolbox);
	}

	/**
	* Stop the drag and drop event
	*/
	private function stopDrag():Void{
		super.stopDrag();
		delete(this.onMouseMove);
		
		// remember postion
		storedInfoSO.data.toolsPostionsArray[this._parent._name]["_x"] = _x;
		storedInfoSO.data.toolsPostionsArray[this._parent._name]["_y"] = _y;
		storedInfoSO.flush();
		
/* REMOVED FOR SMALL SCREENS
		var thisObj = this._parent;

		//silex_ptr.utils.trace ("toolbox base stopDrag -- "+_droptarget+"-"+_droptarget.substring(0,_droptarget.lastIndexOf("/shape_mc"))+" - "+eval(_droptarget)["_parent"]+"-"+eval(_droptarget)["_parent"]._target);
		
		// remove "/shape_mc" to /toolsContainer_mc/Actions/main/shape_mc
		var pathToToolbox_str:String=_droptarget.substring(0,_droptarget.lastIndexOf("/shape_mc"));
		var tb=eval(pathToToolbox_str);
		
		if (tb._isToolBox==true){
			// compute direction
			var cx = tb.shape_mc._width/2;
			var cy = tb.shape_mc._height/2;
			var adj = tb.shape_mc._xmouse-cx;
			var hyp = Math.sqrt(Math.pow(adj,2)+Math.pow(tb.shape_mc._ymouse-cy,2));
			var cosa = adj/hyp;
	
			var angle;
			var clipZone_num:Number;
			if((tb.shape_mc._ymouse-cy)<=0) angle=180*Math.acos(cosa)/Math.PI;
			if((tb.shape_mc._ymouse-cy)>0) angle=360-(180*Math.acos(cosa)/Math.PI);
			if(angle>=45 && angle<135)  clipZone_num = TOP_ZONE;
			if(angle>=135 && angle<225) clipZone_num = LEFT_ZONE;
			if(angle>=225 && angle<315) clipZone_num = BOTTOM_ZONE;
			if(angle>=315 || angle<45) clipZone_num = RIGHT_ZONE;
			
			clipTo(tb,clipZone_num);
		}
*/	}

	/**
	* Start the resize event
	*/
	private function startResize():Void{
		//trace("startResize");
		var thisObj= this;
		this.onMouseMove = function(){
			resize(thisObj._xmouse+5, thisObj._ymouse-30);
		}
	}

	/**
	* Stop the resize event
	*/
	private function stopResize():Void{
		//trace("stopResize");
		delete(this.onMouseMove);
		// remember postion
		storedInfoSO.data.toolsPostionsArray[this._parent._name]["_width"] = _width;
		storedInfoSO.data.toolsPostionsArray[this._parent._name]["_height"] = _height;
		storedInfoSO.flush();
	}

	/**
	 * Add an event listener to link with an another toolbox
	 */
	/**
	 * A do-nothing implementation of the Toolbox interface's
	 * refresh() method. Subclasses of Toolbox will provide
	 * a concrete implementation for this method.
	 */
	public function refresh():Void {
		//silex_ptr.utils.trace ("toolbox base refresh - "+this._parent._name);
	}
	
	/**
	 * A do-nothing implementation of the Toolbox interface's
	 * getSelectedContent() method. Subclasses of Toolbox will provide
	 * a concrete implementation for this method.
	 */
	public function getSelectedContent():Array {
		return new Array();
	}
	
	/**
	 * To resize the toolbox and to re-place button, shape and mcs elements
	 * @param   w   The width in pixel
	 * @param   h   The height in pixel
	*/
	public function resize(w:Number,h:Number):Void{
		if (w < minWidth) w = minWidth;
		close_btn._x = minimize_btn._x = w;
		
		resize_btn._x = w;
		shape_mc._width = resize_btn._x + resize_btn._width;
		list.setSize(resize_btn._x + resize_btn._width - list.x,list.height );
		//setSize(w,this.height);
		
		if(h<minHeight) h=minHeight;
		resize_btn._y = h;
		shape_mc._height = resize_btn._y + ui_mc._height;
		ui_mc._y = resize_btn._y;
		topBarBg_mc._width = drag_btn._width = ui_mc.bg_mc._width = resize_btn._x + resize_btn._width;
		list.setSize(list.width,resize_btn._y-list.y );
		//setSize(this.width,h);
		

		dispatchEvent({type:"parentMove"});
		parentToolbox.dispatchEvent({type:"parentMove"});
	}
	
	/**
	 * Apply a scale setting of _xscale and _yscale toolbox's values
	 * @param   zscale   zoom scale percent value
	*/
	public function zoom(zscale:Number):Void{
		//trace("zoom : "+zscale);
		this._xscale=this._yscale=zscale;
		dispatchEvent({type:"resize"});
	}
	
	/**
	 * make UIs disappear, leave drag zone and minimize_btn
	 * get the initial size back in currentWidth and currentHeight
	*/
	public function minimize():Void{
		if(!this.minimized){
			//trace("minimize");
			list._visible = false;
			resize_btn._visible = false;
			ui_mc._visible = false;
			topBarBg_mc._visible = false;
			shape_mc._height = this.drag_btn._height;
			minimized= true;
		}else maximize();
		dispatchEvent({type:"resize"});
		parentToolbox.dispatchEvent({type:"resize"});
	}
	
	/**
	 * set resize with currentWidth and currentHeight properties
	*/
	public function maximize():Void{
		//trace("maximize");
		list._visible = true;
		resize_btn._visible = true;
		ui_mc._visible = true;
		shape_mc._height = resize_btn._y + ui_mc._height;
		//trace("shape_mc._height "+_height);
		minimized= false;
	}
	
	/**
	 * Move this to according position to an other movie clip and its shape zone hit
	 * Directly calculate the 4 shape's zone and place this on the correct position
	 * @param   tb   An other toolbox reference for the hit
	*/
	public function clipTo(tb:Toolbox,clipZone_num:Number):Void{
		//silex_ptr.utils.trace ("toolbox base - clipTo "+tb._parent._name+","+clipZone_num);
		parentToolbox = tb;
		clipZone=clipZone_num;

		///
		listener = new Object();
		listener.parentMove = listener.resize = Utils.createDelegate(this,followTo);
		parentToolbox.addEventListener("parentMove", listener);
		parentToolbox.addEventListener("resize", listener);
		parentToolbox.dispatchEvent({type:"parentMove"});
		
	}
	
	public function followTo():Void{
		//silex_ptr.utils.trace ("toolbox base - followTo "+_parent._name+","+clipZone);
		this._parent.swapDepths(this._parent._parent.getNextHighestDepth());
		var xtmp:Number;
		var ytmp:Number;
		switch(clipZone){
			case TOP_ZONE:
				xtmp = parentToolbox._x;
				ytmp = parentToolbox._y - this.shape_mc._height;
				break;
			case LEFT_ZONE:
				xtmp = parentToolbox._x - this.shape_mc._width;
				ytmp = parentToolbox._y;
				break;
			case BOTTOM_ZONE:
				xtmp = parentToolbox._x;
				ytmp = parentToolbox._y + parentToolbox.shape_mc._height;
				break;
			case RIGHT_ZONE:
				xtmp = parentToolbox._x + parentToolbox.shape_mc._width;
				ytmp = parentToolbox._y;
				break;
			default:
				break;
			
		}
		
		this.move(xtmp,ytmp);
		//silex_ptr.utils.trace("toolbox base - followTo "+parentToolbox);
		dispatchEvent({type:"resize"});
	}	
}