﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import org.silex.core.Utils;
import mx.controls.List;

/**
 * Website toolbox
 */
class org.silex.toolbox.Website extends org.silex.toolbox.Toolbox {
	
	public var oldValue;  // an array to memorize the old value

	
	/**
	 * Constructor. 
	 * Add a listener on change event of toolbox players and call this onLoad method.
	 */
	public function Website(){
		trace("New Website");
	}
	function allToolsLoaded() 
	{
		super.allToolsLoaded();
	}
	
	public function onLoad(){
		super.onLoad();

		title=silex_ptr.config.TOOL_BOX_TITLE_WEBSITE;
		
		// build params list
		// html page
		list.addItem({label:"htmlTitle",data:{value: silex_ptr.config.htmlTitle,type: silex_ptr.config.PROPERTIES_TYPE_URL,defaultValue:""}});
		list.addItem({label:"htmlIcon",data:{value: silex_ptr.config.htmlIcon,type: silex_ptr.config.PROPERTIES_TYPE_URL,defaultValue:""}});
		list.addItem({label:"htmlKeywords",data:{value: silex_ptr.config.htmlKeywords,type: silex_ptr.config.PROPERTIES_TYPE_URL,defaultValue:""}});
		list.addItem({label:"flashPlayerVersion",data:{value: silex_ptr.config.flashPlayerVersion,type: silex_ptr.config.PROPERTIES_TYPE_NUMBER,defaultValue:"7",minValue:7,maxValue:9}});

		// website
		list.addItem({label:"scaleMode",data:{value: silex_ptr.config.scaleMode,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"bgColor",data:{value: silex_ptr.config.bgColor,type: silex_ptr.config.PROPERTIES_TYPE_COLOR}});
		list.addItem({label:"mainRssFeed",data:{value: silex_ptr.config.mainRssFeed,type: silex_ptr.config.PROPERTIES_TYPE_URL,defaultValue:""}});

		// layouts
		list.addItem({label:"layoutStageWidth",data:{value: silex_ptr.config.layoutStageWidth,type: silex_ptr.config.PROPERTIES_TYPE_NUMBER}});
		list.addItem({label:"layoutStageHeight",data:{value: silex_ptr.config.layoutStageHeight,type: silex_ptr.config.PROPERTIES_TYPE_NUMBER}});
		list.addItem({label:"layoutFolderPath",data:{value: silex_ptr.config.layoutFolderPath,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"initialLayoutFile",data:{value: silex_ptr.config.initialLayoutFile,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"layerSkinUrl",data:{value: silex_ptr.config.layerSkinUrl,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		
		// folders
		list.addItem({label:"CONFIG_START_SECTION",data:{value: silex_ptr.config.CONFIG_START_SECTION,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"toolsFolderRelativePath",data:{value: silex_ptr.config.toolsFolderRelativePath,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"websiteFtpRelativeUrl",data:{value: silex_ptr.config.websiteFtpRelativeUrl,type: silex_ptr.config.PROPERTIES_TYPE_URL}});

		//screen saver
		list.addItem({label:"screenSaverDelay",data:{value: silex_ptr.config.screenSaverDelay,type: silex_ptr.config.PROPERTIES_TYPE_NUMBER}});
		list.addItem({label:"screenSaverActivateCommands",data:{value: silex_ptr.config.screenSaverActivateCommands,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"screenSaverDeactivateCommands",data:{value: silex_ptr.config.screenSaverDeactivateCommands,type: silex_ptr.config.PROPERTIES_TYPE_URL}});

		// tracking
		list.addItem({label:"googleAnaliticsAccountNumber",data:{value: silex_ptr.config.googleAnaliticsAccountNumber,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"phpmyvisitesURL",data:{value: silex_ptr.config.phpmyvisitesURL,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"phpmyvisitesSiteNumber",data:{value: silex_ptr.config.phpmyvisitesSiteNumber,type: silex_ptr.config.PROPERTIES_TYPE_NUMBER}});
		
		// context
		list.addItem({label:"AVAILABLE_CONTEXT_LIST",data:{value: silex_ptr.config.AVAILABLE_CONTEXT_LIST,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"globalContext",data:{value: silex_ptr.config.globalContext,type: silex_ptr.config.PROPERTIES_TYPE_URL}});

		// languages
		list.addItem({label:"DEFAULT_LANGUAGE",data:{value: silex_ptr.config.DEFAULT_LANGUAGE,type: silex_ptr.config.PROPERTIES_TYPE_URL}});
		list.addItem({label:"AVAILABLE_LANGUAGE_LIST",data:{value: silex_ptr.config.AVAILABLE_LANGUAGE_LIST,type: silex_ptr.config.PROPERTIES_TYPE_URL}});

		// FOR GROMO

/*		list.addItem({label:"APPLICATION_CONFIG_FILE",data:{value:silex_ptr.config.APPLICATION_CONFIG_FILE,type: silex_ptr.config.PROPERTIES_TYPE_URL}});		list.addItem({label:"DEBUG_LEVEL",data:{value:silex_ptr.config.DEBUG_LEVEL,type: silex_ptr.config.PROPERTIES_TYPE_TEXT}});
		list.addItem({label:"GROMO_VERSION",data:{value:silex_ptr.config.GROMO_VERSION,type: silex_ptr.config.PROPERTIES_TYPE_TEXT}});
		list.addItem({label:"APPLICATION_CONFIG_FILE",data:{value:silex_ptr.config.APPLICATION_CONFIG_FILE,type: silex_ptr.config.PROPERTIES_TYPE_TEXT}});
		list.addItem({label:"GROMO_MATCH_DURATION",data:{value:silex_ptr.config.GROMO_MATCH_DURATION,type: silex_ptr.config.PROPERTIES_TYPE_TEXT}});
		list.addItem({label:"REGISTER_URL",data:{value:silex_ptr.config.REGISTER_URL,type: silex_ptr.config.PROPERTIES_TYPE_TEXT}});
		list.addItem({label:"REQUEST_URL",data:{value:silex_ptr.config.REQUEST_URL,type: silex_ptr.config.PROPERTIES_TYPE_TEXT}});
		list.addItem({label:"GATEWAY_URL",data:{value:silex_ptr.config.GATEWAY_URL,type: silex_ptr.config.PROPERTIES_TYPE_TEXT}});
*/
		// init
		refresh();
		ui_mc.save_btn.onRelease=Utils.createDelegate(this,saveWebsite);
		ui_mc.reload_btn.onRelease=Utils.createDelegate(this,reloadWebsite);
		ui_mc.del_btn.onRelease=Utils.createDelegate(this,deleteWebsite);
		ui_mc.duplicate_btn.onRelease=Utils.createDelegate(this,duplicateWebsite);
		ui_mc.help_btn.onRelease = function(){_root.getURL(_global.getSilex().config.HELP_URL_DOCUMENTATION_ROOT+_global.getSilex().config.HELP_URL_WYSIWYG_WEBSITE,"_blank");};
		
		// Defined the change event for the list.
		var listListener:Object = new Object();
		listListener.change = Utils.createDelegate(this, change);
		list.addEventListener("change", listListener);
	}
	function reloadWebsite() {
		silex_ptr.utils.trace("toolbox.Website reload "+silex_ptr.config.id_site);
		silex_ptr.application.start();
	}
	function saveWebsite() {
		silex_ptr.utils.trace("toolbox.Website saveWebsite "+silex_ptr.config.id_site);
		
		// build website info object from list
		var websiteInfo:Object=new Object;
		for (var idx:Number=0;idx<list.length;idx++){
			silex_ptr.utils.trace(list.getItemAt(idx).label+"="+list.getItemAt(idx).data.value);
			websiteInfo[list.getItemAt(idx).label]=list.getItemAt(idx).data.value;
		}
		// save data
		silex_ptr.com.writeWebsiteConfig(websiteInfo,silex_ptr.config.id_site,Utils.createDelegate(this,saveWebsiteCallback));
	}
	function saveWebsiteCallback (success:Boolean) {
		silex_ptr.utils.trace("toolbox.Website saveWebsiteCallback");
		if (success==true)
			silex_ptr.utils.alertSimple(silex_ptr.utils.revealAccessors(silex_ptr.config.MESSAGE_WEBSITE_SAVED,silex_ptr.config));
		else
			silex_ptr.utils.alert(silex_ptr.utils.revealAccessors(silex_ptr.config.ERROR_WEBSITE_SAVE_ERROR,silex_ptr.config));
		
		reloadWebsite();
	}
	function deleteWebsite() {
		silex_ptr.utils.confirm(silex_ptr.utils.revealAccessors(silex_ptr.config.WARNING_WEBSITE_DELETE_CONFIRM,silex_ptr.config),Utils.createDelegate(this,doDeleteWebsite));
	}
	function doDeleteWebsite (doIt_bool:Boolean) {
		if (doIt_bool==true) silex_ptr.com.writeWebsiteConfig({},silex_ptr.config.id_site,Utils.createDelegate(this,saveWebsiteCallback));
	}
	function duplicateWebsite() {
		silex_ptr.utils.prompt(silex_ptr.utils.revealAccessors(silex_ptr.config.PROMPT_ENTER_NEW_NAME_FOR_WEBSITE,silex_ptr.config),silex_ptr.config.id_site,Utils.createDelegate(this,doDuplicateWebsite));
	}
	function doDuplicateWebsite(newName_str:String) {
		if (newName_str)
			silex_ptr.com.duplicateWebsite(silex_ptr.config.id_site,newName_str,Utils.createDelegate(this,duplicateWebsiteCallback));
	}
	function duplicateWebsiteCallback (partialCopyError_str:String) {
		silex_ptr.utils.trace("toolbox.Website saveWebsiteCallback");
		if (partialCopyError_str=="")
			silex_ptr.utils.alertSimple(silex_ptr.utils.revealAccessors(silex_ptr.config.MESSAGE_WEBSITE_DUPLICATION_SUCCESS,silex_ptr.config));
		else
			silex_ptr.utils.alert(silex_ptr.utils.revealAccessors(silex_ptr.config.ERROR_WEBSITE_DUPLICATION_ERROR,{config:silex_ptr.config,error:partialCopyError_str}));
	}

	/**
	 * Defined the change event for the list. 
	 * Check the Website list by the getSelectedContent method of players toolbox.
	 */
	public function refresh(){
		silex_ptr.utils.trace("toolbox.Website refresh Website");

		dispatchEvent({type:"change",target:this});
		//list.labelField="description";
	}
	
	/**
	 * Function used to retrieve the selected Website.
	 */
	public function getSelectedContent():Array {
		return list.selectedItem.data;
	}
	
	/**
	 * Call at each click on the list to show the editor with a good type
	 * Call showEditor with "evt_obj.target.selectedItem"
	 * @param  evt_obj  the event object
	 */
	public function change(evt_obj:Object):Void {
		//showEditor(evt_obj.target.selectedItem);
		//resize(resize_btn._x,resize_btn._y+resize_btn._height);
		// dispatchEvent({type:"change",target:this});
		dispatchEvent({type:"change",target:this,callback:Utils.createDelegate(this,apply),propertyType:evt_obj.target.selectedItem.data.type,value:evt_obj.target.selectedItem.data.value,data:evt_obj.target.selectedItem.data});
	}
	
	/**
	 * Display on the editor with a good type
	 * @param   sItem   the selectedItem
	 * Use attachMovie method with sItem.type+"_editor" in instanceName
	 */
/*	public function showEditor(item:Object):Void {
		silex_ptr.utils.trace("toolbox.Website showEditor "+item.label+" - "+item.value+" - "+item.data+" - "+item.data.value);
	
		// hide the curently displayed editor
		hideEditor();

		// put on top of other tools
		_parent.swapDepths(_parent._parent.getNextHighestDepth());
		
		// init object
		var sItem_obj:Object = new Object();
		sItem_obj.property = {description:item.label,item:item};
		sItem_obj.description=item.label;
		sItem_obj.initValue = item.data.value;
		sItem_obj.toolbox_ptr = this;
		
		// attach property editor
		ui_mc.attachMovie(item.data.type+"_editor", "editor_mc", 1,sItem_obj);
		//shape_mc._height = resize_btn._y + ui_mc._height;
	}
*/
	/**
	 * Set the value property. 
	 * Tell from the property editor. 
	 * Action depend to the editor type.
	 * @param   sItem_obj    object passed by the Website toolbox components, 
	 *                       this object is defined in showEditor method
	 */
	public function apply(data:Object,value):Void {
		data.value=value;
		dispatchEvent({type:"change"});
	}
}