﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import mx.controls.cells.CheckCellRenderer
import mx.controls.CheckBox;
import org.silex.core.Utils;
import mx.controls.NumericStepper;
import mx.managers.DepthManager;

class org.silex.toolbox.list.DefaultCellRenderer extends CheckCellRenderer{// extends MovieClip{//
	
	var listOwner : MovieClip; // the reference we receive to the list
	var getCellIndex : Function; // the function we receive from the list
	var	getDataLabel : Function; // the function we receive from the list
	
	// UI
	var _txt:TextField;
	var bg_btn:Button;
	var selected_mc:MovieClip;
	
	//
	var label:String="";

	// constants :
	var preferedHeight:Number=44;
	var cellMarginX:Number=10;
	var cellMarginY:Number=0;
//	var maxHeight:Number=22
//	var maxWidth:Number=100
	
	
	function DefaultCellRenderer(){
	}

	function createChildren(Void) : Void{
		_txt.autoSize=true;
		_txt.wordWrap=false;

		//trace("DefaultCellRenderer createChildren");
		bg_btn.onPress=Utils.createDelegate(this,onPressCallback);
		bg_btn.onRelease=Utils.createDelegate(this,onReleaseCallback);
		bg_btn.onReleaseOutside=Utils.createDelegate(this,onReleaseOutsideCallback);
		bg_btn.useHandCursor=false;
		size();
	}
	function onPressCallback () {
	}
	function onReleaseCallback() {
		listOwner.selectedItem=this;
	}
	function onReleaseOutsideCallback() {
	}

	// note that setSize is implemented by UIComponent and calls size(), after setting
	// __width and __height

	function setValue(str:String, item:Object, sel:Boolean) : Void{
/*	trace("setValue "+str);
		for (var idx in item)
		{
			trace(idx+"->"+item[idx]);
		}
/*
		trace("DefaultCellRenderer setValue "+str);
*/		//check._visible = (item!=undefined);
		//check.selected = item[getDataLabel()];
		if (item==undefined){
			_visible = false;
			return;
		}
		// visible if there is data
		_visible=true;
		
		// display data
		label=str;

		// get the width and height of the text + margins
		var w:Number=_txt._width+cellMarginX*2;
		var h:Number=_txt._height+cellMarginY*2;
		
		// refresh
		setSize(w,h);
		
		// selected item?
		selected_mc._visible=sel;
	}

	function getPreferredHeight(Void) : Number{
		return preferedHeight;
	}

	function getPreferredWidth(Void) : Number{
		return listOwner._width;
	}
	function setSize(w,h) : Void{
		__width=w;
		__height=h;
		redraw();
	}
	function redraw()
	{
		// adapt textfield position
		_txt._x=Math.round((__width-_txt._width)/2);
		_txt._y=Math.round((__height-_txt._height)/2);

		// move UIs
		selected_mc._width=bg_btn._width=__width;
		selected_mc._height=bg_btn._height=__height;
		selected_mc._x=selected_mc._y=bg_btn._x=bg_btn._y=0;
	}
}