﻿import org.silex.core.Utils;
import mx.events.EventDispatcher;
import mx.controls.List;
//color picker
import org.sepy.ColorPicker

class org.silex.toolbox.property_editor.TextEditor extends mx.core.UIObject
{
	// constants
	var INDENT_STEP_POINTS:Number=20;
	
	// target text field
    var target; 
	var _format:TextFormat;
	var dispatchEvent : Function;

	/* _useEmbeddedFonts
	 * if true, then use [font name]+"_bold" instead of <b> tag
	 * same for italic
	 */
	var _useEmbeddedFonts:Boolean;
	//select
	var endSelec:Number;
	var startSelec:Number;
	var caretSelec:Number
	var currentFocus;
	//text
	//var _text:TextField;
	//btn
	var bold_btn:MovieClip;
	var italic_btn:MovieClip;
	var underline_btn:MovieClip;
	var align_left_btn:MovieClip;
	var align_center_btn:MovieClip;
	var align_right_btn:MovieClip;
	var align_justify_btn:MovieClip;
	var bullet_btn:MovieClip;
	var indent_more_btn:MovieClip;
	var indent_less_btn:MovieClip;
	var blocIndent_more_btn:MovieClip;
	var blocIndent_less_btn:MovieClip;
	var reset_btn:MovieClip;
	var fontList:List;
	var sizeList:List;
	var colorPicker;
	// numeric stepers
	//var leading_stp:mx.controls.NumericStepper;
	//var spacing_stp:mx.controls.NumericStepper;
	var leading_tf:TextField;
	var spacing_tf:TextField;
	var right_btn:Button;
	var left_btn:Button;
	
	//listeners
	var fontListListener:Object;
	var sizeListListener:Object;
	var colorListener:Object;
	
	// hasFocus is true when target has focus
	var hasFocus:Boolean=false;
	
    function TextEditor(){
    } 
	
	function onLoad(){
		//dispatch
		mx.events.EventDispatcher.initialize(this);
		// in the container :
		// init();
	}
	
	function init(_text,useEmbeddedFonts:Boolean){
		if (useEmbeddedFonts!=undefined) _useEmbeddedFonts=useEmbeddedFonts;
		else _useEmbeddedFonts=_text.embedFonts;
		
	
		//Assign textfield
        target = _text;
        _format = target.getTextFormat();
		startSelec = endSelec = caretSelec = 0;
		//listener
		Selection.addListener(this);
		//Btn actions
		bold_btn.onRelease = Utils.createDelegate(this, toBold);
		italic_btn.onRelease = Utils.createDelegate(this, toItalic);
		underline_btn.onRelease = Utils.createDelegate(this, toUnderline);
		bullet_btn.onRelease = Utils.createDelegate(this, toBullet);
		blocIndent_more_btn.onRelease = Utils.createDelegate(this, toBlocIndentMore);
		blocIndent_less_btn.onRelease = Utils.createDelegate(this, toBlocIndentLess);
		indent_more_btn.onRelease = Utils.createDelegate(this, toIndentMore);
		indent_less_btn.onRelease = Utils.createDelegate(this, toIndentLess);
		align_left_btn.onRelease = Utils.createDelegate(this, toAlignLeft);
		align_center_btn.onRelease = Utils.createDelegate(this, toAlignCenter);
		align_right_btn.onRelease = Utils.createDelegate(this, toAlignRight);
		align_justify_btn.onRelease = Utils.createDelegate(this, toAlignJustify);
		//
		reset_btn.onRelease = Utils.createDelegate(this, resetFormat);

		// **
		// steppers
		right_btn.onRelease=Utils.createDelegate(this, leadingMore);
		left_btn.onRelease=Utils.createDelegate(this, leadingLess);
		leading_tf.onChanged=Utils.createDelegate(this, leadingChanged);
		//leading_tf.onKillFocus=Utils.createDelegate(this, triggerRenew);
		leading_tf.onSetFocus=Utils.createDelegate(this, refocus);
		//leading_tf.restrict="0-9 \-";
		spacing_tf.onChanged=Utils.createDelegate(this, spacingChanged);
		spacing_tf.onKillFocus=Utils.createDelegate(this, triggerRenew);
		spacing_tf.onSetFocus=Utils.createDelegate(this, refocus);
		//spacing_tf.restrict="0-9 \-";
		if (!(parseInt(_global.getSilex().config.flashPlayerVersion)>7))
			spacing_tf._visible=false;
		
/*		With numeric steppers (focus bug) :
		var nstepListener:Object = new Object();
		nstepListener.change = Utils.createDelegate(this, leadingChanged);
		nstepListener.focusIn = Utils.createDelegate(this, refocus);
		// Add listener.
		leading_stp.addEventListener("change", nstepListener);
//		leading_stp.addEventListener("focusIn", nstepListener);
*/
/*		nstepListener = new Object();
		nstepListener.change = Utils.createDelegate(this, spacingChanged);
		nstepListener.focusIn = Utils.createDelegate(this, refocus);
		// Add listener.
		spacing_stp.addEventListener("change", nstepListener);
//		spacing_stp.addEventListener("focusIn", nstepListener);
*/		
		// **
		//font list
/*		fontList.addItem("_sans");
		fontList.addItem("_serif");
		fontList.addItem("_typewriter");
		fontList.addItem("arial");
		fontList.addItem("arial_black");
		fontList.addItem("courier_new");
		fontList.addItem("impact");
		fontList.addItem("georgia");
		fontList.addItem("helvetica");
		fontList.addItem("tahoma");
		fontList.addItem("times_new_roman");
		fontList.addItem("verdana");
*/
		var fonts_array:Array;
		if (_useEmbeddedFonts)
			fonts_array = _global.getSilex().config.embeddedFont;
		else
			fonts_array = TextField.getFontList();

		for(var fontIdx:Number=0;fontIdx<fonts_array.length;fontIdx++){
			fontList.addItem(fonts_array[fontIdx]);
		}

		fontListListener = new Object();
		fontListListener.change = Utils.createDelegate(this, fontChange);
		fontListListener.scroll = Utils.createDelegate(this, fontChange);
		fontList.addEventListener("change",fontListListener);
		fontList.addEventListener("scroll",fontListListener);
		//font size
		sizeList.addItem("5");
		sizeList.addItem("6");
		sizeList.addItem("7");
		sizeList.addItem("8");
		sizeList.addItem("9");
		sizeList.addItem("10");
		sizeList.addItem("11");
		sizeList.addItem("12");
		sizeList.addItem("13");
		sizeList.addItem("14");
		sizeList.addItem("15");
		sizeList.addItem("16");
		sizeList.addItem("17");
		sizeList.addItem("18");
		sizeList.addItem("19");
		sizeList.addItem("20");
		sizeList.addItem("21");
		sizeList.addItem("22");
		sizeList.addItem("23");
		sizeList.addItem("24");
		sizeList.addItem("25");
		sizeList.addItem("26");
		sizeList.addItem("27");
		sizeList.addItem("28");
		sizeList.addItem("29");
		sizeList.addItem("30");
		sizeList.addItem("31");
		sizeList.addItem("32");
		sizeList.addItem("33");
		sizeList.addItem("34");
		sizeList.addItem("35");
		sizeList.addItem("36");
		sizeList.addItem("38");
		sizeList.addItem("40");
		sizeList.addItem("42");
		sizeList.addItem("44");
		sizeList.addItem("46");
		sizeList.addItem("48");
		sizeList.addItem("50");
		sizeList.addItem("55");
		sizeList.addItem("60");
		sizeList.addItem("65");
		sizeList.addItem("70");
		sizeList.addItem("72");
		sizeList.addItem("80");
		sizeList.addItem("90");
		sizeList.addItem("100");
		sizeListListener = new Object();
		sizeListListener.change = Utils.createDelegate(this, sizeChange);
		sizeListListener.scroll = Utils.createDelegate(this, sizeChange);
		sizeList.addEventListener("change",sizeListListener);
		sizeList.addEventListener("scroll",sizeListListener);

		//colorpicler
		colorListener = new Object();
		//color picker
/*		colorPicker.color = 0x006699
		// choose where the component will be opened
		colorPicker.direction = ColorPicker.UP_RIGHT
	*/	// register event listener
		colorPicker.addListener(colorListener)
		// when the component change
		colorListener.change = Utils.createDelegate(this, colorChange);
	
		//get selections indices
		this.setSelectionValues()
	}
	function setSize(w:Number,h:Number){
		sizeList.setSize(sizeList.width,h);
		fontList.setSize(fontList.width,h);
	}
	
	
	function leadingChanged(_tf:TextField){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.leading = parseInt(_tf.text);
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
		//refocus();
	}
	var LEADING_DELTA:Number=1;
	function leadingMore(){
        _format = target.getTextFormat(startSelec, endSelec);
		if (!_format.leading) _format.leading=LEADING_DELTA;
        _format.leading += LEADING_DELTA;
        target.setTextFormat(startSelec, endSelec, _format);
		leading_tf.text=_format.leading.toString();
		//Set focus on textfield
		triggerRenew();
		//refocus();
	}
	function leadingLess(){
        _format = target.getTextFormat(startSelec, endSelec);
		if (!_format.leading) _format.leading=LEADING_DELTA;
        _format.leading -= LEADING_DELTA;
        target.setTextFormat(startSelec, endSelec, _format);
		leading_tf.text=_format.leading.toString();
		//Set focus on textfield
		triggerRenew();
		//refocus();
	}
	// ONLY FOR FP 8
	function spacingChanged(_tf:TextField){
        _format = target.getTextFormat(startSelec, endSelec);
        _format["letterSpacing"] = parseInt(_tf.text);
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		//triggerRenew();
		//refocus();
	}
	
/*	With numeric stepper - bug focus
	function leadingChanged(evt_obj:Object){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.leading = evt_obj.target.value;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		//triggerRenew();
		//refocus();
	}
	
	// ONLY FOR FP 8
	function spacingChanged(evt_obj:Object){
        _format = target.getTextFormat(startSelec, endSelec);
        _format["letterSpacing"] = evt_obj.target.value;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		//triggerRenew();
		//refocus();
	}
*/	
	function colorChange(evt_obj:Object){
		var color = '0x'+evt_obj.getRGB()
		toColor (color);
		triggerRenew();
	}
	
	function fontChange(evt_obj:Object){
		var font:String = evt_obj.target.value;
		toFont( font );		
		triggerRenew();
	}
	
	function sizeChange(evt_obj:Object){
		var size:Number = evt_obj.target.value;
		toSize( size );
		triggerRenew();
	}
	
    function toBold(){
		trace("toBold "+target.embedFonts+" - "+_format.font);
		if (_useEmbeddedFonts==true){
			if (!_format.font){
				trace("toBold fails because font is null");
				return;
			}
			if (isBold==false){
				// prevent from being italic ADN bold
				if (isItalic==true) toItalic();
				
				trace("toBold text was not bold");
				toFont(_format.font+"_bold");
			}
			else{
				trace("toBold text was bold");
				var _str:String=_format.font.substring(0,_format.font.lastIndexOf("_bold"));
				toFont(_str);
			}
		}
		else{
		   _format = target.getTextFormat(startSelec, endSelec);
	        _format.bold = !_format.bold;
	        target.setTextFormat(startSelec, endSelec, _format);
			//Set focus on textfield
			triggerRenew();
		}
    } 
	
	
    function toItalic(){
		if (_useEmbeddedFonts==true){
			if (!_format.font){
				trace("toItalic fails because font is null");
				return;
			}
			if (isItalic==false){

				// prevent from being italic ADN bold
				if (isBold==true) toBold();
				
				trace("toItalic text was not Italic");
				toFont(_format.font+"_italic");
			}
			else{
				trace("toItalic text was Italic");
				var _str:String=_format.font.substring(0,_format.font.lastIndexOf("_italic"));
				toFont(_str);
			}
		}
		else{
	        _format = target.getTextFormat(startSelec, endSelec);
	        _format.italic = !_format.italic;
	        target.setTextFormat(startSelec, endSelec, _format);
			//Set focus on textfield
			triggerRenew();
		}
    }
	
	
	function toBlocIndentMore(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.blockIndent += INDENT_STEP_POINTS;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	
	function toBlocIndentLess(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.blockIndent -= INDENT_STEP_POINTS;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	function toIndentMore(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.indent += INDENT_STEP_POINTS;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	
	function toIndentLess(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.indent -= INDENT_STEP_POINTS;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	
	function toBullet(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.bullet = !_format.bullet;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	
    function toUnderline(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.underline = !_format.underline;
		_global.getSilex().utils.trace("org.silex.toolbox.property_editor.TextEditor toUnderline "+this+" - "+target+" - "+startSelec+","+endSelec+","+_format.underline);
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    }
	
	function toAlignLeft(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.align = 'left';
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	
	
	function toAlignCenter(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.align = 'center';
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	
	
	function toAlignRight(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.align = 'right';
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	
	// FLASH 8 ONLY
	function toAlignJustify(){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.align = 'justify';
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
	
	
	
	
    function toColor(n){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.color = n;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    }
	
	
    function toFont(s){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.font = s;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    } 
		
		
    function toSize(n){
        _format = target.getTextFormat(startSelec, endSelec);
        _format.size = n;
        target.setTextFormat(startSelec, endSelec, _format);
		//Set focus on textfield
		triggerRenew();
    }
	

	function resetFormat(){
		trace("resetFormat");
		_format = new TextFormat();
		_format.font = "_sans";
		_format.size = 12;
		_format.align = "left";
		_format.italic = _format.bold = _format.underline = false;
		_format.leading = 2;
		_format.bullet = false;
		_format.blockIndent = _format.indent = _format.leftMargin = _format.rightMargin = 0;
		_format.bullet = false;
		_format.color = 0;
		_format.url = null;
		_format.target = "";
		_format["letterSpacing"] = 0;
		//_format.kerning = false;
		target.setTextFormat(startSelec, endSelec, _format);
/*		tf = new TextFormat();
		tf.font = "_sans";
		tf.size = 12;
		tf.align = "left";
		tf.italic = tf.bold = tf.underline = false;
		tf.leading = 2;
		tf.bullet = false;
		tf.blockIndent = tf.indent = tf.leftMargin = tf.rightMargin = tf.bullet = false;
		tf.color = 0;
		tf.url = null;
		tf.target = 0;
		tf["letterSpacing"] = 0;
		tf.kerning = false;*/
		triggerRenew();
    }
	
	function get format(){
        return _format;
    }
	
	
	function onSetFocus(oldFocus, newFocus){

	   //current
	   currentFocus = newFocus
	   
	   //add listener
	   if (newFocus == target){
			_global.getSilex().utils.trace("org.silex.toolbox.property_editor.TextEditor onSetFocus this ");
            Mouse.addListener(this);
            Key.addListener(this);
			refocus();
			hasFocus=true;
        }
        else{
			hasFocus=false;
			if (oldFocus == target){
				//remove listener
			   Mouse.removeListener(this);
	           Key.removeListener(this);
	        }
		}
    }
	
	function refocus(){
		
		if(startSelec != endSelec){
			Selection.setSelection(startSelec, endSelec);
		}else{
			Selection.setSelection(caretSelec, caretSelec);
		}
	}
	
	
	
	function onMouseUp(){
		this.setSelectionValues();
		//dispatch renew
		//this.triggerRenew();
    }
	
	var onChanged:Function;
	function triggerRenew(){
		// give the focus to target
		Selection.setFocus(target);
        Selection.setSelection(startSelec, endSelec);		
       // this.dispatchEvent({type: "formatRenew", target: this});
	   this.dispatchEvent({type: "change", target: this});
	   if (onChanged) onChanged();
	   trace("called onChanged "+onChanged);
    }
	

	
    function onKeyDown(){
       // keyDownCaret = caret;
    }
	
    function onKeyUp(){
		
        this.setSelectionValues();
        var keyCode = Key.getCode();
        if (keyCode == 39 || keyCode == 37 || keyCode == 38 || keyCode == 40)
        {
           // newFormat = {};
        }
		//dispatch renew
        triggerRenew();
    } 
	
	
    function setSelectionValues(){
		if (hasFocus!=true)
			return;
	
        if (_format.size == 2)
        {
            if (Key.getCode() == 37)
            {
                Selection.setSelection(caretSelec - 2, caretSelec - 2);
            }
            else
            {
                Selection.setSelection(caretSelec + 2, caretSelec + 2);
            }
        }
		//get indexes
        startSelec = Selection.getBeginIndex();
        endSelec = Selection.getEndIndex();
        caretSelec = Selection.getCaretIndex();
		_global.getSilex().utils.trace("org.silex.toolbox.property_editor.TextEditor setSelectionValues "+this+" - "+target+" - "+startSelec+","+endSelec+","+startSelec+" - "+_format.underline);
		
		displayCurrentFont();
    }
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// display font of current selection
	var _isBold:Boolean=false;
	function set isBold(value:Boolean){
		trace("set isBold to "+value);
		_isBold=value;
		//isBold_mc._visible=_isBold;
	}
	function get isBold():Boolean{
		return _isBold;
	}
	////
	var _isItalic:Boolean=false;
	function set isItalic(value:Boolean){
		trace("set isItalic to "+value);
		_isItalic=value;
		//isItalic_mc._visible=_isItalic;
	}
	function get isItalic():Boolean{
		return _isItalic;
	}
	///
	function displayCurrentFont(){
		var idx:Number;
		var _str:String;
		_format=target.getTextFormat(startSelec,endSelec);
		//////////////////////////////////////
		// display font in the font list
		_str=_format.font;
		trace("---------------------------");
		trace(_str+","+_format.size);
		// case bold
		idx=_str.lastIndexOf("_bold");
		if (idx>-1){
			_str=_str.substring(0,idx);
			isBold=true;
		}
		else{
			isBold=false;
		}
		trace("displayCurrentFont bold index : "+idx+" - "+_str);
		// case italic
		idx=_str.lastIndexOf("_italic");
		if (idx>-1){
			_str=_str.substring(0,idx);
			isItalic=true;
		}
		else{
			isItalic=false;
		}
		trace("displayCurrentFont italic index : "+idx+" - "+_str);
		// display corresponding font
		setListSelection(fontList,_str);

		//////////////////////////////////////
		// display font size in the font size list
		setListSelection(sizeList,_format.size);
		
		/////////////////////////////////////
		// steppers
		if (_format["letterSpacing"]!=undefined)
			spacing_tf.text=_format["letterSpacing"].toString();
			//spacing_stp.value=_format["letterSpacing"] ;
		if (_format.leading!=undefined)
			leading_tf.text=_format.leading.toString();
			//leading_stp.value=_format.leading;
	}
	function setListSelection(_lst:List,itemValue):Boolean{
		//if (!itemValue) _lst.selectable=false;
		
		trace("setListSelection "+_lst+" - "+itemValue);
		for (var idx:Number=0;idx<_lst.length;idx++){
			if (_lst.getItemAt(idx).label==itemValue){
				_lst.selectedIndex=idx;
				_lst.vPosition=idx;
				return true;
			}
		}
		_lst.selectedIndex=-1;
		_lst.selectedItem=undefined;
		return false;
	}
}
