﻿/*
???
// update the layout dom (md lex for multi context)
silexInstance.dynDataManager.buildLayoutDom(silexInstance.application.getLayout(this));
*/
/**
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex.sourceforge.net/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
/**
 * Name : Layer.as
 * Package : ui
 * Version : 0.8
 * Date :  2007-08-09
 */

//import org.analogcode.util.JSTextReader;

//import mx.utils.Delegate;
import org.silex.core.Utils;
import mx.events.EventDispatcher;
//players class
//import org.silex.ui.players.*;
import org.silex.core.plugin.HookManager;
import org.silex.ui.LayerHooks;

[Event("playersLoaded")] // thrown when players are loaded
[Event("allPlayersLoaded")] // thrown when players and components are loaded
class org.silex.ui.Layer extends mx.core.UIObject{
	
	//array of players
	var players:Array = null;
	
	var nRegisteredPlayers=0;

	
	//silex instance
	var silexInstance/*:org.silex.core.Api*/ = null;	
	
	/**
	 * name
	 * used by toolbox.Layers
	 * set by core.Layout::registerLayer
	 */
	 var name:String="";
	
	

	/**
	 * function construct
	 * @return void
	 */
	public function Layer(){

		//eventDispatcher
		EventDispatcher.initialize(this);		
		// players
		this.players = new Array();
		//silex instance
		this.silexInstance =_global.getSilex(this);
		//register players
		this.silexInstance.dynDataManager.registerVariable(this, "players","array");
		//initlayer
		initLayer();
		// register layer
		this.silexInstance.application.getLayout(this).registerLayer(this);
		//setEditable all players
		this.setEditable(true);

		// patch for bug input text fields in firefox because of wmode
		//JSTextReader.enableForAllTextFields();
		
	}
	
	/**
	 * initialize players in array players
	 * @return void
	 */
	function initLayer():Void{
		// call hooks
        var hookManager:HookManager = HookManager.getInstance();
		hookManager.callHooks(LayerHooks.INIT_START_HOOK_UID, arguments);
		
		//attachMovie
		var l:Number = players.length;
		if (l > 0)
		{
			//1ast in array is the highest
			for (var i:Number = l-1; i>= 0; i--){
				if (isInContext(players[i])){
					//if not component type
					if(players[i].type != "Component"){
						//get name and type
						this.attachMovie( players[i].type, players[i]._name, this.getNextHighestDepth());
					}else{
						//load component  url
						this.loadComponent(players[i]._name, players[i].mediaUrl  );
					}
				}
				else{
					///////////////////////
					// register this clip as out of context
					silexInstance.dynDataManager.registerClipOutOfContext(this,players[i]._name);
					nRegisteredPlayers++;
				}
			}
		}
		else
		{
			// here there is 0 player in the layer
			// just continue (playersLoaded event)
			silexInstance.sequencer.doInNextFrame(Utils.createDelegate(this,onPlayersLoaded));
			silexInstance.sequencer.doInNextFrame(Utils.createDelegate(this, dispatchEvent), { type: "allPlayersLoaded", target:this } );
			silexInstance.sequencer.doInNextFrame(Utils.createDelegate(silexInstance.application,silexInstance.application.dispatchEvent),{type: "allPlayersLoaded",target:silexInstance.application});
		}
		// hooks
		hookManager.callHooks(LayerHooks.INIT_END_HOOK_UID, null);
	}

	// dejavu : allPlayersLoaded has to be dispatched only one time
	var dejavu:Boolean = false;
	/*
	 * registerPlayer
	 * called by UiBase
	 * called when an error occurred while downloading a component
	 */
	function registerPlayer(player/*:org.silex.ui.UiBase*/) {
		// call hooks
        var hookManager:HookManager = HookManager.getInstance();
		hookManager.callHooks(LayerHooks.REGISTER_PLAYER_START_HOOK_UID, arguments);
		
		nRegisteredPlayers++;
		
		if (!dejavu && nRegisteredPlayers>=players.length){
			dejavu=true;
			// dispatch event
			//dispatchEvent({type: "allPlayersLoaded",target:this});
			// test for bug undefined page
			silexInstance.sequencer.doInNextFrame(Utils.createDelegate(this, dispatchEvent), { type: "allPlayersLoaded", target:this } );
			silexInstance.sequencer.doInNextFrame(Utils.createDelegate(silexInstance.application,silexInstance.application.dispatchEvent),{type: "allPlayersLoaded",target:this});
		}
		// hooks
		hookManager.callHooks(LayerHooks.REGISTER_PLAYER_END_HOOK_UID, null);
	}
	
	// onPlayersLoaded called by initLayer and refresh
	function onPlayersLoaded() {
		// call hooks
        var hookManager:HookManager = HookManager.getInstance();
		hookManager.callHooks(LayerHooks.ALL_PLAYERS_LOADED_START_HOOK_UID, arguments);

		// silexInstance.utils.trace('ui.Layer onPlayersLoaded '+silexInstance.application);
		dispatchEvent({type: "playersLoaded",target:this});
		silexInstance.application.dispatchEvent({type: "playersLoaded",target:this});
		// hooks
		hookManager.callHooks(LayerHooks.ALL_PLAYERS_LOADED_END_HOOK_UID, null);
	}
	
	public function addFramedLocation(_str:String)
	{
		//date to avoid name collision
		var my_date:Date = new Date();
		var	aleaNumber:Number = Math.round(my_date.getTime());
		//add alea to media name
		var playerInstanceName = 'asframe_' + aleaNumber;
		// add frame
		addFramedMedia({location:_str,name_str:'asframe'},playerInstanceName);
	}
	public function addFramedEmbededObject(_str:String)
	{
		//date to avoid name collision
		var my_date:Date = new Date();
		var	aleaNumber:Number = Math.round(my_date.getTime());
		//add alea to media name
		var playerInstanceName = 'asframe_' + aleaNumber;
		// add frame
		addFramedMedia({embededObject:_str,name_str:'asframe'},playerInstanceName);
	}
	public function addFramedHtmlText(_str:String)
	{
		//date to avoid name collision
		var my_date:Date = new Date();
		var	aleaNumber:Number = Math.round(my_date.getTime());
		//add alea to media name
		var playerInstanceName = 'asframe_' + aleaNumber;
		// add frame
		addFramedMedia({htmlText:_str,name_str:'asframe'},playerInstanceName);
	}
	public function addFramedMedia(initObj:Object,playerInstanceName:String)
	{
		silexInstance.utils.trace ('ui.Layer addFramedMedia');
		//instanciate player
		var player = this.attachMovie('AsFrame','AsFrame_'+ playerInstanceName , this.getNextHighestDepth(),initObj);
		//stock infos in object
		var oPlayer:Object = {_name:player._name, type:"AsFrame"};
		//seteditable
		player.main.setEditable(true);
		player.isEditable = true;

		//add to players in first position
		players.unshift(oPlayer);
	}

	/**
	 * Add media 
	 * @param 	string	   	media
	 * @return 	boolean 	true if the player is instancied
	 */
	public function addMedia(mediaUrl:String){
		//trace
		silexInstance.utils.trace('ui.Layer addMedia '+mediaUrl);
		// new object in the players array
		var oPlayer:Object;
		//date to avoid name collision
		var my_date:Date = new Date();
		var	aleaNumber:Number = Math.round(my_date.getTime());
		//add alea to media name
		var playerInstanceName = this.getBaseName(mediaUrl) + '_'+aleaNumber;
		//get media name
		var playerName:String = getDisplayName(mediaUrl);		
		var player;

		// set layout as dirty
		silexInstance.application.getLayout(this).isDirty=true;

		//if
		if( mediaUrl != null ){			
			//component extension
			if( isComponent(mediaUrl) ){
				//component drag
				silexInstance.utils.trace('ui.Layer addMedia component mediaUrl '+ mediaUrl);
				//exception component playername 
				playerInstanceName = 'Cmp_' + this.getBaseNameComponent(mediaUrl) + '_'+aleaNumber;
				//load component
				var contener:MovieClip = this.loadComponent(playerInstanceName, mediaUrl+"?name_str="+playerName );					
				//stock infos in object
				oPlayer = {_name:  playerInstanceName, type:"Component", mediaUrl: mediaUrl};
				//add to players in first position
				players.unshift(oPlayer);
				//return player
				return contener;
			}
			else{
				//get extension
				var ext:String = this.getExtension(mediaUrl);
				//trace
				//silexInstance.utils.trace('ui.layers extension '+ ext);
				//select right player
				switch(ext){				
						
					case 'mp3':
						silexInstance.utils.trace('ui.Layer addMedia - Audio player')
						//instanciate player
						player = this.attachMovie('Audio','Audio_'+ playerInstanceName , this.getNextHighestDepth(),{name_str: playerName, media_str: mediaUrl});
						//stock infos in object
						oPlayer = {_name:player._name, type:"Audio" };
						break;
						
					case 'flv':
						silexInstance.utils.trace('ui.Layer addMedia - video player ')
						//instanciate player
						player = this.attachMovie('Video','Video_'+ playerInstanceName , this.getNextHighestDepth(),{name_str: playerName, media_str: mediaUrl});
						//stock infos in object
						oPlayer = {_name:player._name, type:"Video" };
						break;
						
					case 'gif':
					case 'png':
					case 'jpg':
					case 'swf':
						silexInstance.utils.trace ('ui.Layer addMedia - Image player');
						//instanciate player
						player = this.attachMovie('Image','Image_'+ playerInstanceName , this.getNextHighestDepth(),{name_str: playerName, media_str: mediaUrl});
						//stock infos in object
						oPlayer = {_name:player._name, type:"Image"};
						break;
				}
			}
		}else{
			player = this.attachMovie('Text','Text_'+ playerInstanceName, this.getNextHighestDepth(),{name_str: 'Text'}) ;
			//stock infos in object
			oPlayer = {_name:player._name, type:"Text" };
		}
		//silexInstance.utils.trace('ui.Layer addMedia will call setEditable '+player+" - "+player.main+" - "+player.main.setEditable);
		//seteditable
		player.main.setEditable(true);
		player.isEditable = true;
		//add to players in first position
		players.unshift(oPlayer);
		
		//return
		return player;
	}
	
		
	/*
	 * loadComponent
	 * 
	 * @param MovieClip
	 * @param String
	 * @return Boolean
	 */	 
	 function loadComponent( componentName:String, componentUrl:String){
		//movieclip loader
    	var loaderComponent_mcl:MovieClipLoader = new MovieClipLoader();
		
		var listenerLoader_obj:Object = new Object();
		
		//error
		listenerLoader_obj.onLoadError = Utils.createDelegate(this, componentDownloadError);
		/*		
		listenerLoader_obj.onLoadInit = function (cible_mc:MovieClip){
			silexInstance.utils.trace('ui.Layer loadComponent onLoadInit '+ cible_mc );
		}
		*/				
		
		//create movieClip container
		var contener:MovieClip = this.createEmptyMovieClip( componentName , this.getNextHighestDepth() );		
/*		//add Listener
		loaderComponent_mcl.addListener(listenerLoader_obj);
		//load component in contener
		loaderComponent_mcl.loadClip(componentUrl, contener);
*/
		// 
		silexInstance.utils.loadMedia(componentUrl,contener,listenerLoader_obj);
		//Return cotener
		return contener;	
	 }
	function componentDownloadError(cible_mc:MovieClip, errorCode_str:String, HTTPStatus_str:Number)
	{
		silexInstance.utils.trace('ui.Layer loadComponent onLoadError ' + errorCode_str + '  httpstatus : ' + HTTPStatus_str);
		registerPlayer();
	}
	 
	 
	 /**
	 * isComponent
	 * @param 	sring		   	file url
	 * @return 	Boolean 			return Boolean
	 */
	 private function isComponent(url:String ):Boolean{
		
		var ext:String =  url.substr( url.lastIndexOf(".")-3, url.length);	
		//silexInstance.utils.trace('ui.Layer isComponent ext = '+ext);
		if(ext.toLowerCase() == 'cmp.swf'){
			return true;
		}
		return false;
	 }
	 
	
	/**
	 * Get file extension
	 * @param 	sring		   	file url
	 * @return 	string 			return extension
	 */
	private function getExtension( url:String ):String{
		//return extension form last '.'
		var ext:String =  url.substr( url.lastIndexOf(".")+1, url.length);	
		return ext.toLowerCase();
	}
	
	
	
	/**
	 * getName
	 * @param 	sring		   	media name
	 * @return 	string 			return name
	 */
	private function getDisplayName( url:String ):String{
		//return extension form last '/'
		var mediaName:String =  url.substr( url.lastIndexOf("/") + 1, url.length);	
		if (!mediaName || mediaName == "") mediaName = "new media";

		silexInstance.utils.trace('ui.Layer loadComponent getDisplayName ' + url + '  -> ' + mediaName);
		return mediaName;
	}
	
	
	/**
	 * getBaseName
	 * @param 	sring		   	media name
	 * @return 	string 			return name
	 */
	private function getBaseName( url:String ):String{
		//return extension form last '/'
		var mediaName:String =  url.substr( url.lastIndexOf("/") + 1, url.length);	
		if (!mediaName || mediaName == "") mediaName = "new_media";
		else
		{
			//delete  .ext
			mediaName =  mediaName.substring( 0, mediaName.length - 4);
		}
		
		silexInstance.utils.trace('ui.Layer loadComponent getBaseName ' + url + '  -> ' + mediaName.toLowerCase());
		return mediaName.toLowerCase();
	}
	
	
	/**
	 * getComponentBaseName
	 * @param 	sring		   	media name
	 * @return 	string 			return name
	 */
	private function getBaseNameComponent( url:String ):String{
		//return extension form last '/'
		var mediaName:String =  url.substr( url.lastIndexOf("/") + 1, url.length);	
		if (!mediaName || mediaName == "") mediaName = "new_media";
		else
		{
			//delete .cmp + .ext 
			mediaName =  mediaName.substring( 0, mediaName.length - 8);			
		}
		return mediaName.toLowerCase();
	}
	
		
	/**
	 * TODO : Improve sort algorithme
	 * refresh players array
	 * change z order if needed
	 * @return 	void 			return extension
	 */
	public function refresh():Void{
		// call hooks
        var hookManager:HookManager = HookManager.getInstance();
		hookManager.callHooks(LayerHooks.REFRESH_START_HOOK_UID, arguments);
		
		//players length
		var l:Number = players.length;
		for (var i:Number = l-1; i >= 0; i-- ){
			//player object
			var playerObj:Object = players[i];
			//player instance
			var player:MovieClip =  this[players[i]._name];
			silexInstance.utils.trace('ui.Layer refresh -  player '+ player)
			//if on scene
			if(player != undefined){
				if (isInContext(playerObj)){
					//silexInstance.utils.trace('ui.Layer refresh - player is in context :' + playerObj._name)
					//change z order
					player.swapDepths( this.getNextHighestDepth());	
				}
				else{
					//silexInstance.utils.trace('ui.Layer refresh - player is NOT in context anymore :' + playerObj._name)

					// register this clip as out of context
					silexInstance.dynDataManager.registerClipOutOfContext(this,players[i]._name);

					// remove player
					player.main.unloadMedia();
					player.removeMovieClip();
				}
			}else{
				//silexInstance.utils.trace('ui.Layer refresh -  type :' + playerObj.type)
				if (isInContext(playerObj)){
					// silexInstance.utils.trace('ui.Layer refresh - player is in context :' + playerObj._name)

					// register this clip as out of context
					silexInstance.dynDataManager.unRegisterClipOutOfContext(this,players[i]._name);

					//attach player
					if(playerObj.type != "Component"){
						//get name and type
						this.attachMovie( playerObj.type, playerObj._name, this.getNextHighestDepth());
					}else{
						//load component 
						this.loadComponent(playerObj._name, playerObj.mediaUrl  );
					}
				}
				else{
					// do not create player
					// silexInstance.utils.trace('ui.Layer refresh - player is NOT in context :' + playerObj._name)
				}
			}
			
		}
		// dispatch event on next frame
		//silexInstance.sequencer.addItem(null,mx.utils.Utils.createDelegate(this,onPlayersLoaded));
		silexInstance.sequencer.doInNextFrame(Utils.createDelegate(this,onPlayersLoaded));
		// hooks
		hookManager.callHooks(LayerHooks.REFRESH_END_HOOK_UID, null);
	}

	/**
	 * setEditable
	 * cahnge setEditable for each player in the layer
	 * @param  Boolean
	 * @return Void
	 */
	public function setEditable(allowEdit:Boolean):Void{
		//silexInstance.utils.trace('ui.Layer setEditable ' + allowEdit);
		if (allowEdit == undefined) return;
		//players length
		var l:Number = players.length;
		for (var i:Number = l-1; i >= 0; i-- ){
			//player instance
			var player:MovieClip =  this[players[i]._name];	
			
			//silexInstance.utils.trace('ui.Layer setEditable player ' + players[i]._name+" - "+this[players[i]._name]+" - "+player.main.setEditable);
			//setEdidable
			player.main.setEditable(allowEdit);
			
		}
	}
	function isInContext(player_obj:Object):Boolean{
		if (player_obj.contextAccepted==undefined){
			player_obj.contextAccepted=new Array("*");
			// silexInstance.utils.trace('ui.Layer isInContext player had no context data : ' + player_obj._name)
			return true;
		}
/*		if (player_obj.contextRejected==undefined){
			player_obj.contextRejected=new Array;
			silexInstance.utils.trace('ui.Layer isInContext player had no context data : ' + player_obj._name)
			return true;
		}*/
		// if the player contextAccepted array is included in global context but not the contextRejected
		// silexInstance.utils.trace('ui.Layer isInContext ' + player_obj._name+" - "+player_obj.contextAccepted+"("+player_obj.contextAccepted.length+") -- "+silexInstance.config.globalContext.split(",")+" - "+silexInstance.utils.isPartOf+" - "+silexInstance.utils.isPartOf(player_obj.contextAccepted,silexInstance.config.globalContext.split(",")))
		
		for (var idx:Number=0;idx<player_obj.contextAccepted.length;idx++){
			// silexInstance.utils.trace('ui.Layer isInContext check ' + player_obj.contextAccepted[idx].split(",")+" -- "+silexInstance.config.globalContext.split(","));
			if (silexInstance.utils.isPartOf(player_obj.contextAccepted[idx].split(","),silexInstance.config.globalContext.split(","))==true){
				return true;
			}
		}
		return false;
	}
}