﻿import org.silex.core.Utils;

import org.silex.ui.components.ComponentAnimated;

class org.silex.ui.components.ComponentAnimatedPhoto extends ComponentAnimated {

	
	var loaderMedia_mcl:MovieClipLoader;
	var listenerLoader_obj:Object;
	
	var cible_photo:MovieClip;
	
	
	/**
	 * constructor
	 */
	function ComponentAnimatedPhoto(){
		
	}
	
	
	/**
	 * initialize
	 */	
	function _initialize() {
		//parent
		super._initialize()		
		//trace
		silexInstance.utils.trace('ui.components.ComponentAnimatedPhoto _initialize ')

		//change value in clip if different path
		cible_photo = contener_mc.cible_photo;
		
		//movieClip Loader
		this.loaderMedia_mcl = new MovieClipLoader();
		this.listenerLoader_obj = new Object();
		//listener events		
		this.listenerLoader_obj.onLoadStart = Utils.createDelegate(this, _onLoadStart);
		this.listenerLoader_obj.onLoadProgress 	= Utils.createDelegate(this, _onLoadProgress);
		this.listenerLoader_obj.onLoadComplete 	= Utils.createDelegate(this, _onLoadComplete);
		this.listenerLoader_obj.onLoadInit		= Utils.createDelegate(this, _onLoadInit);
		this.listenerLoader_obj.onLoadError 	= Utils.createDelegate(this, _onLoadError);		
		//add Listener
		this.loaderMedia_mcl.addListener(this.listenerLoader_obj);					
	}
	
	
	
	
	/**
	 * function _onLoadStart
	 * @param	MovieClip   cible
	 * @return 	void
	 */
	function _onLoadStart(cible_mc:MovieClip):Void{
		//dispatch
		this.dispatch({type: silexInstance.config.UI_PLAYERS_EVENT_LOAD_START ,target:this});
		//trace
		silexInstance.utils.trace('ui.components.ComponentAnimatedPhoto _onLoadStart ')
	}
	
	/**
	 * function _onLoadProgress
	 * @param	MovieClip	cible
	 * @param	Number		bytes loaded
	 * @param	Number		total bytes to load
	 * @return 	void
	 */
	function _onLoadProgress (cible_mc:MovieClip, nBytesLoaded:Number, nBytesTotal:Number):Void{
		//dispatch
		this.dispatch({type: silexInstance.config.UI_PLAYERS_EVENT_LOAD_PROGRESS ,target:this, loaded:nBytesLoaded, total:nBytesTotal });
		//trace
		silexInstance.utils.trace('ui.components.ComponentAnimatedPhoto _onLoadProgress ')
	}
	
	/**
	 * function _onLoadStart
	 * @param	MovieClip   cible
	 * @return 	void
	 */
	function _onLoadComplete (cible_mc:MovieClip):Void {	
		//dispatch
		this.dispatch({type: silexInstance.config.UI_PLAYERS_EVENT_LOAD_COMPLETE ,target:this});
		//trace
		silexInstance.utils.trace('ui.components.ComponentAnimatedPhoto _onLoadComplete ')
	}		
		
	function _onLoadInit (cible_mc:MovieClip):Void  {	 
		//dispatch
		this.dispatch({type: silexInstance.config.UI_PLAYERS_EVENT_LOAD_INIT ,target:this});
		//dimensions
		if (!__width) __width=		cible_mc._width;
		if (!__height) __height=	cible_mc._height;
		//cible dimensions
		cible_mc._width=__width;
		cible_mc._height=__height;
		//refresh position
		redraw();
		//trace
		silexInstance.utils.trace('ui.components.ComponentAnimatedPhoto _onLoadInit ')
	}
	
	
	/**
	 * function _onLoadError
	 * @param	MovieClip   cible
	 * @param	String		error code
	 * @param	Number		http status
	 * @return 	void
	 */
 	function _onLoadError (cible_mc:MovieClip,errorCode_str:String, HTTPStatus_str:Number):Void{
		//dispatch
		this.dispatch({type: silexInstance.config.UI_PLAYERS_EVENT_LOAD_ERROR ,target:this, error:errorCode_str, status:HTTPStatus_str });
		//trace
		silexInstance.utils.trace('ui.components.ComponentAnimatedPhoto _onLoadError ')
	}
	
	
	
	
	/**
	 * function loadmedia
	 * @param 	string	media url 
	 * @return 	void
	 */
	public function loadMedia(url_str:String):Void{
		//stock url
		this.url = url_str; // => setter will call doLoadMedia (see UiBase)
		silexInstance.utils.trace('ui.components.ComponentAnimatedPhoto - loadMedia: '+ url_str)
	}
	
	function doLoadMedia() {
		silexInstance.utils.trace('ui.components.ComponentAnimatedPhoto - doLoadMedia url: '+ silexInstance.config.initialFtpFolderPath+silexInstance.config.websiteFtpRelativeUrl+this.privateUrl_str)
		//appel MoviClipLoader
		this.loaderMedia_mcl.loadClip(silexInstance.rootUrl+this.privateUrl_str, cible_photo);
	}

	/**
	 * function unloadMedia
	 * @return 	void
	 */
	public function unloadMedia():Void {
		this.loaderMedia_mcl.unloadClip( cible_photo);
	}
	
}