﻿import org.silex.core.Utils;
/**
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2017 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/

/**
 *
 * Name : AsFramePlayer.as
 * Package : org.silex.ui.players
 * Version : 1
 * Date :  2007-08-03
 * Author : lex@silex.tv
 */
class org.silex.ui.players.AsFramePlayer extends org.silex.ui.players.PlayerBase
{
	/**
	 * frame component
	 */
	var asframe:org.lexayo.asframe.AsFrameBase;
	/**
	 * ref to UI
	 */
	var asframeUi:MovieClip;

	// __width and __height are used to store width an height while media may not be loaded yet
	var __width:Number;
	var __height:Number;
	
	/**
	 * function initialize
	 * @return void
	 */
	private function _initialize():Void{
		super._initialize();
			
		//availableEvents
/*		this.availableEvents.push(
			{modifier:"onLoadStart", 	description : "on Load Start"},
        );
*/
		//editableProperties
		this.editableProperties.push(
			{ name :"scale" , 			description:silexInstance.config.PROPERTIES_LABEL_SCALE, 				type: silexInstance.config.PROPERTIES_TYPE_NUMBER		, defaultValue: ""	, isRegistered: false	, minValue:+1,  	maxValue:+100, group:"attributes" },
			{ name :"width" ,			description:silexInstance.config.PROPERTIES_LABEL_WIDTH, 				type: silexInstance.config.PROPERTIES_TYPE_NUMBER		, defaultValue: undefined	, isRegistered:true 	, minValue:-5000,  	maxValue:+5000, group:"attributes" },
			{ name :"height" , 			description:silexInstance.config.PROPERTIES_LABEL_HEIGHT, 				type: silexInstance.config.PROPERTIES_TYPE_NUMBER 		, defaultValue: undefined	, isRegistered:true 	, minValue:-5000,  	maxValue:+5000, group:"attributes" },
			{ name :"htmlText" , 			description:silexInstance.config.PROPERTIES_LABEL_FRAME_WIDGET_HTML_TEXT, 				type: silexInstance.config.PROPERTIES_TYPE_TEXT 		, defaultValue: this.playerContainer.htmlText	, isRegistered:true 	, group:"attributes" },
			{ name :"embededObject" ,	description:silexInstance.config.PROPERTIES_LABEL_FRAME_SWF_AS3, 				type: silexInstance.config.PROPERTIES_TYPE_URL 		, defaultValue: this.playerContainer.embededObject	, isRegistered:true 	, group:"attributes" },
			{ name :"location" , 			description:silexInstance.config.PROPERTIES_LABEL_FRAME_HTML_LOCATION, 				type: silexInstance.config.PROPERTIES_TYPE_URL 		, defaultValue: this.playerContainer.location	, isRegistered:true 	, group:"attributes" },
			{ name :"backgroundVisible" , 			description:silexInstance.config.PROPERTIES_LABEL_FRAME_IS_BACKGROUND_VISIBLE, 				type: silexInstance.config.PROPERTIES_TYPE_BOOLEAN 		, defaultValue: true	, isRegistered:true , group:"attributes" }
		);	
	}
	/**
	 * function set/get width
	 * @param 	Number		
	 * @return  void|Number
	 */
	function set width( intValue:Number):Void
	{
		//layerInstance.registerPlayer(this);		
		//_parent._parent._parent._parent._visible = true;
		asframe._width = intValue;
		__width = intValue;
		redraw();
	}

	
	function get width ():Number{
		return __width;
	}
	
	/**
	 * function set/get height
	 * @param 	Number		
	 * @return  void|Number
	 */
	function set height( intValue:Number):Void
	{
		asframe._height = intValue;
		__height= intValue;
		redraw();
	}
	
	function get height ():Number{
		return __height;
	}
	
	
	/**
	 * set/get scale
	 * @param 	Number		
	 * @return  void|Number
	 */
	function set scale( numValue:Number):Void{
		asframe._xscale = numValue;
		asframe._yscale = numValue;
		width = asframe._width 
		height = asframe._height
		//refresh
		redraw()
	}
	
	function get scale():Number{
		return Math.round((asframe._xscale + asframe._yscale)/2);
	}
	
	/**
	 * function loadmedia
	 * @param 	string	media url 
	 * @return 	void
	 */
	public function loadMedia(url_str:String):Void{
	}
	
	/**
	 * function unloadMedia
	 * @return 	void
	 */
	public function unloadMedia():Void {
		embededObject = "";
		location = "";
		htmlText = "";
	}
	/**
	 * set/get isEditable
	 * @param 	Boolean		moderation or not
	 * @return  void|Boolean
	 */ 
	public function set isEditable(allowEdit:Boolean)
	{
		super.isEditable = allowEdit;
		if (allowEdit)
		{
			// attach UI
			attachAsFrameUi();
		}
		else
		{
			// remove UI
			removeAsFrameUi();
		}
	}
	function attachAsFrameUi() 
	{
		if (!asframeUi)
		{
			asframeUi = this.attachMovie("AsFrameUi", "asframeUi", getNextHighestDepth());
			asframeUi.drag_btn.onRelease = asframeUi.drag_btn.onReleaseOutside = Utils.createDelegate(this,stopDragAsFrameUi);
			asframeUi.drag_btn.onPress = Utils.createDelegate(this, startDragAsFrameUi);
			asframeUi.minimize_btn.onRelease = Utils.createDelegate(this, minimizeCallback);
			redraw();
		}
	}
	function minimizeCallback() 
	{
		asframe.isFrameVisible = !asframe.isFrameVisible;
	}
	function stopDragAsFrameUi() 
	{
		this.stopDrag();
	}
	function startDragAsFrameUi() 
	{
		this.startDrag();
	}
	function removeAsFrameUi() 
	{
		if (asframeUi)
		{
			asframeUi.drag_btn.onRelease = asframeUi.drag_btn.onReleaseOutside = undefined;
			asframeUi.drag_btn.onPress = undefined;
			asframeUi.removeMovieClip();
		}
		asframeUi = undefined;
	}
	function redraw(b:Boolean)
	{
		super.redraw(b);
		asframe.redraw(b);
		if (asframeUi)
		{
			asframeUi._x = asframe._x;
			asframeUi._y = asframe._y;
		}
	}
	
	// ------------------------------------------
	// proxy
	// ------------------------------------------
	private var _location:String;
	function get location():String
	{
		return _location;
	}
	function set location(val:String) 
	{
		_location = val;
		asframe.location = silexInstance.utils.revealAccessors(val,this);
	}
	private var _htmlText:String;
	function get htmlText():String
	{
		return _htmlText;
	}
	function set htmlText(val:String) 
	{
		_htmlText = val;
		asframe.htmlText = silexInstance.utils.revealAccessors(val,this);
	}
	private var _embededObject:String;
	function get embededObject():String
	{
		return _embededObject;
	}
	function set embededObject(val:String) 
	{
		_embededObject = val;
		asframe.embededObject = silexInstance.utils.revealAccessors(val,this);
	}
	function get backgroundVisible():Boolean
	{
		return asframe.backgroundVisible;
	}
	function set backgroundVisible(val:Boolean) 
	{
		asframe.backgroundVisible = val;
	}
	
	// **
	// override PlayerBase class :
	function getGlobalCoordTL(){
		// from global coords
		var coordTL:Object={x:asframe._x,y:asframe._y};
	
		// to global
		this.localToGlobal(coordTL);
		
		return coordTL;
	}
	
	function getGlobalCoordBR(){
		// from global coords
		var coordBR:Object={x:asframe._width+asframe._x,y:asframe._height+asframe._y};
	
		// to global
		this.localToGlobal(coordBR);
		
		//trace("left:"+coordTL.x+",right:"+coordBR.x+",top:"+coordTL.y+",bottom:"+coordBR.y);
		return coordBR;
	}
	
	
	// **
	// override PlayerBase class :
	// setGlobalCoordTL sets coordinates of the media
	// it substracts the registration point coords to coord
	// and apply the new coordinates to the player
	function setGlobalCoordTL(coord:Object){
		// back to local
		//this.layerInstance.globalToLocal(coord);
		_parent.globalToLocal(coord);
			
		// apply the new coordinates to the player
		_x=coord.x;
		_y=coord.y;
	}
	function setGlobalCoordBR(coord:Object){
		// back to local
		_parent.globalToLocal(coord);
				
		// apply the new coordinates to the player
		width = coord.x - _x;
		height = coord.y - _y;
	}
	
	

	/* getSeoData
	 * return the seo data to be associated with this player
	 * to be overriden in derived class :
	 * @return	object with text (string), tags (array), description (string), links (object with link, title and description), htmlEquivalent (string), context (array)
	 */
	 function getSeoData(url_str:String):Object {
		var res_obj:Object = super.getSeoData();
		var htmlContent:String = "";
		
		// html location 
		if (location != "")
		{
			var objTL:Object = getGlobalCoordTL();
			var objBR:Object = getGlobalCoordBR();
			res_obj.htmlEquivalent = '<iframe src="' + location + '" style="background-color:transparent; border-width:0" height="' + (objBR.y - objTL.y) + '" width="' + objBR.x - objTL.x + '"></iframe>';
		}
		// htmlText 
		if (htmlText && htmlText != "")
		{
			if (!res_obj.text) res_obj.text = "";
			res_obj.text += " "+htmlText;
		}
		
		return res_obj;
	}
}
