﻿import org.silex.ui.players.PlayerBase;
import org.silex.core.Utils;

[Event("onSoundComplete")]
[Event("soundPlay")]
[Event("soundPause")]
[Event("soundStop")]
[Event("soundId3")]
[Event("soundLoaded")]

class org.silex.ui.players.Audio extends PlayerBase {

	//dimensions
	var __width:Number;
	var __height:Number;
	var nav_sound:MovieClip;
	var contener_mc:MovieClip;

	//sound
	var soundObject;
	var sndClip:MovieClip;
	var _volume:Number;
	var _savePosition:Number;
	var isMuted_bool:Boolean;
	var _autoPlay_bool:Boolean;
	var isPlaying_bool:Boolean;
	var isPlayInit_bool:Boolean;
	var _loop_bool:Boolean;
	var _showNav_bool:Boolean;
	//Set intervat for time
	var time_interval:Number;
	//url
	var privateUrl_str:String = null;


	function Audio() {
		//create contener global
		this.createEmptyMovieClip("contener_mc",this.getNextHighestDepth());
		//contener image
		contener_mc.createEmptyMovieClip("contenerVide_mc",contener_mc.getNextHighestDepth());
		//nav
		nav_sound = this.attachMovie("nav_sound", "nav_sound", this.getNextHighestDepth());
	}
	function _initialize() {
		super._initialize();



		//available contextmenu
		this.availableContextMenuMethods.push(
			{fct:"changeScale", description:"100% scale", param:100}
		);
		//availableEvents
		this.availableEvents.push(
			{modifier:silexInstance.config.UI_PLAYERS_EVENT_SOUND_LOADED, 		description : "on sound loaded"},
			{modifier:silexInstance.config.UI_PLAYERS_EVENT_SOUND_COMPLETE,		description : "on sound complete"},
			{modifier:silexInstance.config.UI_PLAYERS_EVENT_SOUND_ID3, 			description : "on sound id3"},
			{modifier:silexInstance.config.UI_PLAYERS_EVENT_SOUND_PLAY, 		description : "on sound play"},		
			{modifier:silexInstance.config.UI_PLAYERS_EVENT_SOUND_PAUSE, 		description : "on sound pause"},		
			{modifier:silexInstance.config.UI_PLAYERS_EVENT_SOUND_STOP, 		description : "on sound stop"}		
        );
		//availableMethods
		this.availableMethods.push(
			{modifier:"PLAY", 		description : "play sound"	, parameters: new Array()},
			{modifier:"PAUSE",		description : "pause sound"	, parameters: new Array()},
			{modifier:"STOP", 		description : "stop sound"	, parameters: new Array()},
			{modifier:"MUTE", 		description : "mute sound"	, parameters: new Array()},
			{modifier:"UNMUTE", 	description : "unmute sound", parameters: new Array()}
        );

		//editableProperties first position
		this.editableProperties.unshift(
				{name:"width", 				description:silexInstance.config.PROPERTIES_LABEL_WIDTH, 		type:silexInstance.config.PROPERTIES_TYPE_NUMBER, defaultValue:"", isRegistered:true, minValue:-5000, maxValue:+5000, group:"attributes"},
				{name:"height",				description:silexInstance.config.PROPERTIES_LABEL_HEIGHT, 		type:silexInstance.config.PROPERTIES_TYPE_NUMBER, defaultValue:"", isRegistered:true, minValue:-5000, maxValue:+5000, group:"attributes"},
				{name:"autoPlay", 			description:silexInstance.config.PROPERTIES_LABEL_AUTOPLAY, 		type:silexInstance.config.PROPERTIES_TYPE_BOOLEAN, defaultValue:false, isRegistered:true, group:"parameters"},
				{name:"loop", 				description:silexInstance.config.PROPERTIES_LABEL_AUTOREPLAY, 	type:silexInstance.config.PROPERTIES_TYPE_BOOLEAN, defaultValue:false, isRegistered:true, group:"parameters"},
				{name:"showNavigation", 	description:silexInstance.config.PROPERTIES_LABEL_SHOW_UI,  type:silexInstance.config.PROPERTIES_TYPE_BOOLEAN, defaultValue:true, isRegistered:true, group:"parameters"},
				{name:"mute", 				description:silexInstance.config.PROPERTIES_LABEL_IS_MUTED, 			type:silexInstance.config.PROPERTIES_TYPE_BOOLEAN, defaultValue:false, isRegistered:true, group:"parameters"},
				{name:"volume", 			description:silexInstance.config.PROPERTIES_LABEL_VOLUME_LEVEL, 			type:silexInstance.config.PROPERTIES_TYPE_NUMBER, defaultValue:50, isRegistered:true, minValue:+1, maxValue:+100, group:"parameters"}
		);
		//push end
		this.editableProperties.push({name:"useHandCursor", description:silexInstance.config.PROPERTIES_LABEL_SHOW_HAND_ON_ROLLOVER, type:silexInstance.config.PROPERTIES_TYPE_BOOLEAN, defaultValue:false, isRegistered:true, group:"attributes"});


		contener_mc.onRollOver = Utils.createDelegate(this, _onRollOver);
		contener_mc.onRollOut = Utils.createDelegate(this, _onRollOut);
		contener_mc.onRelease = Utils.createDelegate(this, _onRelease);
		contener_mc.onPress = Utils.createDelegate(this, _onPress);
		/*
		nav_sound.onRollOver = Utils.createDelegate(this, _onRollOver);
		nav_sound.onRollOut = Utils.createDelegate(this, _onRollOut);
		nav_sound.onRelease = Utils.createDelegate(this, _onRelease);
		nav_sound.onPress = Utils.createDelegate(this, _onPress);*/
		
		// UI init
		nav_sound.mute_btn._visible = false;
		nav_sound.unmute_btn._visible = false;
		//event
		nav_sound.play_btn.onRelease = Utils.createDelegate(this, playMedia);
		nav_sound.pause_btn.onRelease = Utils.createDelegate(this, pauseMedia);
		nav_sound.stop_btn.onRelease = Utils.createDelegate(this, stopMedia);
		// sound
		nav_sound.mute_btn.onRelease = Utils.createDelegate(this, muteMedia);
		nav_sound.unmute_btn.onRelease = Utils.createDelegate(this, unmuteMedia);


		//sound
		soundObject = new Sound();
		soundObject.id3 = Utils.createDelegate(this, _onId3);
		soundObject.onLoad = Utils.createDelegate(this, _onLoaded);
		soundObject.onSoundComplete = Utils.createDelegate(this, _onSoundComplete);
		_soundbuftime = 6;


		//init
		isPlaying_bool = false;
		isPlayInit_bool = false;
		_savePosition = 0;
	}
	/**
	 * function redraw
	 * @return void
	 */
	function redraw() {
		//usehandcursor
		if (!useHandCursor) {
			contener_mc.useHandCursor = false;
		} else {
			contener_mc.useHandCursor = true;
		}
		//show nav
		if (showNavigation) {
			nav_sound._visible = true;
		} else {
			nav_sound._visible = false;
		}
		//Adjust navigation position ( bottom left)
		nav_sound._x = 0;
		nav_sound._y = height;
		//sound
		if (mute) {
			//hide mute btn
			nav_sound.mute_btn._visible = false;
			nav_sound.unmute_btn._visible = true;
		} else {
			//hide unmute btn
			nav_sound.mute_btn._visible = true;
			nav_sound.unmute_btn._visible = false;
		}
		//nav
		if (isPlaying_bool) {
			nav_sound.play_btn._visible = false;
			nav_sound.pause_btn._visible = true;
		} else {
			nav_sound.play_btn._visible = true;
			nav_sound.pause_btn._visible = false;
		}
	}
	/**
	 * set/get rotation
	 * @param Numbershow/hide
	 * @return  void|Number
	 */
	public function set rotation(rotationNumber:Number):Void {
		this.contener_mc._rotation = rotationNumber;
		//refresh
		redraw();
	}
	public function get rotation():Number {
		return this.contener_mc._rotation;
	}
	/**
	 * function set/get width
	 * @param Number
	 * @return  void|Number
	 */
	function set width(intValue:Number):Void {
		contener_mc._width = intValue;
		__width = intValue;
		//refresh
		redraw();
	}
	function get width():Number {
		return __width;
	}
	/**
	 * function set/get height
	 * @param Number
	 * @return  void|Number
	 */
	function set height(intValue:Number):Void {
		contener_mc._height = intValue;
		__height = intValue;
		//refresh
		redraw();
	}
	function get height():Number {
		return __height;
	}
	/**
	 * set/get mute
	 * @param Boolean
	 * @return  void|Boolean
	 */
	function set mute(mute_bool:Boolean):Void {
		if (mute_bool) {
			muteMedia();
		} else {
			unmuteMedia();
		}
		redraw();
	}
	function get mute():Boolean {
		//stock voulme
		return this.isMuted_bool;
	}
	/**
	 * muteMedia 
	 * @return  void
	 */
	function muteMedia():Void {
		//set vol 0
		setMediaVolume(0);
		//mute
		this.isMuted_bool = true;
		//redraw
		redraw();
	}
	/**
	 * unmuteMedia 
	 * @return  void//
	 */
	function unmuteMedia():Void {
		//set volume to volume stocked
		setMediaVolume(volume);
		//mute
		this.isMuted_bool = false;
		//redraw
		redraw();
	}
	/**
	 * setMediaVolume
	 */
	function setMediaVolume(vol:Number):Void {
		soundObject.setVolume(vol);
	}
	/**
	 * set/get volume 
	 * @param Number
	 * @return  void|Number
	 */
	function set volume(vol_int:Number):Void {
		//stock voulme
		this._volume = vol_int;
		//change volume
		soundObject.setVolume(this._volume);
	}
	function get volume():Number {
		//stock voulme
		return this._volume;
	}

	/**
	 * set/get autoPlay 
	 * @param Boolean
	 * @return  void|Boolean
	 */
	function set autoPlay(auto_bool:Boolean):Void {
		//stock voulme
		this._autoPlay_bool = auto_bool;
	}
	function get autoPlay():Boolean {
		//stock voulme
		return this._autoPlay_bool;
	}
	/**
	 * set/get loop
	 * @param Boolean
	 * @return  void|Boolean
	 */
	function set loop(auto_bool:Boolean):Void {
		//stock voulme
		this._loop_bool = auto_bool;
	}
	function get loop():Boolean {
		//stock voulme
		return this._loop_bool;
	}
	/**
	 * set/get showNavigation
	 * @param Boolean
	 * @return  void|Boolean
	 */
	function set showNavigation(auto_bool:Boolean):Void {
		//stock voulme
		this._showNav_bool = auto_bool;
		//show nav_video
		redraw();
	}
	function get showNavigation():Boolean {
		//stock voulme
		return this._showNav_bool;
	}
	/**
	 * set/get url 
	 * @param String
	 * @return  void|Number
	 */
	function get url():String {
		return privateUrl_str;
	}
	function set url(url_str:String):Void {
		//reinitialize 
		isPlayInit_bool = false;
		privateUrl_str = url_str;
		doLoadMedia(privateUrl_str);

	}
	/**
	 * play media
	 */
	function playMedia():Void {
		//not yet initialized
		if (!isPlayInit_bool) {
			isPlayInit_bool = true;
			_savePosition = 0;
			//load song in streaming
			//var url:String = silexInstance.config.websiteFtpRelativeUrl;
			// build url
			var url_str:String;
			if (privateUrl_str.indexOf("http")==0 || privateUrl_str.indexOf("file")==0)
				url_str = privateUrl_str
			else
				url_str = silexInstance.rootUrl + privateUrl_str;			

			silexInstance.utils.trace('ui.Player.Audio  - playMedia - ' + url_str )
			soundObject.loadSound( url_str,true);
			isPlaying_bool = true;
			////todo : display loading ??
			redraw();
		} else {
			//fct pauseMedia
			pauseMedia();
		}
	}
	
	/**
	 * pause media
	 */
	function pauseMedia():Void {
		//if pause
		if (isPlaying_bool) {
			isPlaying_bool = false;
			//stop
			soundObject.stop();
			_savePosition = soundObject.position;
			//event
			this.dispatch({target:this, type:silexInstance.config.UI_PLAYERS_EVENT_SOUND_PAUSE});
		} else {
			//start
			soundObject.start(_savePosition);
			isPlaying_bool = true;
			//event
			this.dispatch({target:this, type:silexInstance.config.UI_PLAYERS_EVENT_SOUND_PLAY});
		}
		//redraw
		redraw();

	}
	
	/**
	 * stop media
	 */
	function stopMedia():Void {
		//retour debut
		isPlaying_bool = false;
		soundObject.stop();
		_savePosition = 0;
		//redraw
		redraw();
		//event
		this.dispatch({target:this, type:silexInstance.config.UI_PLAYERS_EVENT_SOUND_STOP});
	}
	
	
	/** 
	 * wrappers functions
	 **/
	function STOP(){
		stopMedia();
	}
	
	function PAUSE(){
		pauseMedia();
	}
	
	function PLAY(){
		playMedia();
	}
	
	function MUTE(){
		muteMedia();
	}
	
	function UNMUTE(){
		unmuteMedia();
	}
	
	
	
	/* song loaded*/
	function _onLoaded() {
		//todo : hide loading ????
		//playMedia();
		soundObject.start();
		redraw();
		//event
		this.dispatch({target:this, type:silexInstance.config.UI_PLAYERS_EVENT_SOUND_LOADED});
		//trace
		silexInstance.utils.trace('ui.players.sound  _onLoaded');
	}
	
	/* song compelte */
	function _onSoundComplete() {
		_savePosition = 0;
		isPlaying_bool = false;
		if (loop) {
			playMedia();
		}
		silexInstance.utils.trace('ui.players.sound  _onSoundComplete');
		//event
		this.dispatch({target:this, type:silexInstance.config.UI_PLAYERS_EVENT_SOUND_COMPLETE});
	}

	/* infos */
	function _onId3(obj) {
		//prop
		/*for (var prop in obj.id3) {
			silexInstance.utils.trace(prop+": "+obj.id3[prop]);
		}*/
		silexInstance.utils.trace('ui.players.sound _onId3 => dispatch event');
		//event
		this.dispatch({target:this, type:silexInstance.config.UI_PLAYERS_EVENT_SOUND_ID3});

	}
	
	
	
	
	//displaytime insterval
	function displayTime(interval) {
		//position
		if (soundObject.position != undefined) {
			nav_sound.playTime.text = Math.round(soundObject.position);
		} else {
			nav_sound.playTime.text = 0;
		}
		//duration
		nav_sound.totalTime.text = Math.round(soundObject.duration);
	}
	/**
	 * function _onPress
	 * @param stringmedia url 
	 * @return void
	 */
	public function loadMedia(url_str:String):Void {
		//stock url
		this.url = url_str;// => setter will call doLoadMedia
	}
	
	
	function doLoadMedia() {
		//time
		time_interval = setInterval(this, "displayTime", 500);
		//play video
		if (autoPlay) {
			//playmedia if autoplay
			playMedia();
		} else {
			//msg ?
		}
	}
	/**
	 * function unloadMedia
	 * @return void
	 */
	public function unloadMedia():Void {
		clearInterval(time_interval);
		soundObject.stop();
	}
	// **
	// override PlayerBase class :
	// setGlobalCoordTL sets coordinates of the media
	// it substracts the registration point coords to coord
	// and apply the new coordinates to the player
	function setGlobalCoordTL(coord:Object) {
		// to local
		this.layerInstance.globalToLocal(coord);

		// apply the new coordinates to the player
		_x = coord.x;
		_y = coord.y;
	}
	function setGlobalCoordBR(coord:Object) {
		// to local
		this.layerInstance.globalToLocal(coord);
		// get width and height
		coord.x = coord.x-_x;
		coord.y = coord.y-_y;

		// apply the new coordinates to the player
		width = coord.x;
		height = coord.y;
	}
	function getGlobalCoordTL() {
		// from global coords
		var coordTL:Object = {x:_x, y:_y};

		// to global
		this.layerInstance.localToGlobal(coordTL);

		return coordTL;
	}
	function getGlobalCoordBR() {
		// from global coords
		var coordBR:Object = {x:width+_x, y:height+_y};

		// to global
		this.layerInstance.localToGlobal(coordBR);

		//trace("left:"+coordTL.x+",right:"+coordBR.x+",top:"+coordTL.y+",bottom:"+coordBR.y);
		return coordBR;
	}

	/* getSeoData
	 * return the seo data to be associated with this player
	 * to be overriden in derived class :
	 * @return	object with text (string), tags (array), description (string), links (object with link, title and description), htmlEquivalent (string), context (array)
	 */
	 function getSeoData(url_str:String):Object {
		var res_obj:Object=super.getSeoData();
		
		// html equivalent
/*		if (descriptionText)
			res_obj.htmlEquivalent="<a href='"+url_str+privateUrl_str+"'>"+descriptionText+"</a>";
		else
			res_obj.htmlEquivalent="<a href='"+url_str+privateUrl_str+"'>"+url_str+privateUrl_str+"</a>";
*/		
		res_obj.htmlEquivalent = '<object type="audio/mpeg" data="'+url_str+privateUrl_str+'" width="200" height="20">';
		res_obj.htmlEquivalent += '<param name="src" value="'+url_str+privateUrl_str+'"><param name="autoplay" value="false"><param name="autoStart" value="0">';
		if (descriptionText)
			res_obj.htmlEquivalent += "alt : <a href='" + url_str + privateUrl_str + "'>" + descriptionText + "</a>";
		else
			res_obj.htmlEquivalent += "alt : <a href='" + url_str + privateUrl_str + "'>" + privateUrl_str + "</a>";			
		res_obj.htmlEquivalent += '</object>';

		return res_obj;
	}
	/*	//override PlayerBase method
	function getHtmlTags(url_str:String):Object {
		var res_obj:Object = new Object();
		res_obj.keywords = descriptionText;
		res_obj.description = descriptionText;
		res_obj.context = getUiContext();
		//html 
		var htmlContent = '<a href="';
		htmlContent += url_str+silexInstance.config.initialFtpFolderPath+silexInstance.config.websiteFtpRelativeUrl+this.privateUrl_str;
		htmlContent +='">';
		if (descriptionText)
			htmlContent += descriptionText;
		else
			htmlContent += this.privateUrl_str;

		htmlContent += '</a>';
		//assign
		res_obj.htmlEquivalent = htmlContent;
		return res_obj;
	}
*/}